-- ****************************************
-- **           AI_Editor.lua            **
-- **                                    **
-- ** Copyright (c) 2017 SpinalSoft (AU) **
-- ****************************************
sky.include "SkyQt.lua"
sky.include "generic_functions.lua"

thisEditor = "AI_Editor"

bActNew = false
bEvalNew = false
bBTNew = false
bBTSub = false
bDTNew = false
bDTSub = false
bFSMStateNew = false
bFSMTransNew = false
bAct = false
bEval = false
bBT = false
bDT = false
bFSMState = false
bFSMTrans = false
bInit = true
bActions = false
bEvaluators = false
bBehaviour = false
bDecision = false
bFinite = false

txtFileName = ""

tblActions = { }
tblEvaluators = { }
tblBT = { }
tblDT = { }
tblFSMState = { }
tblFSMTrans = { }
tblTmp = { }
tblJSON = { }

iCancel = 0
iDelete = 0
sFSMInit = 0
treeActionID = -1
treeEvalID = -1
treeBehaviourID = -1
treeDecisionID = -1
treeStateID = -1
treeTransID = -1
iDialog = 0

-- iDialog:
--		1 = Name Already Exists			Center ONLY
--		2 = Save First?					Center & Right
--		3 = Invalid File				Center ONLY
--		4 = Overwrite?					Center & Right
--		5 = Invalid File Name			Center ONLY
--		6 = Errors in AI				Center ONLY
--		7 = Errors in BT				Center ONLY
--		8 = Errors in DT				Center ONLY
--		9 = Errors in FSM				Center ONLY
--		10 = Errors in Actions			Center ONLY
--		11 = Errors in Evaluators		Center ONLY
--		12 = Invalid Character			Center ONLY
--		13 = Can't Delete Root Item		Center ONLY
--		14 = BT Successful				Center ONLY
--		15 = DT Successful				Center ONLY
--		16 = Delete State				Center & Right
--		17 = FSM Successful				Center ONLY
--		18 = 1 Action / 1 Evaluator		Center ONLY

function main ( )
	setActionDefaults ( )
	setEvaluatorDefaults ( )
	setBTDefaults ( )
	setDTDefaults ( )
	setFSMStateDefaults ( )
	bInit = false

	disableMenu ( )
end

function disableMenu ( )
--[[
TODO:
bActions = false
bEvaluators = false
bBehaviour = false
bDecision = false
bFinite = false
DISABLE actionSave
DISABLE actionSave_As
DISABLE actionCreate_Actions
DISABLE actionCreate_Evaluators
DISABLE actionCreate_Behaviour_Tree
DISABLE actionCreate_Decision_Tree
DISABLE actionCreate_FSM
DISABLE actionCreate_All
]]

end

function btnDlgRight ( )
	qt.closeEditor ( thisEditor, "Dialog" )

	if ( iDialog == 2 ) then
		setActionDefaults ( )
		setEvaluatorDefaults ( )
		setBTDefaults ( )
		setDTDefaults ( )
		setFSMStateDefaults ( )

		txtFileName = ""
		qt.setCurrentIndex ( thisEditor, "tabWidget", 0 )
		qt.setFocus ( thisEditor, "txtActionName" )

		disableMenu ( )
	elseif ( iDialog == 4 ) then
		-- DO NOTHING
	elseif ( iDialog == 16 ) then
		-- DO NOTHING
	end
end

function btnDlgCenter ( )
	qt.closeEditor ( thisEditor, "Dialog" )

	if ( iDialog == 2 ) then
		actionSave_Overwrite ( )
		setActionDefaults ( )
		setEvaluatorDefaults ( )
		setBTDefaults ( )
		setDTDefaults ( )
		setFSMStateDefaults ( )
		txtFileName = ""
		qt.setFocus ( thisEditor, "txtActionName" )

		disableMenu ( )
	elseif ( iDialog == 4 ) then
		actionSave_Overwrite ( )
	elseif ( iDialog == 16 ) then
		btnDelState ( )
	end
end

-- ****************
-- ** ACTION TAB **
-- ****************
function btnActionNew ( )
	checkStatus ( )
	checkStatus ( )
	bActNew = true
	bAct = false

	qt.setEnabled ( thisEditor, "txtActionName" )
	qt.setEnabled ( thisEditor, "btnActionCxl" )

	qt.setText ( thisEditor, "txtActionName", "NAME of ACTION (A-z, 0-9 & _ ONLY!)" )
	qt.setText ( thisEditor, "txtActionMsg", "**Press 'Enter' in the NAME field to enable the FUNCTION fields. ***" )

	qt.setDisabled ( thisEditor, "txtInitFn" )
	qt.setDisabled ( thisEditor, "txtUpdFn" )
	qt.setDisabled ( thisEditor, "txtClnFn" )
	qt.setDisabled ( thisEditor, "tblAction" )
	qt.setDisabled ( thisEditor, "btnActionNew" )
	qt.setDisabled ( thisEditor, "btnActionEdit" )
	qt.setDisabled ( thisEditor, "btnActionDel" )
	qt.setDisabled ( thisEditor, "btnActionSave" )

	qt.setFocus ( thisEditor, "txtActionName" )
end

function btnActionEdit ( )
	bActNew = false
	bAct = false

	qt.setEnabled ( thisEditor, "txtActionName" )
	qt.setEnabled ( thisEditor, "btnActionCxl" )

	qt.setText ( thisEditor, "txtActionMsg", "**Press 'Enter' in the NAME field to enable the FUNCTION fields. ***" )

	qt.setDisabled ( thisEditor, "txtInitFn" )
	qt.setDisabled ( thisEditor, "txtUpdFn" )
	qt.setDisabled ( thisEditor, "txtClnFn" )
	qt.setDisabled ( thisEditor, "tblAction" )
	qt.setDisabled ( thisEditor, "btnActionNew" )
	qt.setDisabled ( thisEditor, "btnActionEdit" )
	qt.setDisabled ( thisEditor, "btnActionDel" )
	qt.setDisabled ( thisEditor, "btnActionSave" )
end

function btnActionDel ( )
	local iCount = 0
	local iTmp = 1

	for x = 2, getTableLength ( tblActions ), 7 do
		if ( tblActions[x] == treeActionID ) then
			iCount = x
			break
		end
	end

	table.remove ( tblActions, iCount + 5 )
	table.remove ( tblActions, iCount + 4 )
	table.remove ( tblActions, iCount + 3 )
	table.remove ( tblActions, iCount + 2 )
	table.remove ( tblActions, iCount + 1 )
	table.remove ( tblActions, iCount )
	table.remove ( tblActions, iCount - 1 )

	treeActionID = treeActionID - 1

	if ( treeActionID < 1 ) then
		treeActionID = 1
	end

	if ( getTableLength ( tblActions ) > 0 ) then
		populateActions ( )
	else
		setActionDefaults ( )
--[[
TODO:
bActions = false
DISABLE actionCreate_Actions
DISABLE actionCreate_All
]]

	end
end

function btnActionCxl ( )
	checkStatus ( )
	if ( getTableLength ( tblActions ) > 0 ) then
		populateActions ( )
	else
		setActionDefaults ( )
	end
end

function btnActionSave ( )
	checkStatus ( )
	local bFound = false
	local iTmp = 0
	local tmpParentID = 0
	local tmpTxt = ""
	local txtName = ""
	local txtFn = ""
	local txtInit = qt.getText ( thisEditor, "txtInitFn" )
	local txtUpd = qt.getText ( thisEditor, "txtUpdFn" )
	local txtCln = qt.getText ( thisEditor, "txtClnFn" )

	if ( not bActNew ) then
		txtName = qt.getTreeItemText ( thisEditor, "tblAction", treeActionID, 0 )
	else
		txtName = qt.getTreeItemText ( thisEditor, "tblAction", 1, 0 )

		local idTable = qt.getAllTreeIDs ( thisEditor, "tblAction")

		for k, v in pairs ( idTable ) do
			iTmp = v
		end

		treeActionID = iTmp
	end

	tmpTxt = qt.getText ( thisEditor, "txtActionName" )
	txtFn = "ACT_" .. tmpTxt .. "Action ( objID )"

	if ( txtName == "Dummy" ) then
		tblActions = { }
		treeActionID = 1
		table.insert ( tblActions, tmpParentID )
		table.insert ( tblActions, 1 )
		table.insert ( tblActions, tmpTxt )
		table.insert ( tblActions, txtFn )
		table.insert ( tblActions, txtInit )
		table.insert ( tblActions, txtUpd )
		table.insert ( tblActions, txtCln )
	else
		if ( not bActNew ) then
			for x = 3, getTableLength ( tblActions ), 7 do
				if ( txtName == tblActions[x] ) then
					tblActions[x] = tmpTxt
					tblActions[x + 1] = txtFn
					tblActions[x + 2] = txtInit
					tblActions[x + 3] = txtUpd
					tblActions[x + 4] = txtCln
					bFound = true
					break
				end
			end
		end

		if ( bActNew or not bFound ) then
			table.insert ( tblActions, tmpParentID )
			table.insert ( tblActions, treeActionID )
			table.insert ( tblActions, tmpTxt )
			table.insert ( tblActions, txtFn )
			table.insert ( tblActions, txtInit )
			table.insert ( tblActions, txtUpd )
			table.insert ( tblActions, txtCln )
		end
	end

	sortActions ( )
	populateActions ( )
--[[
TODO:
bActions = true
ENABLE actionSave
ENABLE actionSave_As
ENABLE actionCreate_Actions
]]
end

function txtActionName_Return ( txtInput )
	checkStatus ( )
	local txtTmp = ""
	local txtTmp1 = ""
	local txtTmp2 = ""
	local txtInit = ""
	local txtUpd = ""
	local txtCln = ""
	local bRet = false
	local iInit = 0
	local iEnd = 0
	local iTmp = 0

	txtInput = qt.getText ( thisEditor, "txtActionName" )
	bRet = checkTextInput ( txtInput )

	if ( bRet ) then
		if ( not bActNew ) then
			txtTmp = qt.getText ( thisEditor, "txtInitFn" )
			iInit, iTmp = string.find ( txtTmp, "act_" )
			iInit, iEnd = string.find ( txtTmp, " ", iTmp )

			txtTmp1 = string.sub ( txtTmp, 1, iTmp )
			txtTmp2 = string.sub ( txtTmp, iEnd )
			txtInit = txtTmp1 .. txtInput .. "Initialize" .. txtTmp2

			txtTmp = qt.getText ( thisEditor, "txtUpdFn" )
			iInit, iTmp = string.find ( txtTmp, "act_" )
			iInit, iEnd = string.find ( txtTmp, " ", iTmp )

			txtTmp1 = string.sub ( txtTmp, 1, iTmp )
			txtTmp2 = string.sub ( txtTmp, iEnd )
			txtUpd = txtTmp1 .. txtInput .. "Update" .. txtTmp2

			txtTmp = qt.getText ( thisEditor, "txtUpdFn" )
			iInit, iTmp = string.find ( txtTmp, "act_" )
			iInit, iEnd = string.find ( txtTmp, " ", iTmp )

			txtTmp1 = string.sub ( txtTmp, 1, iTmp )
			txtTmp2 = string.sub ( txtTmp, iEnd )
			txtCln = txtTmp1 .. txtInput .. "CleanUp" .. txtTmp2

			qt.setEnabled ( thisEditor, "txtInitFn" )
			qt.setEnabled ( thisEditor, "txtUpdFn" )
			qt.setEnabled ( thisEditor, "txtClnFn" )
			qt.setEnabled ( thisEditor, "btnActionCxl" )
			qt.setEnabled ( thisEditor, "btnActionSave" )

			qt.setText ( thisEditor, "txtActionMsg", "" )
		else
			if ( checkName ( "A", txtInput ) ) then
				qt.setEnabled ( thisEditor, "txtInitFn" )
				qt.setEnabled ( thisEditor, "txtUpdFn" )
				qt.setEnabled ( thisEditor, "txtClnFn" )
				qt.setEnabled ( thisEditor, "btnActionCxl" )
				qt.setEnabled ( thisEditor, "btnActionSave" )

				qt.setText ( thisEditor, "txtActionMsg", "" )

				txtInit = "local act_" .. txtInput .. "Initialize = function ( objID )\n\treturn \"TERMINATED\"\nend"
				txtUpd = "local act_" .. txtInput .. "Update = function ( objID )\n\treturn \"TERMINATED\"\nend"
				txtCln = "local act_" .. txtInput .. "CleanUp = function ( objID )\n\nend"
			else
				iDialog = 1
				showDialog ( 3, "Sorry, but you have entered a NAME for the ACTION that already exists!\n\nPlease enter a different NAME and try again." )
				qt.setFocus ( thisEditor, "txtActionName" )
			end
		end

		qt.setText ( thisEditor, "txtInitFn", txtInit )
		qt.setText ( thisEditor, "txtUpdFn", txtUpd )
		qt.setText ( thisEditor, "txtClnFn", txtCln )
	else
		iDialog = 12
		showDialog ( 3, "Sorry, but you have used an INVALID Character in the NAME of the ACTION!\n\nThe available characters are A-z, 0-9 & _ ONLY!\n\nPlease try again." )
		qt.setFocus ( thisEditor, "txtActionName" )
	end
end

function tblAction_Clicked ( itemText, treeID, column )
	checkStatus ( )
	treeActionID = treeID
	local txtName = ""
	local txtFn = ""
	local txtInit = ""
	local txtUpd = ""
	local txtCln = ""
	local iCount = 0

	txtName = qt.getTreeItemText ( thisEditor, "tblAction", treeActionID, 0 )

	for x = 3, getTableLength ( tblActions ), 7 do
		if ( txtName == tblActions[x] ) then
			txtFn = tblActions[x + 1]
			txtInit = tblActions[x + 2]
			txtUpd = tblActions[x + 3]
			txtCln = tblActions[x + 4]
			break
		end
	end

	qt.setText ( thisEditor, "txtActionName", txtName )
	qt.setText ( thisEditor, "txtInitFn", txtInit )
	qt.setText ( thisEditor, "txtUpdFn", txtUpd )
	qt.setText ( thisEditor, "txtClnFn", txtCln )

	qt.setEnabled ( thisEditor, "tblAction" )
	qt.setEnabled ( thisEditor, "btnActionNew" )
	qt.setEnabled ( thisEditor, "btnActionEdit" )
	qt.setEnabled ( thisEditor, "btnActionDel" )

	bAct = true

	qt.setDisabled ( thisEditor, "txtActionName" )
	qt.setDisabled ( thisEditor, "txtInitFn" )
	qt.setDisabled ( thisEditor, "txtUpdFn" )
	qt.setDisabled ( thisEditor, "txtClnFn" )
	qt.setDisabled ( thisEditor, "btnActionCxl" )
	qt.setDisabled ( thisEditor, "btnActionSave" )
end

-- *******************
-- ** EVALUATOR TAB **
-- *******************
function txtEvalName_Return ( txtInput )
	checkStatus ( )
	local txtTmp = ""
	local txtTmp1 = ""
	local txtTmp2 = ""
	local txtCode = ""
	local bRet = false
	local iInit = 0
	local iEnd = 0
	local iTmp = 0

	txtInput = qt.getText ( thisEditor, "txtEvalName" )
	bRet = checkTextInput ( txtInput )

	if ( bRet ) then
		if ( not bEvalNew ) then
			txtTmp = qt.getText ( thisEditor, "txtEvalCode" )
			iInit, iTmp = string.find ( txtTmp, "Evaluators_" )
			iInit, iEnd = string.find ( txtTmp, " ", iTmp )

			txtTmp1 = string.sub ( txtTmp, 1, iTmp )
			txtTmp2 = string.sub ( txtTmp, iEnd )
			txtCode = txtTmp1 .. firstToUpper ( txtInput ) .. txtTmp2

			qt.setEnabled ( thisEditor, "txtEvalCode" )
			qt.setEnabled ( thisEditor, "btnEvalCxl" )
			qt.setEnabled ( thisEditor, "btnEvalSave" )

			qt.setText ( thisEditor, "txtEvalMsg", "" )
		else
			if ( checkName ( "E", txtInput ) ) then
				qt.setEnabled ( thisEditor, "txtEvalCode" )
				qt.setEnabled ( thisEditor, "btnEvalCxl" )
				qt.setEnabled ( thisEditor, "btnEvalSave" )

				qt.setText ( thisEditor, "txtEvalMsg", "" )

				txtCode = firstToUpper ( txtInput )
				txtCode = "function Evaluators_" .. txtCode .. " ( objID )\n\t-- CODE GOES HERE\n\n\treturn false\nend"
			else
				iDialog = 1
				showDialog ( 3, "Sorry, but you have entered a NAME for the EVALUATOR that already exists!\n\nPlease enter a different NAME and try again." )
				qt.setFocus ( thisEditor, "txtEvalName" )
			end
		end

		qt.setText ( thisEditor, "txtEvalCode", txtCode )
	else
		iDialog = 12
		showDialog ( 3, "Sorry, but you have used an INVALID Character in the NAME of the EVALUATOR!\n\nThe available characters are A-z, 0-9 & _ ONLY!\n\nPlease try again." )
		qt.setFocus ( thisEditor, "txtEvalName" )
	end
end

function tblEval_Clicked ( itemText, treeID, column )
	checkStatus ( )
	treeEvalID = treeID
	local txtName = ""
	local txtFn = ""
	local txtCode = ""
	local iCount = 0

	txtName = qt.getTreeItemText ( thisEditor, "tblEval", treeEvalID, 0 )

	for x = 3, getTableLength ( tblEvaluators ), 5 do
		if ( tblEvaluators[x] == txtName ) then
			txtFn = tblEvaluators[x + 1]
			txtCode = tblEvaluators[x + 2]
			break
		end
	end

	qt.setText ( thisEditor, "txtEvalName", txtName )
	qt.setText ( thisEditor, "txtEvalCode", txtCode )

	qt.setEnabled ( thisEditor, "tblEval" )
	qt.setEnabled ( thisEditor, "btnEvalNew" )
	qt.setEnabled ( thisEditor, "btnEvalEdit" )
	qt.setEnabled ( thisEditor, "btnEvalDel" )

	bEval = true

	qt.setDisabled ( thisEditor, "txtEvalName" )
	qt.setDisabled ( thisEditor, "txtEvalCode" )
	qt.setDisabled ( thisEditor, "btnEvalCxl" )
	qt.setDisabled ( thisEditor, "btnEvalSave" )
end

function btnEvalNew ( )
	checkStatus ( )
	bEvalNew = true
	bEval = false

	qt.setEnabled ( thisEditor, "txtEvalName" )
	qt.setEnabled ( thisEditor, "btnEvalCxl" )

	qt.setText ( thisEditor, "txtEvalName", "NAME of EVALUATOR (A-z, 0-9 & _ ONLY!)" )
	qt.setText ( thisEditor, "txtEvalMsg", "**Press 'Enter' in the NAME field to enable the FUNCTION fields. ***" )

	qt.setDisabled ( thisEditor, "txtEvalCode" )
	qt.setDisabled ( thisEditor, "tblEval" )
	qt.setDisabled ( thisEditor, "btnEvalNew" )
	qt.setDisabled ( thisEditor, "btnEvalEdit" )
	qt.setDisabled ( thisEditor, "btnEvalDel" )
	qt.setDisabled ( thisEditor, "btnEvalSave" )

	qt.setFocus ( thisEditor, "txtEvalName" )
end

function btnEvalEdit ( )
	checkStatus ( )
	bEvalNew = false
	bEval = false

	qt.setEnabled ( thisEditor, "txtEvalName" )
	qt.setEnabled ( thisEditor, "btnEvalCxl" )

	qt.setText ( thisEditor, "txtEvalMsg", "**Press 'Enter' in the NAME field to enable the CODE field. ***" )

	qt.setDisabled ( thisEditor, "tblEval" )
	qt.setDisabled ( thisEditor, "txtEvalCode" )
	qt.setDisabled ( thisEditor, "btnEvalNew" )
	qt.setDisabled ( thisEditor, "btnEvalEdit" )
	qt.setDisabled ( thisEditor, "btnEvalDel" )
	qt.setDisabled ( thisEditor, "btnEvalSave" )
end

function btnEvalDel ( )
	checkStatus ( )
	local iTmp = 1
	local iCount = 0

	for x = 2, getTableLength ( tblEvaluators ), 5 do
		if ( tblEvaluators[x] == treeEvalID ) then
			iCount = x
			break
		end
	end

	table.remove ( tblEvaluators, iCount + 3 )
	table.remove ( tblEvaluators, iCount + 2 )
	table.remove ( tblEvaluators, iCount + 1 )
	table.remove ( tblEvaluators, iCount )
	table.remove ( tblEvaluators, iCount - 1 )

	treeEvalID = treeEvalID - 1

	if ( treeEvalID < 1 ) then
		treeEvalID = 1
	end

	if ( getTableLength ( tblEvaluators ) > 0 ) then
		populateEvaluators ( )
	else
		setEvaluatorDefaults ( )
--[[
TODO:
bEvaluators = false
DISABLE actionCreate_Evaluators
DISABLE actionCreate_All
]]
	end
end

function btnEvalCxl ( )
	checkStatus ( )
	if ( getTableLength ( tblEvaluators ) > 0 ) then
		populateEvaluators ( )
	else
		setEvaluatorDefaults ( )
	end
end

function btnEvalSave ( )
	checkStatus ( )
	local bFound = false
	local iTmp = 0
	local tmpParentID = 0
	local tmpTxt = ""
	local txtName = ""
	local txtFn = ""
	local txtCode = qt.getText ( thisEditor, "txtEvalCode" )

	if ( not bEvalNew ) then
		txtName = qt.getTreeItemText ( thisEditor, "tblEval", treeEvalID, 0 )
	else
		txtName = qt.getTreeItemText ( thisEditor, "tblEval", 1, 0 )

		local idTable = qt.getAllTreeIDs ( thisEditor, "tblEval")

		for k, v in pairs ( idTable ) do
			iTmp = v
		end

		treeEvalID = iTmp
	end

	tmpTxt = qt.getText ( thisEditor, "txtEvalName" )
	txtFn = "Evaluator_" .. tmpTxt .. " ( objID )"

	if ( txtName == "Dummy" ) then
		tblEvaluators = { }
		treeEvalID = 1
		table.insert ( tblEvaluators, tmpParentID )
		table.insert ( tblEvaluators, treeEvalID )
		table.insert ( tblEvaluators, tmpTxt )
		table.insert ( tblEvaluators, txtFn )
		table.insert ( tblEvaluators, txtCode )
	else

		if ( not bEvalNew ) then
			for x = 3, getTableLength ( tblEvaluators ), 5 do
				if ( txtName == tblEvaluators[x] ) then
					tblEvaluators[x] = tmpTxt
					tblEvaluators[x + 1] = txtFn
					tblEvaluators[x + 2] = txtCode
					bFound = true
					break
				end
			end
		end

		if ( bEvalNew or not bFound ) then
			table.insert ( tblEvaluators, tmpParentID )
			table.insert ( tblEvaluators, treeEvalID )
			table.insert ( tblEvaluators, tmpTxt )
			table.insert ( tblEvaluators, txtFn )
			table.insert ( tblEvaluators, txtCode )
		end
	end

	sortEvaluators ( )
	populateEvaluators ( )
--[[
TODO:
bEvaluators = true
ENABLE actionSave
ENABLE actionSave_As
ENABLE actionCreate_Evaluators
]]
end

-- ************************
-- ** BEHAVIOUR TREE TAB **
-- ************************
function btnBTNewItem ( )
	checkStatus ( )
	bBTNew = true
	bBTSub = false
	bBT = false

	qt.setEnabled ( thisEditor, "cboBTType" )
	qt.setEnabled ( thisEditor, "btnBTCxl" )
	qt.setEnabled ( thisEditor, "btnBTSave" )
	qt.setEnabled ( thisEditor, "cboBTDetail" )

	qt.setCurrentIndex ( thisEditor, "cboBTType", 0 )

	populateComboActions ( "cboBTDetail" )

	qt.setDisabled ( thisEditor, "treeBehaviour" )
	qt.setDisabled ( thisEditor, "btnBTNewItem" )
	qt.setDisabled ( thisEditor, "btnBTNewSubItem" )
	qt.setDisabled ( thisEditor, "btnBTDelItem" )
	qt.setDisabled ( thisEditor, "btnBTEdit" )
	qt.setDisabled ( thisEditor, "btnBTCheck" )
end

function btnBTNewSubItem ( )
	checkStatus ( )
	btnBTNewItem ( )
	bBTNew = false
	bBTSub = true
end

function btnBTEdit ( )
	checkStatus ( )
	bBTNew = false
	bBTSub = false
	bBT = false

	qt.setEnabled ( thisEditor, "cboBTType" )
	qt.setEnabled ( thisEditor, "btnBTCxl" )
	qt.setEnabled ( thisEditor, "btnBTSave" )

	local tmpTxt = qt.getTreeItemText ( thisEditor, "treeBehaviour", treeBehaviourID, 0 )
	local tmpTxt2 = qt.getTreeItemText ( thisEditor, "treeBehaviour", treeBehaviourID, 1 )

	if ( tmpTxt == "Action" ) then
		populateComboActions ( "cboBTDetail" )
		qt.setCurrentIndex ( thisEditor, "cboBTType", 0 )
		qt.setEnabled ( thisEditor, "cboBTDetail" )
		setActionComboIdx ( "cboBTDetail", tmpTxt2 )
	elseif ( tmpTxt == "Evaluator" ) then
		populateComboEvals ( "cboBTDetail" )
		qt.setCurrentIndex ( thisEditor, "cboBTType", 1 )
		qt.setEnabled ( thisEditor, "cboBTDetail" )
		setEvalComboIdx ( "cboBTDetail", tmpTxt2 )
	elseif ( tmpTxt == "Selector" ) then
		populateComboNA ( "cboBTDetail" )
		qt.setDisabled ( thisEditor, "cboBTDetail" )
		qt.setCurrentIndex ( thisEditor, "cboBTType", 2 )
	elseif ( tmpTxt == "Sequence" ) then
		populateComboNA ( "cboBTDetail" )
		qt.setDisabled ( thisEditor, "cboBTDetail" )
		qt.setCurrentIndex ( thisEditor, "cboBTType", 3 )
	end

	qt.setDisabled ( thisEditor, "treeBehaviour" )
	qt.setDisabled ( thisEditor, "btnBTNewItem" )
	qt.setDisabled ( thisEditor, "btnBTNewSubItem" )
	qt.setDisabled ( thisEditor, "btnBTEdit" )
	qt.setDisabled ( thisEditor, "btnBTDelItem" )
	qt.setDisabled ( thisEditor, "btnBTCheck" )
end

function btnBTDelItem ( )
	checkStatus ( )
	local tmpTxt = qt.getTreeItemText ( thisEditor, "treeBehaviour", treeBehaviourID, 0 )
	local iCount = 0
	local iTmp = 1

	if ( tmpTxt ~= "Behaviour" ) then
		for x = 2, getTableLength ( tblBT ), 4 do
			if ( tonumber ( tblBT[x] ) == treeBehaviourID ) then
				iCount = x
				break
			end
		end

		table.remove ( tblBT, iCount + 2 )
		table.remove ( tblBT, iCount + 1 )
		table.remove ( tblBT, iCount )
		table.remove ( tblBT, iCount - 1)

		iCount = iCount - 1
		local z = getTableLength ( tblBT ) - 3

		for x = z, 1, -4 do
			if ( tonumber ( tblBT[x] ) == treeBehaviourID ) then
				table.remove ( tblBT, x + 3 )
				table.remove ( tblBT, x + 2 )
				table.remove ( tblBT, x + 1 )
				table.remove ( tblBT, x )
				iCount = x
				iTmp = iTmp + 1
			end
		end

		for x = iCount, getTableLength ( tblBT ), 4 do
			if ( tblBT[x] > treeBehaviourID ) then
				tblBT[x] = tblBT[x] - iTmp
			end

			tblBT[x + 1] = tblBT[x + 1] - iTmp
		end

		if ( getTableLength ( tblBT ) > 0 ) then
			populateBT ( )
		else
			setBTDefaults ( )
--[[
TODO:
bBehaviour = false
DISABLE actionCreate_Behaviour_Tree
DISABLE actionCreate_All
]]
		end
	else
		iDialog = 13
		showDialog ( 3, "Sorry, but you cannot DELETE the ROOT ITEM of the BEHAVIOUR TREE!" )
		qt.setFocus ( thisEditor, "treeBehaviour" )
	end
end

function btnBTCxl ( )
	checkStatus ( )
	if ( getTableLength ( tblBT ) > 0 ) then
		populateBT ( )
	else
		setBTDefaults ( )
	end
end

function btnBTSave ( )
	checkStatus ( )
	local tmpTxt = ""
	local txtFn = ""
	local tmpParentID = 0
	local iCount = 0

	local iTmp1 = qt.getCurrentIndex ( thisEditor, "cboBTType" )
	local iTmp2 = qt.getCurrentIndex ( thisEditor, "cboBTDetail" )

	tmpTxt = qt.getComboItemText ( thisEditor, "cboBTType", iTmp1 )
	txtFn = qt.getComboItemText ( thisEditor, "cboBTDetail", iTmp2 )

	if ( bBTNew or bBTSub ) then
		if ( bBTNew ) then
			for x = 2, getTableLength ( tblBT ), 4 do
				if ( treeBehaviourID == tblBT[x] ) then
					tmpParentID = tblBT[x - 1]
				end
			end

			if ( tmpParentID == 0 ) then
				tmpParentID = 1
			end

			treeBehaviourID = qt.insertTreeItem ( thisEditor, "treeBehaviour", tmpParentID )
			qt.setTreeItemText ( thisEditor, "treeBehaviour", treeBehaviourID, 0, "bBTNew" )
		else
			tmpParentID = treeBehaviourID or 1
			treeBehaviourID = qt.insertTreeItem ( thisEditor, "treeBehaviour", tmpParentID )
			qt.setTreeItemText ( thisEditor, "treeBehaviour", treeBehaviourID, 0, "bBTSub" )
		end

		table.insert ( tblBT, tmpParentID )
		table.insert ( tblBT, treeBehaviourID )
		table.insert ( tblBT, tmpTxt )
		table.insert ( tblBT, txtFn )
	else
		for x = 2, getTableLength ( tblBT ), 4 do
			if ( tblBT[x] == treeBehaviourID ) then
				iCount = x
				break
			end
		end

		tblBT[iCount + 1] = tmpTxt
		tblBT[iCount + 2] = txtFn
	end

	populateBT ( )
--[[
TODO:
ENABLE actionSave
ENABLE actionSave_As
]]
end

function treeBehaviour_Clicked ( itemText, treeID, column )
	checkStatus ( )
	treeBehaviourID = treeID

	local txtTmp = qt.getTreeItemText ( thisEditor, "treeBehaviour", treeID, 0 )
	local txtVal = qt.getTreeItemText ( thisEditor, "treeBehaviour", treeID, 1 )

	if ( txtTmp ~= "Behaviour" ) then
		if ( txtTmp == "Action" ) then
			qt.setCurrentIndex ( thisEditor, "cboBTType", 0 )
			populateComboActions ( "cboBTDetail" )
			setActionComboIdx ( "cboBTDetail", txtVal )
			qt.setDisabled ( thisEditor, "btnBTNewSubItem" )
		elseif ( txtTmp == "Evaluator" ) then
			qt.setCurrentIndex ( thisEditor, "cboBTType", 1 )
			populateComboEvals ( "cboBTDetail" )
			setEvalComboIdx ( "cboBTDetail", txtVal )
			qt.setDisabled ( thisEditor, "btnBTNewSubItem" )
		elseif ( txtTmp == "Selector" ) then
			qt.setCurrentIndex ( thisEditor, "cboBTType", 2 )
			populateComboNA ( "cboBTDetail" )
			qt.setCurrentIndex ( thisEditor, "cboBTDetail", 0 )
			qt.setEnabled ( thisEditor, "btnBTNewSubItem" )
		elseif ( txtTmp == "Sequence" ) then
			qt.setCurrentIndex ( thisEditor, "cboBTType", 3 )
			populateComboNA ( "cboBTDetail" )
			qt.setCurrentIndex ( thisEditor, "cboBTDetail", 0 )
			qt.setEnabled ( thisEditor, "btnBTNewSubItem" )
		end

		qt.setEnabled ( thisEditor, "btnBTNewItem" )
		qt.setEnabled ( thisEditor, "btnBTDelItem" )
		qt.setEnabled ( thisEditor, "btnBTEdit" )
		qt.setEnabled ( thisEditor, "btnBTCheck" )
	else
		qt.setCurrentIndex ( thisEditor, "cboBTType", 0 )
		populateComboActions ( "cboBTDetail" )
		qt.setCurrentIndex ( thisEditor, "cboBTDetail", 0 )
		qt.setEnabled ( thisEditor, "btnBTNewSubItem" )
		qt.setEnabled ( thisEditor, "btnBTCheck" )

		qt.setDisabled ( thisEditor, "btnBTNewItem" )
		qt.setDisabled ( thisEditor, "btnBTDelItem" )
		qt.setDisabled ( thisEditor, "btnBTEdit" )
	end

	bBT = true
	bBTNew = false
	bBTSub = false

	qt.setDisabled ( thisEditor, "cboBTType" )
	qt.setDisabled ( thisEditor, "cboBTDetail" )
	qt.setDisabled ( thisEditor, "btnBTCxl" )
	qt.setDisabled ( thisEditor, "btnBTSave" )

	qt.setEnabled ( thisEditor, "treeBehaviour" )
end

function cboBTType_ActivatedText ( inText )
	checkStatus ( )
	if ( inText == "Action" ) then
		populateComboActions ( "cboBTDetail" )
		qt.setEnabled ( thisEditor, "cboBTDetail" )
	elseif ( inText == "Evaluator" ) then
		populateComboEvals ( "cboBTDetail" )
		qt.setEnabled ( thisEditor, "cboBTDetail" )
	elseif ( inText == "Selector" ) then
		populateComboNA ( "cboBTDetail" )
		qt.setDisabled ( thisEditor, "cboBTDetail" )
	elseif ( inText == "Sequence" ) then
		populateComboNA ( "cboBTDetail" )
		qt.setDisabled ( thisEditor, "cboBTDetail" )
	end

	qt.setDisabled ( thisEditor, "btnBTNewItem" )
	qt.setDisabled ( thisEditor, "btnBTNewSubItem" )

	qt.setCurrentIndex ( thisEditor, "cboBTDetail", 0 )
end

function btnBTCheck ( )
	checkStatus ( )
	local tblSeq = { }
	local tblSel = { }
	local tblAct = { }
	local tblEva = { }
	local iCount = 0
	local iTmp = 0
	local bErr = false
	local sErr = ""
	local iLen = getTableLength ( tblBT )

	for x = 3, iLen, 4 do
		if ( tblBT[x] == "Sequence" ) then
			iTmp = tblBT[x - 1]
			tblSeq[iTmp] = 0

			for y = x, iLen do
				if ( tblBT[y] == iTmp ) then
					tblSeq[iTmp] = tblSeq[iTmp] + 1
				end
			end
		end
	end

	iCount = 0
	iTmp = 0

	for x = 3, iLen, 4 do
		if ( tblBT[x] == "Selector" ) then
			iTmp = tblBT[x - 1]
			tblSel[iTmp] = 0

			for y = x, iLen do
				if ( tblBT[y] == iTmp ) then
					tblSel[iTmp] = tblSel[iTmp] + 1
				end
			end
		end
	end

	iCount = 0
	iTmp = 0

	for x = 3, iLen, 4 do
		if ( tblBT[x] == "Action" ) then
			iTmp = tblBT[x - 1]
			tblAct[iTmp] = 0

			for y = x, iLen do
				if ( tblBT[y] == iTmp ) then
					tblAct[iTmp] = tblAct[iTmp] + 1
				end
			end
		end
	end

	iCount = 0
	iTmp = 0

	for x = 3, iLen, 4 do
		if ( tblBT[x] == "Evaluator" ) then
			iTmp = tblBT[x - 1]
			tblEva[iTmp] = 0

			for y = x, iLen do
				if ( tblBT[y] == iTmp ) then
					tblEva[iTmp] = tblEva[iTmp] + 1
				end
			end
		end
	end

	if ( tblBT[3] ~= "Selector" and tblBT[3] ~= "Sequence" ) then
		bErr = true
		sErr = "The FIRST Item in the Tree (ex Root) MUST be a Selector or a Sequence!"
	end

	if ( not bErr ) then
		for k, v in pairs ( tblSel ) do
			if ( v < 2 ) then
				bErr = true
				sErr = "Selectors MUST have at least 2 Children!"
				break
			end
		end

		if ( not bErr ) then
			for k, v in pairs ( tblSeq ) do
				if ( v < 2 ) then
					bErr = true
					sErr = "Sequences MUST have at least 2 Children!"
					break
				end
			end

			if ( not bErr ) then
				for k, v in pairs ( tblEva ) do
					if ( v > 0 ) then
						bErr = true
						sErr = "Evaluators MUST NOT have any Children!"
						break
					end
				end

				if ( not bErr ) then
					for k, v in pairs ( tblAct ) do
						if ( v > 0 ) then
							bErr = true
							sErr = "Actions MUST NOT have any Children!"
							break
						end
					end
				end
			end
		end
	end

	if ( not bErr ) then
--[[
TODO:
ENABLE actionCreate_Behaviour_Tree
bBehaviour = true

if ( bActions and bEvaluators and bBehaviour and bDecision and bFinite ) then
	ENABLE actionCreate_All
else
	DISABLE actionCreate_All
end
]]
		iDialog = 14
		showDialog ( 2, "The check of the BEHAVIOUR TREE was SUCCESSFUL!" )
	else
--[[
TODO:
DISABLE actionCreate_Behaviour_Tree
bBehaviour = false
DISABLE actionCreate_all
]]
		iDialog = 7
		showDialog ( 3, "Sorry, but the BEHAVIOUR TREE is NOT correctly formed!\n\n" .. sErr .. "\n\nPlease check your data and try again." )
	end
end

-- ***********************
-- ** DECISION TREE TAB **
-- ***********************
function btnDTNewItem ( )
	checkStatus ( )
	bDTNew = true
	bDTSub = false
	bDT = false

	qt.setEnabled ( thisEditor, "cboDTType" )
	qt.setEnabled ( thisEditor, "btnDTCxl" )
	qt.setEnabled ( thisEditor, "btnDTSave" )
	qt.setEnabled ( thisEditor, "cboDTDetail" )

	qt.setCurrentIndex ( thisEditor, "cboDTType", 0 )

	populateComboActions ( "cboDTDetail" )

	qt.setDisabled ( thisEditor, "treeDecision" )
	qt.setDisabled ( thisEditor, "btnDTNewItem" )
	qt.setDisabled ( thisEditor, "btnDTNewSubItem" )
	qt.setDisabled ( thisEditor, "btnDTDelItem" )
	qt.setDisabled ( thisEditor, "btnDTEdit" )
	qt.setDisabled ( thisEditor, "btnDTCheck" )
end

function btnDTNewSubItem ( )
	checkStatus ( )
	btnDTNewItem ( )
	bDTNew = false
	bDTSub = true
end

function btnDTEdit ( )
	checkStatus ( )
	bDTNew = false
	bDTSub = false
	bDT = false

	qt.setEnabled ( thisEditor, "cboDTType" )
	qt.setEnabled ( thisEditor, "btnDTCxl" )
	qt.setEnabled ( thisEditor, "btnDTSave" )

	local tmpTxt = qt.getTreeItemText ( thisEditor, "treeDecision", treeDecisionID, 0 )
	local tmpTxt2 = qt.getTreeItemText ( thisEditor, "treeDecision", treeDecisionID, 1 )

	if ( tmpTxt == "Action" ) then
		populateComboActions ( "cboDTDetail" )
		qt.setCurrentIndex ( thisEditor, "cboDTType", 0 )
		qt.setEnabled ( thisEditor, "cboDTDetail" )
		setActionComboIdx ( "cboDTDetail", tmpTxt2 )
	elseif ( tmpTxt == "Branch" ) then
		populateComboEvals ( "cboDTDetail" )
		qt.setCurrentIndex ( thisEditor, "cboDTType", 1 )
		qt.setEnabled ( thisEditor, "cboDTDetail" )
		setEvalComboIdx ( "cboDTDetail", tmpTxt2 )
	end

	qt.setDisabled ( thisEditor, "treeDecision" )
	qt.setDisabled ( thisEditor, "btnDTNewItem" )
	qt.setDisabled ( thisEditor, "btnDTNewSubItem" )
	qt.setDisabled ( thisEditor, "btnDTEdit" )
	qt.setDisabled ( thisEditor, "btnDTDelItem" )
	qt.setDisabled ( thisEditor, "btnDTCheck" )
end

function btnDTDelItem ( )
	checkStatus ( )
	local tmpTxt = qt.getTreeItemText ( thisEditor, "treeDecision", treeDecisionID, 0 )
	local iCount = 0
	local iTmp = 1

	if ( tmpTxt ~= "Decision" ) then
		for x = 2, getTableLength ( tblDT ), 4 do
			if ( tonumber ( tblDT[x] ) == treeDecisionID ) then
				iCount = x
				break
			end
		end

		table.remove ( tblDT, iCount + 2 )
		table.remove ( tblDT, iCount + 1 )
		table.remove ( tblDT, iCount )
		table.remove ( tblDT, iCount - 1 )

		iCount = iCount - 1
		local z = getTableLength ( tblDT ) - 3

		for x = z, 1, -4 do
			if ( tonumber ( tblDT[x] ) == treeDecisionID ) then
				table.remove ( tblDT, x + 3 )
				table.remove ( tblDT, x + 2 )
				table.remove ( tblDT, x + 1 )
				table.remove ( tblDT, x )
				iCount = x
				iTmp = iTmp + 1
			end
		end

		for x = iCount, getTableLength ( tblDT ), 4 do
			if ( tblDT[x] > treeDecisionID ) then
				tblDT[x] = tblDT[x] - iTmp
			end

			tblDT[x + 1] = tblDT[x + 1] - iTmp
		end

		if ( getTableLength ( tblDT ) > 0 ) then
			populateDT ( )
		else
			setDTDefaults ( )
		end
	else
		iDialog = 13
		showDialog ( 3, "Sorry, but you cannot DELETE the ROOT ITEM of the DECISION TREE!" )
		qt.setFocus ( thisEditor, "treeDecision" )
	end
end

function btnDTCxl ( )
	checkStatus ( )
	if ( getTableLength ( tblDT ) > 0 ) then
		populateDT ( )
	else
		setDTDefaults ( )
--[[
TODO:
bDecision = false
DISABLE actionCreate_Decision_Tree
DISABLE actionCreate_All
]]
	end
end

function btnDTSave ( )
	checkStatus ( )
	local tmpTxt = ""
	local txtFn = ""
	local tmpParentID = 0
	local iCount = 0

	local iTmp1 = qt.getCurrentIndex ( thisEditor, "cboDTType" )
	local iTmp2 = qt.getCurrentIndex ( thisEditor, "cboDTDetail" )

	tmpTxt = qt.getComboItemText ( thisEditor, "cboDTType", iTmp1 )
	txtFn = qt.getComboItemText ( thisEditor, "cboDTDetail", iTmp2 )

	if ( bDTNew or bDTSub ) then
		if ( bDTNew ) then
			for x = 2, getTableLength ( tblDT ), 4 do
				if ( treeDecisionID == tblDT[x] ) then
					tmpParentID = tblDT[x - 1]
				end
			end

			if ( tmpParentID == 0 ) then
				tmpParentID = 1
			end

			treeDecisionID = qt.insertTreeItem ( thisEditor, "treeDecision", tmpParentID )
			qt.setTreeItemText ( thisEditor, "treeDecision", treeDecisionID, 0, "bDTNew" )
		else
			tmpParentID = treeDecisionID or 1
			treeDecisionID = qt.insertTreeItem ( thisEditor, "treeDecision", tmpParentID )
			qt.setTreeItemText ( thisEditor, "treeDecision", treeDecisionID, 0, "bDTSub" )
		end

		table.insert ( tblDT, tmpParentID )
		table.insert ( tblDT, treeDecisionID )
		table.insert ( tblDT, tmpTxt )
		table.insert ( tblDT, txtFn )
	else
		for x = 2, getTableLength ( tblDT ), 4 do
			if ( tblDT[x] == treeDecisionID ) then
				iCount = x
				break
			end
		end

		tblDT[iCount + 1] = tmpTxt
		tblDT[iCount + 2] = txtFn
	end

	populateDT ( )
--[[
TODO:
ENABLE actionSave
ENABLE actionSave_As
]]
end

function treeDecision_Clicked ( itemText, treeID, column )
	checkStatus ( )
	treeDecisionID = treeID

	local txtTmp = qt.getTreeItemText ( thisEditor, "treeDecision", treeID, 0 )
	local txtVal = qt.getTreeItemText ( thisEditor, "treeDecision", treeID, 1 )

	if ( txtTmp ~= "Decision" ) then
		if ( txtTmp == "Action" ) then
			qt.setCurrentIndex ( thisEditor, "cboDTType", 0 )
			populateComboActions ( "cboDTDetail" )
			setActionComboIdx ( "cboDTDetail", txtVal )
			qt.setDisabled ( thisEditor, "btnDTNewSubItem" )
		elseif ( txtTmp == "Branch" ) then
			qt.setCurrentIndex ( thisEditor, "cboDTType", 1 )
			populateComboEvals ( "cboDTDetail" )
			setEvalComboIdx ( "cboDTDetail", txtVal )
			qt.setEnabled ( thisEditor, "btnDTNewSubItem" )
		end

		qt.setEnabled ( thisEditor, "btnDTNewItem" )
		qt.setEnabled ( thisEditor, "btnDTDelItem" )
		qt.setEnabled ( thisEditor, "btnDTEdit" )
	else
		qt.setEnabled ( thisEditor, "btnDTNewSubItem" )

		qt.setDisabled ( thisEditor, "btnDTNewItem" )
		qt.setDisabled ( thisEditor, "btnDTDelItem" )
		qt.setDisabled ( thisEditor, "btnDTEdit" )
	end

	bDT = true
	bDTNew = false
	bDTSub = false

	qt.setEnabled ( thisEditor, "treeDecision" )
	qt.setEnabled ( thisEditor, "btnDTCheck" )

	qt.setDisabled ( thisEditor, "cboDTType" )
	qt.setDisabled ( thisEditor, "cboDTDetail" )
	qt.setDisabled ( thisEditor, "btnDTCxl" )
	qt.setDisabled ( thisEditor, "btnDTSave" )
end

function cboDTType_ActivatedText ( inText )
	checkStatus ( )
	if ( inText == "Action" ) then
		populateComboActions ( "cboDTDetail" )
		qt.setEnabled ( thisEditor, "cboDTDetail" )
	elseif ( inText == "Branch" ) then
		populateComboEvals ( "cboDTDetail" )
		qt.setEnabled ( thisEditor, "cboDTDetail" )
	end

	qt.setCurrentIndex ( thisEditor, "cboDTDetail", 0 )

	qt.setDisabled ( thisEditor, "btnDTNewItem" )
	qt.setDisabled ( thisEditor, "btnDTNewSubItem" )
end

function btnDTCheck ( )
	checkStatus ( )
	local tblAct = { }
	local tblEva = { }
	local iCount = 0
	local iTmp = 0
	local bErr = false
	local sErr = ""
	local iLen = getTableLength ( tblDT )

	iCount = 0
	iTmp = 0

	for x = 3, iLen, 4 do
		if ( tblDT[x] == "Action" ) then
			iTmp = tblDT[x - 1]
			tblAct[iTmp] = 0

			for y = x, iLen do
				if ( tblDT[y] == iTmp ) then
					tblAct[iTmp] = tblAct[iTmp] + 1
				end
			end
		end
	end

	for x = 3, iLen, 4 do
		if ( tblDT[x] == "Branch" ) then
			iTmp = tblDT[x - 1]
			tblEva[iTmp] = 0

			for y = x, iLen do
				if ( tblDT[y] == iTmp ) then
					tblEva[iTmp] = tblEva[iTmp] + 1
				end
			end
		end
	end

	if ( tblDT[3] ~= "Branch" ) then
		bErr = true
		sErr = "The FIRST Item in the Tree (ex Root) MUST be a Branch!"
	end

	if ( not bErr ) then
		for k, v in pairs ( tblEva ) do
			if ( v ~= 2 ) then
				bErr = true
				sErr = "Branches MUST have EXACTLY 2 Children!"
				break
			end
		end

		if ( not bErr ) then
			for k, v in pairs ( tblAct ) do
				if ( v > 0 ) then
					bErr = true
					sErr = "Actions MUST NOT have any Children!"
					break
				end
			end
		end
	end

	if ( not bErr ) then
--[[
TODO:
ENABLE actionCreate_Decision_Tree
bDecision = true

if ( bActions and bEvaluators and bBehaviour and bDecision and bFinite ) then
	ENABLE actionCreate_All
else
	DISABLE actionCreate_All
end
]]
		iDialog = 15
		showDialog ( 2, "The check of the DECISION TREE was SUCCESSFUL!" )
	else
--[[
TODO:
DISABLE actionCreate_Decision_Tree
bDecision = false
DISABLE actionCreate_All
]]
		iDialog = 8
		showDialog ( 3, "Sorry, but the DECISION TREE is NOT correctly formed!\n\n" .. sErr .. "\n\nPlease check your data and try again." )
	end
end

-- *************
-- ** FSM TAB **
-- *************
function tblState_Clicked ( itemText, treeID, column )
	checkStatus ( )
	treeStateID = treeID
	local txtTmp = qt.getTreeItemText ( thisEditor, "tblState", treeStateID, 0 )

	qt.setText ( thisEditor, "txtFSMStateName", txtTmp )

	populateComboActions ( "cboFSMStateAction" )
	setActionComboIdx ( "cboFSMStateAction", txtTmp )
end

function tblTransition_Clicked ( itemText, treeID, column )
	checkStatus ( )
	treeTransID = treeID
	local txtTmp = qt.getTreeItemText ( thisEditor, "tblTransition", treeTransID, 0 )

	populateComboStates ( "cboFSMFromState", "" )
	setStateComboIdx ( "cboFSMFromState", txtTmp )

	local txtTmp2 = txtTmp
	txtTmp = qt.getTreeItemText ( thisEditor, "tblTransition", treeTransID, 1 )

	populateComboStates ( "cboFSMToState", "" )
	setStateComboIdx ( "cboFSMToState", txtTmp )

	txtTmp = qt.getTreeItemText ( thisEditor, "tblTransition", treeTransID, 2 )

	populateComboEvals ( "cboFSMStateEval" )
	setEvalComboIdx ( "cboFSMStateEval", txtTmp )
end

function txtFSMStateName_Return ( txtInput )
	checkStatus ( )
	txtInput = qt.getText ( thisEditor, "txtFSMStateName" )
	local bRet = checkTextInput ( txtInput )

	if ( bRet ) then
		if ( bFSMStateNew and not checkName ( "S", txtInput ) ) then
			iDialog = 1
			showDialog ( 3, "Sorry, but you have entered a NAME for the FSM STATE that already exists!\n\nPlease enter a different NAME and try again." )
			qt.setFocus ( thisEditor, "txtFSMStateName" )
		else
			qt.setEnabled ( thisEditor, "cboFSMStateAction" )
			qt.setEnabled ( thisEditor, "btnSaveState" )

			qt.setText ( thisEditor, "txtFSMMsg", "" )
		end
	else
		iDialog = 12
		showDialog ( 3, "Sorry, but you have used an INVALID Character in the NAME of the FSM STATE!\n\nThe available characters are A-z, 0-9 & _ ONLY!\n\nPlease try again." )
		qt.setFocus ( thisEditor, "txtFSMStateName" )
	end
end

function btnNewState ( )
	checkStatus ( )
	iCancel = 0
	bFSMStateNew = true
	bFSMTransNew = false
	bFSMState = false
	bFSMTrans = false

	qt.setEnabled ( thisEditor, "txtFSMStateName" )
	qt.setEnabled ( thisEditor, "btnCxlState" )

	qt.setText ( thisEditor, "txtFSMStateName", "NAME of STATE (A-z, 0-9 & _ ONLY!)" )
	qt.setText ( thisEditor, "txtFSMMsg", "**Press 'Enter' in the NAME field to enable the ACTION combobox. ***" )

	populateComboActions ( "cboFSMStateAction" )

	qt.setCurrentIndex ( thisEditor, "cboFSMStateAction", 0 )

	qt.setDisabled ( thisEditor, "cboFSMInitState" )
	qt.setDisabled ( thisEditor, "tblState" )
	qt.setDisabled ( thisEditor, "tblTransition" )
	qt.setDisabled ( thisEditor, "cboFSMStateAction" )
	qt.setDisabled ( thisEditor, "btnNewState" )
	qt.setDisabled ( thisEditor, "btnEditState" )
	qt.setDisabled ( thisEditor, "btnDelState" )
	qt.setDisabled ( thisEditor, "btnSaveState" )
	qt.setDisabled ( thisEditor, "cboFSMFromState" )
	qt.setDisabled ( thisEditor, "cboFSMToState" )
	qt.setDisabled ( thisEditor, "cboFSMStateEval" )
	qt.setDisabled ( thisEditor, "btnNewTrans" )
	qt.setDisabled ( thisEditor, "btnEditTrans" )
	qt.setDisabled ( thisEditor, "btnDelTrans" )
	qt.setDisabled ( thisEditor, "btnCxlTrans" )
	qt.setDisabled ( thisEditor, "btnSaveTrans" )
	qt.setDisabled ( thisEditor, "btnFSMCheck" )
end

function btnEditState ( )
	checkStatus ( )
	local tmpTxt = qt.getTreeItemText ( thisEditor, "tblState", treeStateID, 0 )
	local tmpTxt2 = qt.getTreeItemText ( thisEditor, "tblState", treeStateID, 1 )

	qt.setText ( thisEditor, "txtFSMStateName", tmpTxt )

	populateComboActions ( "cboFSMStateAction" )
	setActionComboIdx ( "cboFSMStateAction", tmpTxt2 )

	qt.setEnabled ( thisEditor, "txtFSMStateName" )
	qt.setEnabled ( thisEditor, "cboFSMStateAction" )
	qt.setEnabled ( thisEditor, "btnCxlState" )
	qt.setEnabled ( thisEditor, "btnSaveState" )

	qt.setDisabled ( thisEditor, "cboFSMInitState" )
	qt.setDisabled ( thisEditor, "tblState" )
	qt.setDisabled ( thisEditor, "tblTransition" )
	qt.setDisabled ( thisEditor, "btnNewState" )
	qt.setDisabled ( thisEditor, "btnEditState" )
	qt.setDisabled ( thisEditor, "btnDelState" )
	qt.setDisabled ( thisEditor, "cboFSMFromState" )
	qt.setDisabled ( thisEditor, "cboFSMToState" )
	qt.setDisabled ( thisEditor, "cboFSMStateEval" )
	qt.setDisabled ( thisEditor, "btnNewTrans" )
	qt.setDisabled ( thisEditor, "btnEditTrans" )
	qt.setDisabled ( thisEditor, "btnDelTrans" )
	qt.setDisabled ( thisEditor, "btnCxlTrans" )
	qt.setDisabled ( thisEditor, "btnSaveTrans" )
	qt.setDisabled ( thisEditor, "btnFSMCheck" )

	bFSMStateNew = false
	bFSMTransNew = false
	bFSMState = false
	bFSMTrans = false
end

function btnDelState ( )
	checkStatus ( )
	local iCount = 0
	local tmpTxt = qt.getTreeItemText ( thisEditor, "tblState", treeStateID, 0 )
	local bTrans = false
	tblTmp = { }

	iDelete = iDelete + 1

	for k, v in pairs ( tblFSMTrans ) do
		if ( v == tmpTxt ) then
			bTrans = true
			break
		end
	end

	if ( iDelete == 1 and bTrans ) then
		iDialog = 16
		showDialog ( 1, "WARNING! Deleting this FSM STATE will also delete ALL TRANSITIONS that use it.\n\nAre you sure you want to do this?" )
	else
		for x = 2, getTableLength ( tblFSMState ), 4 do
			if ( tblFSMState[x] == treeStateID ) then
				iCount = x
				break
			end
		end

		table.remove ( tblFSMState, x + 2 )
		table.remove ( tblFSMState, x + 1)
		table.remove ( tblFSMState, x )
		table.remove ( tblFSMState, x - 1 )

		if ( iDelete == 2 ) then
			iCount = 1

			for k, v in pairs ( tblFSMTrans ) do
				if ( v == tmpTxt ) then
					if ( iCount == 1 ) then
						table.insert ( tblTmp, k )
					else
						table.insert ( tblTmp, k - 1 )
					end
				end

				iCount = iCount + 1

				if ( iCount > 4 ) then
					iCount = 1
				end
			end

			for x = getTableLength ( tblTmp ), 1, -1 do
				table.remove ( tblFSMTrans, tblTmp[x] + 3 )
				table.remove ( tblFSMTrans, tblTmp[x] + 2 )
				table.remove ( tblFSMTrans, tblTmp[x] + 1 )
				table.remove ( tblFSMTrans, tblTmp[x] )
			end

			treeTransID = 1
		end

		treeStateID = treeStateID - 1

		if ( treeStateID < 0 ) then
			treeStateID = 0
		end

		if ( getTableLength ( tblFSMState ) > 0 ) then
			if ( tmpTxt == sFSMState ) then
				sFSMInitState = tblFSMState[1]
			end
		else
			sFSMInitState = ""
		end

		popStateTrans ( )

		if ( getTableLength ( tblFSMState ) == 0 ) then
--[[
TODO:
bFinite = false
DISABLE actionCreate_FSM
DISABLE actionCreate_All
]]
		end

		iDelete = 0
	end
end

function btnCxlState ( )
	checkStatus ( )
	iDelete = 0

	popStateTrans ( )
end

function btnSaveState ( )
	checkStatus ( )
	local iTmp = 0
	local tmpParentID = 0
	local txtNam = ""
	local txtName = ""
	local txtAct = ""
	local tmpID = 0
	local bFound = false

	if ( not bFSMStateNew ) then
		txtName = qt.getTreeItemText ( thisEditor, "tblState", treeStateID, 0 )
	else
		txtName = qt.getTreeItemText ( thisEditor, "tblState", 1, 0 )

		local idTable = qt.getAllTreeIDs ( thisEditor, "tblState")

		for k, v in pairs ( idTable ) do
			iTmp = v
		end

		treeStateID = iTmp
	end

	txtNam = qt.getText ( thisEditor, "txtFSMStateName" )

	local iTmp1 = qt.getCurrentIndex ( thisEditor, "cboFSMStateAction" )
	txtAct = qt.getComboItemText ( thisEditor, "cboFSMStateAction", iTmp1 )

	if ( not bFSMStateNew ) then
		for x = 3, getTableLength ( tblFSMState ), 4 do
			if ( txtName == tblFSMState[x] ) then
				tblFSMState[x] = txtNam
				tblFSMState[x + 1] = txtAct
				bFound = true
				break
			end
		end
	end

	if ( bFSMStateNew or not bFound ) then
		table.insert ( tblFSMState, tmpParentID )
		table.insert ( tblFSMState, treeStateID )
		table.insert ( tblFSMState, txtNam )
		table.insert ( tblFSMState, txtAct )
	end

	sortStates ( )
	popStateTrans ( )

--[[
TODO:
ENABLE actionSave
ENABLE actionSave_As
]]
end

function cboFSMInitState_ActivatedText ( inText )
	checkStatus ( )
	local iFSMInit = qt.getCurrentIndex ( thisEditor, "cboFSMInitState" )
	sFSMInit = qt.getComboItemText ( thisEditor, "cboFSMInitState", iFSMInit )
end

function cboFSMFromState_ActivatedText ( inText )
	checkStatus ( )
	local iTmp1 = qt.getCurrentIndex ( thisEditor, "cboFSMFromState" )
	inText = qt.getComboItemText ( thisEditor, "cboFSMFromState", iTmp1 )

	populateComboStates ( "cboFSMToState", "" )
	qt.setCurrentIndex ( thisEditor, "cboFSMToState", 0 )

	populateComboEvals ( "cboFSMStateEval" )
	qt.setCurrentIndex ( thisEditor, "cboFSMStateEval", 0 )

	qt.setEnabled ( thisEditor, "cboFSMToState" )
	qt.setEnabled ( thisEditor, "cboFSMStateEval" )
end

function btnNewTrans ( )
	checkStatus ( )
	iCancel = 0
	bFSMTransNew = true
	bFSMStateNew = false
	bFSMTrans = false
	bFSMState = false

	populateComboStates ( "cboFSMFromState", "" )
	qt.setCurrentIndex ( thisEditor, "cboFSMFromState", 0 )

	local iTmp1 = qt.getCurrentIndex ( thisEditor, "cboFSMFromState" )
	local txtAct = qt.getComboItemText ( thisEditor, "cboFSMFromState", iTmp1 )

	populateComboStates ( "cboFSMToState", "" )
	qt.setCurrentIndex ( thisEditor, "cboFSMToState", 0 )

	populateComboEvals ( "cboFSMStateEval", "" )
	qt.setCurrentIndex ( thisEditor, "cboFSMStateEval", 0 )

	qt.setEnabled ( thisEditor, "cboFSMFromState" )
	qt.setEnabled ( thisEditor, "btnCxlTrans" )
	qt.setEnabled ( thisEditor, "btnSaveTrans" )

	qt.setDisabled ( thisEditor, "tblState" )
	qt.setDisabled ( thisEditor, "tblTransition" )
	qt.setDisabled ( thisEditor, "cboFSMInitState" )
	qt.setDisabled ( thisEditor, "txtFSMStateName" )
	qt.setDisabled ( thisEditor, "cboFSMStateAction" )
	qt.setDisabled ( thisEditor, "btnNewState" )
	qt.setDisabled ( thisEditor, "btnEditState" )
	qt.setDisabled ( thisEditor, "btnDelState" )
	qt.setDisabled ( thisEditor, "btnCxlState" )
	qt.setDisabled ( thisEditor, "btnSaveState" )
	qt.setDisabled ( thisEditor, "cboFSMToState" )
	qt.setDisabled ( thisEditor, "cboFSMStateEval" )
	qt.setDisabled ( thisEditor, "btnNewTrans" )
	qt.setDisabled ( thisEditor, "btnEditTrans" )
	qt.setDisabled ( thisEditor, "btnDelTrans" )
	qt.setDisabled ( thisEditor, "btnFSMCheck" )
end

function btnEditTrans ( )
	checkStatus ( )
	local tmpTxt = qt.getTreeItemText ( thisEditor, "tblTransition", treeTransID, 0 )
	local tmpTxt2 = qt.getTreeItemText ( thisEditor, "tblTransition", treeTransID, 1 )
	local tmpTxt3 = qt.getTreeItemText ( thisEditor, "tblTransition", treeTransID, 2 )

	populateComboStates ( "cboFSMFromState", "" )
	populateComboStates ( "cboFSMToState", "" )

	populateComboEvals ( "cboFSMStateEval" )
	setStateComboIdx ( "cboFSMFromState", tmpTxt )
	setStateComboIdx ( "cboFSMToState", tmpTxt2 )
	setEvalComboIdx ( "cboFSMStateEval", tmpTxt3 )

	qt.setEnabled ( thisEditor, "cboFSMFromState" )
	qt.setEnabled ( thisEditor, "cboFSMToState" )
	qt.setEnabled ( thisEditor, "cboFSMStateEval" )
	qt.setEnabled ( thisEditor, "btnCxlTrans" )
	qt.setEnabled ( thisEditor, "btnSaveTrans" )

	qt.setDisabled ( thisEditor, "tblState" )
	qt.setDisabled ( thisEditor, "tblTransition" )
	qt.setDisabled ( thisEditor, "txtFSMStateName" )
	qt.setDisabled ( thisEditor, "cboFSMStateAction" )
	qt.setDisabled ( thisEditor, "cboFSMInitState" )
	qt.setDisabled ( thisEditor, "btnNewState" )
	qt.setDisabled ( thisEditor, "btnEditState" )
	qt.setDisabled ( thisEditor, "btnDelState" )
	qt.setDisabled ( thisEditor, "btnCxlState" )
	qt.setDisabled ( thisEditor, "btnSaveState" )
	qt.setDisabled ( thisEditor, "btnNewTrans" )
	qt.setDisabled ( thisEditor, "btnEditTrans" )
	qt.setDisabled ( thisEditor, "btnDelTrans" )
	qt.setDisabled ( thisEditor, "btnFSMCheck" )

	bFSMStateNew = false
	bFSMTransNew = false
	bFSMState = false
	bFSMTrans = false
end

function btnDelTrans ( )
	checkStatus ( )
	local iCount = 0
	local iTmp = 1

	for x = 2, getTableLength ( tblFSMTrans ), 5 do
		if ( tblFSMTrans[x] == treeTransID ) then
			iCount = x
			break
		end
	end

	table.remove ( tblFSMTrans, iCount + 3 )
	table.remove ( tblFSMTrans, iCount + 2 )
	table.remove ( tblFSMTrans, iCount + 1 )
	table.remove ( tblFSMTrans, iCount )
	table.remove ( tblFSMTrans, iCount - 1 )

	treeTransID = treeTransID - 1

	if ( treeTransID < 1 ) then
		treeTransID = 1
	end

	popStateTrans ( )

	local iLen = getTableLength ( tblFSMState )

	if ( iLen == 0 ) then
--[[
TODO:
bFinite = false
DISABLE actionCreate_FSM
DISABLE actionCreate_All
]]
	end
end

function btnCxlTrans ( )
	checkStatus ( )
	popStateTrans ( )
end

function popStateTrans ( )
	local tT = shallowCopy ( tblFSMState )
	setFSMStateDefaults ( )
	tblFSMState = shallowCopy ( tT )

	local iLen = getTableLength ( tblFSMState )

	if ( iLen > 0 ) then
		populateStates ( )

		if ( iLen > 4 ) then
			if ( getTableLength ( tblFSMTrans ) > 0 ) then
				populateTrans ( )
			end

			qt.setEnabled ( thisEditor, "btnNewTrans" )
		end
	end
end

function btnSaveTrans ( )
	checkStatus ( )
	local bFound = false
	local iTmp = 0
	local txtName = ""
	local tmpParentID = 0
	local tmpTxt = ""
	local tmpTxt2 = ""
	local tmpTxt3 = ""
	local tmpID = 0

	if ( not bFSMTransNew ) then
		txtName = qt.getTreeItemText ( thisEditor, "tblTransition", treeTransID, 0 )
	else
		txtName = qt.getTreeItemText ( thisEditor, "tblTransition", 1, 0 )

		local idTable = qt.getAllTreeIDs ( thisEditor, "tblTransition")

		for k, v in pairs ( idTable ) do
			iTmp = v
		end

		treeTransID = iTmp
	end

	local iTmp1 = qt.getCurrentIndex ( thisEditor, "cboFSMFromState" )
	local iTmp2 = qt.getCurrentIndex ( thisEditor, "cboFSMToState" )
	local iTmp3 = qt.getCurrentIndex ( thisEditor, "cboFSMStateEval" )

	tmpTxt = qt.getComboItemText ( thisEditor, "cboFSMFromState", iTmp1 )
	tmpTxt2 = qt.getComboItemText ( thisEditor, "cboFSMToState", iTmp2 )
	tmpTxt3 = qt.getComboItemText ( thisEditor, "cboFSMStateEval", iTmp3 )

	if ( not bFSMTransNew ) then
		for x = 3, getTableLength ( tblFSMTrans ), 5 do
			if ( txtName == tblFSMTrans[x] ) then
				tblFSMTrans[x] = tmpTxt
				tblFSMTrans[x + 1] = tmpTxt2
				tblFSMTrans[x + 2] = tmpTxt3
				bFound = true
				break
			end
		end
	end

	if ( bFSMTransNew or not bFound ) then
		table.insert ( tblFSMTrans, tmpParentID )
		table.insert ( tblFSMTrans, treeTransID )
		table.insert ( tblFSMTrans, tmpTxt )
		table.insert ( tblFSMTrans, tmpTxt2 )
		table.insert ( tblFSMTrans, tmpTxt3 )
	end

	popStateTrans ( )

--[[
TODO:
ENABLE actionSave
ENABLE actionSave_As
]]
end

function btnFSMCheck ( )
	checkStatus ( )
	local tStates = { }
	local tTrans = { }
	local iT = 0
	local bErr = false
	local sErr = ""

	if ( tblFSMState[1] ~= "Dummy" ) then
		for x = 1, getTableLength ( tblFSMState ), 2 do
			if ( tblFSMState[x] ~= "" ) then
				table.insert ( tStates, tblFSMState[x] )
			else
				bErr = true
				sErr = "FSM States CANNOT be BLANK!"
			end
		end

		if ( not bErr ) then
			for x = 1, getTableLength ( tblFSMTrans ), 3 do
				if ( tblFSMTrans[x] ~= "" ) then
					table.insert ( tTrans, tblFSMTrans[x] )
					iT = x + 1
					table.insert ( tTrans, tblFSMTrans[iT] )
				else
					bErr = true
					sErr = "FSM Transitions CANNOT be BLANK!"
				end
			end

			if ( not bErr ) then
				tTrans = removeDuplicates ( tTrans )
				tTrans = bubbleSort ( tTrans )
				tStates = bubbleSort ( tStates )

				for x = 1, getTableLength ( tStates ) do
					for y = 1, getTableLength ( tTrans ) do
						if ( tStates[x] ~= tTrans[x] ) then
							bErr = true
							sErr = "Each FSM State MUST have a corresponding FSM Transition!"
							break
						end
					end
				end
			end
		end
	end

	if ( not bErr ) then
--[[
TODO:
ENABLE actionCreate_FSM
bFinite = true

if ( bActions and bEvaluators and bBehaviour and bDecision and bFinite ) then
	ENABLE actionCreate_All
else
	DISABLE actionCreate_All
end
]]
		iDialog = 17
		showDialog ( 2, "The check of the FINITE STATE MACHINE was SUCCESSFUL!" )
	else
--[[
TODO:
DISABLE actionCreate_FSM
bFinite = false
DISABLE actionCreate_All
]]
		iDialog = 9
		showDialog ( 3, "Sorry, but the FINITE STATE MACHINE is NOT correctly formed!\n\n" .. sErr .. "\n\nPlease check your data and try again." )
	end
end

-- *****************
-- ** MAIN WINDOW **
-- *****************
function tabWidget_Changed ( index )
	checkStatus ( )
	local tmpTxt = ""

	if ( index == 0 ) then
		if ( getTableLength ( tblActions ) > 0 ) then
			populateActions ( )
		else
			setActionDefaults ( )
		end
	elseif ( index == 1 ) then
		if ( getTableLength ( tblEvaluators ) > 0 ) then
			populateEvaluators ( )
		else
			setEvaluatorDefaults ( )
		end
	elseif ( index == 2 ) then
		if ( getTableLength ( tblBT ) > 0 ) then
			populateBT ( )
		else
			setBTDefaults ( )
		end
	elseif ( index == 3 ) then
		if ( getTableLength ( tblDT ) > 0 ) then
			populateDT ( )
		else
			setDTDefaults ( )
		end
	elseif ( index == 4 ) then
		local tT = shallowCopy ( tblFSMState )
		setFSMStateDefaults ( )
		tblFSMState = shallowCopy ( tT )

		local iLen = getTableLength ( tblFSMState )

		if ( iLen > 0 ) then
			populateStates ( )

			if ( iLen > 2 ) then
				if ( getTableLength ( tblFSMTrans ) > 0 ) then
					populateTrans ( )
				end

				qt.setEnabled ( thisEditor, "btnNewTrans" )
			end
		end
	end
end

function actionNew ( )
	checkStatus ( )
	iDialog = 2
	showDialog ( 1, "WARNING! This operation will DELETE any UNSAVED data.\n\nWould you like to SAVE your existing data first?" )
	bInit = true
end

function actionLoad ( )
	checkStatus ( )
	txtFileName = qt.getOpen_FileDialog ( thisEditor, "Choose AI_Editor file", sky.getDir_AssetLibraryOrGameFolder(), "AI_Editor( *.ai )" )
	local iRow = 1
	local bCont = false
	local iCount = 1
	bInit = true

	setActionDefaults ( )
	setEvaluatorDefaults ( )
	setDTDefaults ( )
	setBTDefaults ( )
	setFSMStateDefaults ( )

	tblJSON = { }

	if ( txtFileName ~= "" and txtFileName ~= "." )then
		tblJSON = rapidjson.load ( txtFileName )

		local tblJAct = shallowCopy ( tblJSON["1"] )
		local tblJEval = shallowCopy ( tblJSON["2"] )
		local tblJBT = shallowCopy ( tblJSON["3"] )
		local tblJDT = shallowCopy ( tblJSON["4"] )
		local tblJFSMi = shallowCopy ( tblJSON["5"] )
		local tblJFSMs = shallowCopy ( tblJSON["6"] )
		local tblJFSMt = shallowCopy ( tblJSON["7"] )

		bAct = true

		tblActions = { }

		for x = 1, getTableLength ( tblJAct ) do
			table.insert ( tblActions, tblJAct[x]["parent"] )
			table.insert ( tblActions, tblJAct[x]["actid"] )
			table.insert ( tblActions, tblJAct[x]["name"] )
			table.insert ( tblActions, tblJAct[x]["func"] )
			table.insert ( tblActions, tblJAct[x]["init"] )
			table.insert ( tblActions, tblJAct[x]["upd"] )
			table.insert ( tblActions, tblJAct[x]["cln"] )
		end

		bEval = true

		tblEvaluators = { }

		for x = 1, getTableLength ( tblJEval ) do
			table.insert ( tblEvaluators, tblJEval[x]["parent"] )
			table.insert ( tblEvaluators, tblJEval[x]["evalid"] )
			table.insert ( tblEvaluators, tblJEval[x]["name"] )
			table.insert ( tblEvaluators, tblJEval[x]["func"] )
			table.insert ( tblEvaluators, tblJEval[x]["code"] )
		end

		tblBT = { }

		if ( tblJBT[1] ~= "None" ) then
			bBT = true

			for x = 1, getTableLength ( tblJBT ) do
				table.insert ( tblBT, tblJBT[x]["parent"] )
				table.insert ( tblBT, tblJBT[x]["behid"] )
				table.insert ( tblBT, tblJBT[x]["typ"] )
				table.insert ( tblBT, tblJBT[x]["det"] )
			end
		else
			bBT = false
		end

		if ( tblJDT[1] ~= "None" ) then
			bDT = true

			for x = 1, getTableLength ( tblJDT ) do
				table.insert ( tblDT, tblJDT[x]["parent"] )
				table.insert ( tblDT, tblJDT[x]["behid"] )
				table.insert ( tblDT, tblJDT[x]["typ"] )
				table.insert ( tblDT, tblJDT[x]["det"] )
			end
		else
			bDT = false
		end

		if ( tblJFSMi[1] ~= "None" ) then
			bFSMState = true
			setStateComboIdx ( "cboFSMInitState", tblJFSMi[1] )

			for x = 1, getTableLength ( tblJFSMs ) do
				table.insert ( tblFSMState, tblJFSMs[x]["parent"] )
				table.insert ( tblFSMState, tblJFSMs[x]["stateid"] )
				table.insert ( tblFSMState, tblJFSMs[x]["name"] )
				table.insert ( tblFSMState, tblJFSMs[x]["act"] )
			end
		else
			bFSMState = false
		end

		if ( tblJFSMi[1] ~= "None" ) then
			bFSMTrans = true

			for x = 1, getTableLength ( tblJFSMt ) do
				table.insert ( tblFSMTrans, tblJFSMt[x]["parent"] )
				table.insert ( tblFSMTrans, tblJFSMt[x]["transid"] )
				table.insert ( tblFSMTrans, tblJFSMt[x]["fromS"] )
				table.insert ( tblFSMTrans, tblJFSMt[x]["toS"] )
				table.insert ( tblFSMTrans, tblJFSMt[x]["eval"] )
			end
		else
			bFSMTrans = false
		end

		if ( bAct ) then
			treeActionID = 1
			populateActions ( )
--[[
TODO:
			bActions = true
			ENABLE actionCreate_Actions
		else
			bActions = false
			DISABLE actionCreate_Actions
			DISABLE actionCreate_All
]]
		end

		if ( bEval ) then
			treeEvalID = 1
			populateEvaluators ( )
--[[
TODO:
			bEvaluators = true
			ENABLE actionCreate_Evaluators
		else
			bEvaluators = false
			DISABLE actionCreate_Evaluators
			DISABLE actionCreate_All
]]
		end

		if ( bDT ) then
			treeDecisionID = 1
			populateDT ( )
--[[
TODO:
			bDecision = true
			ENABLE actionCreate_Decision_Tree
		else
			bDecision = false
			DISABLE actionCreate_Decision_Tree
			DISABLE actionCreate_All
]]
		end

		if ( bBT ) then
			treeBehaviourID = 1
			populateBT ( )
--[[
TODO:
			bBehaviour = true
			ENABLE actionCreate_Behaviour_Tree
		else
			bBehaviour = false
			DISABLE actionCreate_Behaviour_Tree
			DISABLE actionCreate_All
]]
		end

		if ( bFSMState ) then
			treeStateID = 1
			populateStates ( )
			bFSMState = true
			bFSMTrans = true
		end

		if ( bFSMTrans ) then
			treeTransID = 1
			populateTrans ( )
			qt.setEnabled ( thisEditor, "btnNewTrans" )
			bFSMTrans = true
		end

--[[
TODO:
if ( bFSMState and bFSMTrans ) then
	bFinite = true
	ENABLE actionCreate_FSM
else
	bFinite = false
	DISABLE actionCreate_FSM
	DISABLE actionCreate_All
end
]]

		qt.setCurrentIndex ( thisEditor, "tabWidget", 1 )
		qt.setCurrentIndex ( thisEditor, "tabWidget", 0 )
--[[
TODO:
ENABLE actionSave
ENABLE actionSave_As

if ( bActions and bEvaluators and bDecision and bBehaviour and bFinite ) then
	ENABLE actionCreate_All
end
]]
		local tTemp = txtFileName .. " successfully loaded!"
		qt.setText ( thisEditor, "txtStatus", tTemp )
	else
		iDialog = 3
		showDialog ( 3, "Sorry, but you have NOT selected a VALID file!\n\nPlease try again." )

		disableMenu ( )
	end
end

function actionSave ( )
	checkStatus ( )
	iDialog = 4
	showDialog ( 1, "WARNING! This action will OVERWRITE any SAVED data. Are you sure you want to do this?" )
end

function actionSave_Overwrite ( )
	local tblJAct = { }
	local tblJEval = { }
	local tblJBT = { }
	local tblJDT = { }
	local tblJFSMi = { }
	local tblJFSMs = { }
	local tblJFSMt = { }
	tblJSON = { }

	if ( txtFileName ~= "" ) then
		if ( bAct or bEval or bBT or bDT or bFSMState or bFSMTrans ) then
			if ( bAct ) then
				local iTmp = getTableLength ( tblActions )

				for x = 1, iTmp, 7 do
					local tTmp = { parent = "x", actid = "x", name = "x", func = "x", init = "x", upd = "x", cln = "x" }
					tTmp["parent"] = tblActions[x]
					tTmp["actid"] = tblActions[x + 1]
					tTmp["name"] = tblActions[x + 2]
					tTmp["func"] = tblActions[x + 3]
					tTmp["init"] = tblActions[x + 4]
					tTmp["upd"] = tblActions[x + 5]
					tTmp["cln"] = tblActions[x + 6]
					table.insert ( tblJAct, tTmp )
				end
			end

			if ( bEval ) then
				for x = 1, getTableLength ( tblEvaluators ), 5 do
					local tTmp = { parent = "x", evalid = "x", name = "x", func = "x", code = "x" }
					tTmp["parent"] = tblEvaluators[x]
					tTmp["evalid"] = tblEvaluators[x + 1]
					tTmp["name"] = tblEvaluators[x + 2]
					tTmp["func"] = tblEvaluators[x + 3]
					tTmp["code"] = tblEvaluators[x + 4]
					table.insert ( tblJEval, tTmp )
				end
			end

			if ( bBT ) then
				for x = 1, getTableLength ( tblBT ), 4 do
					local tTmp = { parent = "x", behid = "x", typ = "x", det = "x" }
					tTmp["parent"] = tblBT[x]
					tTmp["behid"] = tblBT[x + 1]
					tTmp["typ"] = tblBT[x + 2]
					tTmp["det"] = tblBT[x + 3]
					table.insert ( tblJBT, tTmp )
				end
			else
				tblJBT = { "None" }
			end

			if ( bDT ) then
				for x = 1, getTableLength ( tblDT ), 4 do
					local tTmp = { parent = "x", behid = "x", typ = "x", det = "x" }
					tTmp["parent"] = tblDT[x]
					tTmp["behid"] = tblDT[x + 1]
					tTmp["typ"] = tblDT[x + 2]
					tTmp["det"] = tblDT[x + 3]
					table.insert ( tblJDT, tTmp )
				end
			else
				tblJDT = { "None" }
			end

			if ( bFSMState ) then
				local iTmp1 = qt.getCurrentIndex ( thisEditor, "cboFSMInitState" )
				local sT = qt.getComboItemText ( thisEditor, "cboFSMInitState", iTmp1 )
				table.insert ( tblJFSMi, sT )

				for x = 1, getTableLength ( tblFSMState ), 4 do
					local tTmp = { parent = "x", stateid = "x", name = "x", act = "x" }
					tTmp["parent"] = tblFSMState[x]
					tTmp["stateid"] = tblFSMState[x + 1]
					tTmp["name"] = tblFSMState[x + 2]
					tTmp["act"] = tblFSMState[x + 3]
					table.insert ( tblJFSMs, tTmp )
				end
			else
				table.insert ( tblJFSMi, "None" )
				tblJFSMs = { "None" }
			end

			if ( bFSMTrans ) then
				for x = 1, getTableLength ( tblFSMTrans ), 5 do
					local tTmp = { parent = "x", transid = "x", fromS = "x", toS = "x", eval = "x" }
					tTmp["parent"] = tblFSMTrans[x]
					tTmp["transid"] = tblFSMTrans[x + 1]
					tTmp["fromS"] = tblFSMTrans[x + 2]
					tTmp["toS"] = tblFSMTrans[x + 3]
					tTmp["eval"] = tblFSMTrans[x + 4]
					table.insert ( tblJFSMt, tTmp )
				end
			else
				tblJFSMt = { "None" }
			end

			table.insert ( tblJSON, tblJAct )
			table.insert ( tblJSON, tblJEval )
			table.insert ( tblJSON, tblJBT )
			table.insert ( tblJSON, tblJDT )
			table.insert ( tblJSON, tblJFSMi )
			table.insert ( tblJSON, tblJFSMs )
			table.insert ( tblJSON, tblJFSMt )

			local jsonObj = rapidjson.object ( tblJSON )
			rapidjson.dump ( jsonObj, txtFileName, { pretty = true } )
			local tTemp = "Saved " .. txtFileName .. " successfully!"
			qt.setText ( thisEditor, "txtStatus", tTemp )
		else
			iDialog = 6
			showDialog ( 3, "Sorry, but you CANNOT SAVE the file as there are ERRORS in your AI!\n\nPlease check your data and try again." )
		end
	else
		actionSave_As ( )
	end
end

function actionSave_As ( )
	checkStatus ( )
	txtFileName = qt.getSave_FileDialog ( thisEditor, "Save AI_Editor file", sky.getDir_AssetLibraryOrGameFolder(), "AI_Editor( *.ai )" )

	if ( txtFileName ~= "" and txtFileName ~= "." )then
		actionSave ( )
	else
		iDialog = 3
		showDialog ( 3, "Sorry, but you have NOT selected a VALID file!\n\nPlease try again." )
	end
end

function actionCreate_Behaviour_Tree ( )
	checkStatus ( )
	if ( bBT ) then
		createBT ( )
		return true
	else
		iDialog = 7
		showDialog ( 3, "Sorry, but you CANNOT CREATE the BEHAVIOUR TREE Script, as your BEHAVIOUR TREE has errors!\n\nPlease check your data and try again." )
		return false
	end
end

function actionCreate_Decision_Tree ( )
	checkStatus ( )
	if ( bDT ) then
		createDT ( )
		return true
	else
		iDialog = 8
		showDialog ( 3, "Sorry, but you CANNOT CREATE the DECISION TREE Script, as your DECISION TREE has errors!\n\nPlease check your data and try again." )
		return false
	end
end

function actionCreate_FSM ( )
	checkStatus ( )
	if ( bFSMState and bFSMTrans ) then
		createFSM ( )
		return true
	else
		iDialog = 9
		showDialog ( 3, "Sorry, but you CANNOT CREATE the FINITE STATE MACHINE Script, as your FINITE STATE MACHINE has errors!\n\nPlease check your data and try again." )
		return false
	end
end

function actionCreate_Actions ( )
	checkStatus ( )
	if ( bAct ) then
		createAct ( )
		return true
	else
		iDialog = 10
		showDialog ( 3, "Sorry, but you CANNOT CREATE the ACTIONS Script, as your ACTIONS have errors!\n\nPlease check your data and try again." )
		return false
	end
end

function actionCreate_Evaluators ( )
	checkStatus ( )
	if ( bEval ) then
		createEval ( )
		return true
	else
		iDialog = 11
		showDialog ( 3, "Sorry, but you CANNOT CREATE the EVALUATORS Script, as your EVALUATORS have errors!\n\nPlease check your data and try again." )
		return false
	end
end

function actionCreate_All ( )
	checkStatus ( )
	local bRet = actionCreate_Actions ( )

	if ( bRet ) then
		bRet = actionCreate_Evaluators ( )

		if ( bRet ) then
			bRet = actionCreate_Behaviour_Tree ( )

			if ( bRet ) then
				bRet = actionCreate_Decision_Tree ( )

				if ( bRet ) then
					bRet = actionCreate_FSM ( )

					local tTemp = "All scripts successfully created!"
					qt.setText ( thisEditor, "txtStatus", tTemp )
				end
			end
		end
	end
end

-- *********************
-- ** COMBO FUNCTIONS **
-- *********************
function populateComboActions ( inCombo )
	local iLen = getTableLength ( tblActions )

	qt.clear ( thisEditor, inCombo )

	if ( iLen == 0 ) then
		qt.addComboItem ( thisEditor, inCombo, "No Actions Available" )
	else
		for x = 3, iLen, 7 do
			qt.addComboItem ( thisEditor, inCombo, tblActions[x] )
		end
	end
end

function populateComboEvals ( inCombo )
	local iLen = getTableLength ( tblEvaluators )

	qt.clear ( thisEditor, inCombo )

	if ( iLen == 0 ) then
		qt.addComboItem ( thisEditor, inCombo, "No Evaluators Available" )
	else
		for x = 3, iLen, 5 do
			qt.addComboItem ( thisEditor, inCombo, tblEvaluators[x] )
		end
	end
end

function populateComboStates ( inCombo, inState )
	qt.clear ( thisEditor, inCombo )

	for x = 3, getTableLength ( tblFSMState ), 4 do
		if ( tblFSMState[x] ~= inState ) then
			qt.addComboItem ( thisEditor, inCombo, tblFSMState[x] )
		end
	end
end

function populateComboNA ( inCombo )
	qt.clear ( thisEditor, inCombo )
	qt.addComboItem ( thisEditor, inCombo, "Not Applicable" )
end

function setActionComboIdx ( inCombo, inText )
	local tmpIdx = 0

	for x = 3, getTableLength ( tblActions ), 7 do
		if ( tblActions[x] == inText ) then
			tmpIdx = ( x + 4 ) / 7 - 1
			break
		end
	end

	qt.setCurrentIndex ( thisEditor, inCombo, tmpIdx )
end

function setEvalComboIdx ( inCombo, inText )
	local tmpIdx = 0

	for x = 3, getTableLength ( tblEvaluators ), 5 do
		if ( tblEvaluators[x] == inText ) then
			tmpIdx = ( x + 2 ) / 5 - 1
			break
		end
	end

	qt.setCurrentIndex ( thisEditor, inCombo, tmpIdx )
end

function setStateComboIdx ( inCombo, inText )
	local tmpIdx = -1
	local sTmp = ""
	local bBefore = false

	for x = 3, getTableLength ( tblFSMState ), 4 do
		tmpIdx = tmpIdx + 1

		if ( not bBefore ) then
			sTmp = qt.getComboItemText ( thisEditor, inCombo, ( x - 3 ) / 4 )

			if ( sTmp ~= tblFSMState[x] ) then
				bBefore = true
			end
		end

		if ( tblFSMState[x] == inText ) then
			break
		end
	end

	if ( bBefore ) then
		tmpIdx = tmpIdx - 1
	end

	qt.setCurrentIndex ( thisEditor, inCombo, tmpIdx )
end

-- **********************
-- ** HELPER FUNCTIONS **
-- **********************
function setActionDefaults ( )
	bActNew = false
	bAct = false

	tblActions = { }

	qt.clear ( thisEditor, "tblAction" )

	qt.setText ( thisEditor, "txtActionName", "NAME of ACTION" )
	qt.setText ( thisEditor, "txtActionMsg", "** NO ACTIONS AVAILABLE **" )

	local txtTmp = "local act_DummyInitialize = function ( objID )\n\t-- CODE GOES HERE\n\n\treturn \"TERMINATED\"\nend"
	qt.setText ( thisEditor, "txtInitFn", txtTmp )
	txtTmp = "local act_DummyUpdate = function ( objID )\n\t-- CODE GOES HERE\n\n\treturn \"TERMINATED\"\nend"
	qt.setText ( thisEditor, "txtUpdFn", txtTmp )
	txtTmp = "local act_DummyCleanUp = function ( objID )\n\t-- CODE GOES HERE\n\nend"
	qt.setText ( thisEditor, "txtClnFn", txtTmp )

	treeActionID = qt.insertTreeItem ( thisEditor, "tblAction" )

	qt.setTreeItemText ( thisEditor, "tblAction", treeActionID, 0, "Dummy" )
	qt.setTreeItemText ( thisEditor, "tblAction", treeActionID, 1, "ACT_DummyAction ( objID )" )

	qt.setCurrentIndex ( thisEditor, "tblAction", treeActionID )

	bAct = false

	qt.setEnabled ( thisEditor, "btnActionNew" )

	qt.setDisabled ( thisEditor, "tblAction" )
	qt.setDisabled ( thisEditor, "txtActionName" )
	qt.setDisabled ( thisEditor, "txtInitFn" )
	qt.setDisabled ( thisEditor, "txtUpdFn" )
	qt.setDisabled ( thisEditor, "txtClnFn" )
	qt.setDisabled ( thisEditor, "btnActionEdit" )
	qt.setDisabled ( thisEditor, "btnActionDel" )
	qt.setDisabled ( thisEditor, "btnActionCxl" )
	qt.setDisabled ( thisEditor, "btnActionSave" )

	qt.setFocus ( thisEditor, "txtActionName" )
end

function populateActions ( )
	local iTmp = 0
	local tmpID = 0
	bAct = true

	qt.clear ( thisEditor, "tblAction" )

	iTmp = getTableLength ( tblActions )

	for x = 3, iTmp, 7 do
		tmpID = qt.insertTreeItem ( thisEditor, "tblAction" )
		tblActions[x - 1] = tmpID

		qt.setTreeItemText ( thisEditor, "tblAction", tmpID, 0, tblActions[x] )
		qt.setTreeItemText ( thisEditor, "tblAction", tmpID, 1, tblActions[x + 1] )
	end

	qt.setCurrentIndex ( thisEditor, "tblAction", treeActionID )
	qt.setText ( thisEditor, "txtActionMsg", "" )

	qt.setEnabled ( thisEditor, "tblAction" )
	qt.setEnabled ( thisEditor, "btnActionEdit" )
	qt.setEnabled ( thisEditor, "btnActionDel" )

	local iCount = 0

	for x = 2, getTableLength ( tblActions ), 7 do
		if ( tblActions[x] == treeActionID ) then
			iCount = x
			break
		end
	end

	qt.setText ( thisEditor, "txtActionName", tblActions[iCount + 1] )
	qt.setText ( thisEditor, "txtInitFn", tblActions[iCount + 3] )
	qt.setText ( thisEditor, "txtUpdFn", tblActions[iCount + 4] )
	qt.setText ( thisEditor, "txtClnFn", tblActions[iCount + 5] )

	qt.setEnabled ( thisEditor, "tblAction" )
	qt.setEnabled ( thisEditor, "btnActionNew" )
	qt.setEnabled ( thisEditor, "btnActionEdit" )
	qt.setEnabled ( thisEditor, "btnActionDel" )

	qt.setDisabled ( thisEditor, "txtActionName" )
	qt.setDisabled ( thisEditor, "txtInitFn" )
	qt.setDisabled ( thisEditor, "txtUpdFn" )
	qt.setDisabled ( thisEditor, "txtClnFn" )
	qt.setDisabled ( thisEditor, "btnActionCxl" )
	qt.setDisabled ( thisEditor, "btnActionSave" )

	qt.deselectAllItems ( thisEditor, "tblAction" )
	qt.setTreeSelectedItem ( thisEditor, "tblAction", treeActionID, 0, 1 )
	qt.setTreeSelectedItem ( thisEditor, "tblAction", treeActionID, 1, 1 )
end

function setEvaluatorDefaults ( )
	bEvalNew = false
	bEval = false
	tblEvaluators = { }

	qt.clear ( thisEditor, "tblEval" )

	qt.setText ( thisEditor, "txtEvalName", "NAME of EVALUATOR" )
	qt.setText ( thisEditor, "txtEvalMsg", "** NO EVALUATORS AVAILABLE **" )

	local txtTmp = "function Evaluators_Dummy ( objID )\n\t-- CODE GOES HERE\n\n\treturn false\nend"
	qt.setText ( thisEditor, "txtEvalCode", txtTmp )

	treeEvalID = qt.insertTreeItem ( thisEditor, "tblEval" )
	qt.setTreeItemText ( thisEditor, "tblEval", treeEvalID, 0, "Dummy" )
	qt.setTreeItemText ( thisEditor, "tblEval", treeEvalID, 1, "Evaluators_Dummy" )

	qt.setCurrentIndex ( thisEditor, "tblEval", treeEvalID )

	bEval = false

	qt.setEnabled ( thisEditor, "btnEvalNew" )

	qt.setDisabled ( thisEditor, "tblEval" )
	qt.setDisabled ( thisEditor, "txtEvalName" )
	qt.setDisabled ( thisEditor, "txtEvalCode" )
	qt.setDisabled ( thisEditor, "btnEvalEdit" )
	qt.setDisabled ( thisEditor, "btnEvalDel" )
	qt.setDisabled ( thisEditor, "btnEvalCxl" )
	qt.setDisabled ( thisEditor, "btnEvalSave" )

	qt.setFocus ( thisEditor, "txtEvalName" )
end

function populateEvaluators ( )
	local iTmp = 0
	local tmpID = 0
	local iCount = 0
	bEval = true

	qt.clear ( thisEditor, "tblEval" )

	iTmp = getTableLength ( tblEvaluators )

	for x = 3, iTmp, 5 do
		tmpID = qt.insertTreeItem ( thisEditor, "tblEval" )
		tblEvaluators[x - 1] = tmpID

		qt.setTreeItemText ( thisEditor, "tblEval", tmpID, 0, tblEvaluators[x] )
		qt.setTreeItemText ( thisEditor, "tblEval", tmpID, 1, tblEvaluators[x + 1] )
	end

	qt.setCurrentIndex ( thisEditor, "tblEval", treeEvalID )
	qt.setText ( thisEditor, "txtEvalMsg", "" )

	qt.setEnabled ( thisEditor, "tblEval" )
	qt.setEnabled ( thisEditor, "btnEvalNew" )
	qt.setEnabled ( thisEditor, "btnEvalEdit" )
	qt.setEnabled ( thisEditor, "btnEvalDel" )

	qt.setDisabled ( thisEditor, "txtEvalName" )
	qt.setDisabled ( thisEditor, "txtEvalCode" )
	qt.setDisabled ( thisEditor, "btnEvalCxl" )
	qt.setDisabled ( thisEditor, "btnEvalSave" )

	qt.setFocus ( thisEditor, "txtEvalName" )

	iCount = 0

	for x = 2, getTableLength ( tblEvaluators ), 5 do
		if ( tblEvaluators[x] == treeEvalID ) then
			iCount = x
			break
		end
	end

	qt.setText ( thisEditor, "txtEvalName", tblEvaluators[iCount + 1] )
	qt.setText ( thisEditor, "txtEvalCode", tblEvaluators[iCount + 3] )

	qt.deselectAllItems ( thisEditor, "tblEval" )
	qt.setTreeSelectedItem ( thisEditor, "tblEval", treeEvalID, 0, 1 )
	qt.setTreeSelectedItem ( thisEditor, "tblEval", treeEvalID, 1, 1 )
end

function setBTDefaults ( )
	bBTNew = false
	bBTSub = false
	bBT = false

	tblBT = { }

	if ( getTableLength ( tblActions ) == 0 ) then
		populateComboNA ( "cboBTDetail" )
	else
		populateComboActions ( "cboBTDetail" )
	end

	qt.setCurrentIndex ( thisEditor, "cboBTType", 0 )
	qt.setCurrentIndex ( thisEditor, "cboBTDetail", 0 )

	qt.clear ( thisEditor, "treeBehaviour" )

	treeBehaviourID = qt.insertTreeItem ( thisEditor, "treeBehaviour" )

	qt.setTreeItemText ( thisEditor, "treeBehaviour", treeBehaviourID, 0, "Behaviour" )
	qt.setCurrentIndex ( thisEditor, "treeBehaviour", 0 )

	qt.setDisabled ( thisEditor, "treeBehaviour" )
	qt.setDisabled ( thisEditor, "cboBTType" )
	qt.setDisabled ( thisEditor, "cboBTDetail" )
	qt.setDisabled ( thisEditor, "btnBTNewSubItem" )
	qt.setDisabled ( thisEditor, "btnBTEdit" )
	qt.setDisabled ( thisEditor, "btnBTDelItem" )
	qt.setDisabled ( thisEditor, "btnBTCxl" )
	qt.setDisabled ( thisEditor, "btnBTSave" )
	qt.setDisabled ( thisEditor, "btnBTCheck" )

	if ( getTableLength ( tblActions ) > 0 and getTableLength ( tblEvaluators ) > 0 ) then
		qt.setText ( thisEditor, "txtBTMsg", "" )
		qt.setEnabled ( thisEditor, "btnBTNewSubItem" )
	else
		qt.setDisabled ( thisEditor, "btnBTNewItem" )
		qt.setDisabled ( thisEditor, "btnBTNewSubItem" )

		if ( not bInit ) then
			iDialog = 18
			showDialog ( 3, "Sorry, but to create a BEHAVIOUR TREE, there must be at least one ACTION and one EVALUATOR!\n\nPlease create the missing ACTION and/or EVALUATOR, and try again." )
		end

		qt.setFocus ( thisEditor, "treeBehaviour" )
	end
end

function populateBT ( )
	local tmpID = 0
	bBTNew = false
	bBTSub = false
	local iCount = 0

	local tmpTbl = shallowCopy ( tblBT )

	setBTDefaults ( )

	tblBT = shallowCopy ( tmpTbl )

	bBT = true

	for x = 1, getTableLength ( tblBT ), 4 do
		if ( tblBT[x] == 0 ) then
			tmpID = qt.insertTreeItem ( thisEditor, "treeBehaviour" )
		else
			tmpID = qt.insertTreeItem ( thisEditor, "treeBehaviour", tblBT[x] )
		end

		qt.setTreeItemText ( thisEditor, "treeBehaviour", tmpID, 0, tblBT[x + 2] )
		qt.setTreeItemText ( thisEditor, "treeBehaviour", tmpID, 1, tblBT[x + 3] )
	end

	qt.setCurrentIndex ( thisEditor, "treeBehaviour", treeBehaviourID )

	for x = 2, getTableLength ( tblBT ), 4 do
		if ( tblBT[x] == treeBehaviourID ) then
			if ( tblBT[x + 1] == "Action" ) then
				qt.setCurrentIndex ( thisEditor, "cboBTType", 0 )

				populateComboActions ( "cboBTDetail" )

				for y = 2, getTableLength ( tblActions ), 5 do
					if ( tblActions[y] == tblBT [x + 2] ) then
						iCount = y
						break
					end
				end

				iCount = ( iCount + 3 ) / 5 - 1

				qt.setCurrentIndex ( thisEditor, "cboBTDetail", iCount )
			elseif ( tblBT[x + 1] == "Evaluator" ) then
				qt.setCurrentIndex ( thisEditor, "cboBTType", 1 )

				populateComboEvals ( "cboBTDetail" )

				for y = 2, getTableLength ( tblEvaluators ), 3 do
					if ( tblEvaluators[y] == tblBT [x + 2] ) then
						iCount = y
						break
					end
				end

				iCount = ( iCount + 1 ) / 3 - 1

				qt.setCurrentIndex ( thisEditor, "cboBTDetail", iCount )
			elseif ( tblBT[x + 1] == "Selector" ) then
				qt.setCurrentIndex ( thisEditor, "cboBTType", 2 )
				populateComboNA ( "cboBTDetail" )
			elseif ( tblBT[x + 1] == "Sequence" ) then
				qt.setCurrentIndex ( thisEditor, "cboBTType", 3 )
				populateComboNA ( "cboBTDetail" )
			end
		end
	end

	if ( treeBehaviourID < 2 ) then
		qt.setDisabled ( thisEditor, "btnBTNewItem" )
		qt.setDisabled ( thisEditor, "btnBTDelItem" )
		qt.setDisabled ( thisEditor, "btnBTEdit" )
		qt.setDisabled ( thisEditor, "btnBTCxl" )
		qt.setDisabled ( thisEditor, "btnBTSave" )
		qt.setDisabled ( thisEditor, "cboBTType" )
		qt.setDisabled ( thisEditor, "cboBTDetail" )
	else
		qt.setEnabled ( thisEditor, "btnBTNewItem" )
		qt.setEnabled ( thisEditor, "btnBTDelItem" )
		qt.setEnabled ( thisEditor, "btnBTEdit" )
		qt.setEnabled ( thisEditor, "btnBTCxl" )
		qt.setEnabled ( thisEditor, "btnBTSave" )
		qt.setEnabled ( thisEditor, "cboBTType" )
		qt.setEnabled ( thisEditor, "cboBTDetail" )
	end

	qt.setEnabled ( thisEditor, "treeBehaviour" )
	qt.setEnabled ( thisEditor, "btnBTNewSubItem" )
	qt.setEnabled ( thisEditor, "btnBTCheck" )

	qt.setTreeExpandAll ( thisEditor, "treeBehaviour" )

	qt.deselectAllItems ( thisEditor, "treeBehaviour" )
	qt.setTreeSelectedItem ( thisEditor, "treeBehaviour", 0, treeBehaviourID, 1 )
	qt.setTreeSelectedItem ( thisEditor, "treeBehaviour", 1, treeBehaviourID, 1 )
end

function setDTDefaults ( )
	bDTNew = false
	bDTSub = false
	bDT = false
	tblDT = { }

	if ( getTableLength ( tblActions ) == 0 ) then
		populateComboNA ( "cboDTDetail" )
	else
		populateComboActions ( "cboDTDetail" )
	end

	qt.setCurrentIndex ( thisEditor, "cboDTType", 0 )
	qt.setCurrentIndex ( thisEditor, "cboDTDetail", 0 )

	qt.clear ( thisEditor, "treeDecision" )

	treeDecisionID = qt.insertTreeItem ( thisEditor, "treeDecision" )

	qt.setTreeItemText ( thisEditor, "treeDecision", treeDecisionID, 0, "Decision" )
	qt.setCurrentIndex ( thisEditor, "treeDecision", 0 )

	qt.setDisabled ( thisEditor, "treeDecision" )
	qt.setDisabled ( thisEditor, "cboDTType" )
	qt.setDisabled ( thisEditor, "cboDTDetail" )
	qt.setDisabled ( thisEditor, "btnDTNewSubItem" )
	qt.setDisabled ( thisEditor, "btnDTEdit" )
	qt.setDisabled ( thisEditor, "btnDTDelItem" )
	qt.setDisabled ( thisEditor, "btnDTCxl" )
	qt.setDisabled ( thisEditor, "btnDTSave" )
	qt.setDisabled ( thisEditor, "btnDTCheck" )

	if ( getTableLength ( tblActions ) > 0 and getTableLength ( tblEvaluators ) > 0 ) then
		qt.setText ( thisEditor, "txtDTMsg", "" )
		qt.setEnabled ( thisEditor, "btnDTNewSubItem" )
	else
		qt.setDisabled ( thisEditor, "btnDTNewItem" )
		qt.setDisabled ( thisEditor, "btnDTNewSubItem" )

		if ( not bInit ) then
			iDialog = 18
			showDialog ( 3, "Sorry, but to create a DECISION TREE, there must be at least one ACTION and one EVALUATOR!\n\nPlease create the missing ACTION and/or EVALUATOR, and try again." )
			qt.setFocus ( thisEditor, "treeDecision" )
		end
	end
end

function populateDT ( )
	local tmpID = 0
	bDTNew = false
	bDTSub = false
	local iCount = 0

	local tmpTbl = shallowCopy ( tblDT )

	setDTDefaults ( )

	tblDT = shallowCopy ( tmpTbl )

	bDT = true

	for x = 1, getTableLength ( tblDT ), 4 do
		if ( tblDT[x] == 0 ) then
			tmpID = qt.insertTreeItem ( thisEditor, "treeDecision" )
		else
			tmpID = qt.insertTreeItem ( thisEditor, "treeDecision", tblDT[x] )
		end

		qt.setTreeItemText ( thisEditor, "treeDecision", tmpID, 0, tblDT[x + 2] )
		qt.setTreeItemText ( thisEditor, "treeDecision", tmpID, 1, tblDT[x + 3] )
	end

	qt.setCurrentIndex ( thisEditor, "treeDecision", treeDecisionID )

	for x = 2, getTableLength ( tblDT ), 4 do
		if ( tblDT[x] == treeDecisionID ) then
			if ( tblDT[x + 1] == "Action" ) then
				qt.setCurrentIndex ( thisEditor, "cboDTType", 0 )
				populateComboActions ( "cboDTDetail" )

				for y = 2, getTableLength ( tblActions ), 5 do
					if ( tblActions[y] == tblDT [x + 2] ) then
						iCount = y
						break
					end
				end

				iCount = ( iCount + 3 ) / 5 - 1
				qt.setCurrentIndex ( thisEditor, "cboDTDetail", iCount )
			elseif ( tblDT[x + 1] == "Branch" ) then
				qt.setCurrentIndex ( thisEditor, "cboDTType", 1 )
				populateComboEvals ( "cboDTDetail" )

				for y = 2, getTableLength ( tblEvaluators ), 3 do
					if ( tblEvaluators[y] == tblDT [x + 2] ) then
						iCount = y
						break
					end
				end

				iCount = ( iCount + 1 ) / 3 - 1
				qt.setCurrentIndex ( thisEditor, "cboDTDetail", k )
			end
		end
	end

	if ( treeDecisionID < 2 ) then
		qt.setDisabled ( thisEditor, "btnDTNewItem" )
		qt.setDisabled ( thisEditor, "btnDTDelItem" )
		qt.setDisabled ( thisEditor, "btnDTEdit" )
		qt.setDisabled ( thisEditor, "btnDTCxl" )
		qt.setDisabled ( thisEditor, "btnDTSave" )
		qt.setDisabled ( thisEditor, "cboDTType" )
		qt.setDisabled ( thisEditor, "cboDTDetail" )
	else
		qt.setEnabled ( thisEditor, "btnDTNewItem" )
		qt.setEnabled ( thisEditor, "btnDTEdit" )
		qt.setEnabled ( thisEditor, "btnDTDelItem" )
		qt.setEnabled ( thisEditor, "btnDTCxl" )
		qt.setEnabled ( thisEditor, "btnDTSave" )
		qt.setEnabled ( thisEditor, "cboDTType" )
		qt.setEnabled ( thisEditor, "cboDTDetail" )
	end

	qt.setEnabled ( thisEditor, "treeDecision" )
	qt.setEnabled ( thisEditor, "btnDTNewSubItem" )
	qt.setEnabled ( thisEditor, "btnDTCheck" )

	qt.setTreeExpandAll ( thisEditor, "treeDecision" )

	qt.deselectAllItems ( thisEditor, "treeDecision" )
	qt.setTreeSelectedItem ( thisEditor, "treeDecision", treeDecisionID, 0, 1 )
	qt.setTreeSelectedItem ( thisEditor, "treeDecision", treeDecisionID, 1, 1 )
end

function setFSMStateDefaults ( )
	tblFSMState = { }
	bFSMStateNew = false
	bFSMState = false

	qt.clear ( thisEditor, "tblState" )

	qt.setText ( thisEditor, "txtFSMStateName", "NAME OF STATE" )

	populateComboNA ( "cboFSMInitState" )
	populateComboNA ( "cboFSMStateAction" )

	qt.setCurrentIndex ( thisEditor, "cboFSMInitState", 0 )
	qt.setCurrentIndex ( thisEditor, "cboFSMStateAction", 0 )

	treeStateID = qt.insertTreeItem ( thisEditor, "tblState" )
	qt.setTreeItemText ( thisEditor, "tblState", treeStateID, 0, "Dummy" )
	qt.setTreeItemText ( thisEditor, "tblState", treeStateID, 1, "ACT_DummyAction ( objID )" )

	qt.setCurrentIndex ( thisEditor, "tblState", treeStateID )

	qt.setDisabled ( thisEditor, "tblState" )
	qt.setDisabled ( thisEditor, "cboFSMInitState" )
	qt.setDisabled ( thisEditor, "txtFSMStateName" )
	qt.setDisabled ( thisEditor, "cboFSMStateAction" )
	qt.setDisabled ( thisEditor, "btnEditState" )
	qt.setDisabled ( thisEditor, "btnDelState" )
	qt.setDisabled ( thisEditor, "btnCxlState" )
	qt.setDisabled ( thisEditor, "btnSaveState" )

	local iA = getTableLength ( tblActions )
	local iE = getTableLength ( tblEvaluators )

	if ( iA > 0 and iE > 0 ) then
		qt.setText ( thisEditor, "txtFSMMsg", "" )
		qt.setEnabled ( thisEditor, "btnNewState" )
	else
		qt.setDisabled ( thisEditor, "btnNewState" )

		if ( not bInit ) then
			iDialog = 18
			showDialog ( 3, "Sorry, but to create a FINITE STATE MACHINE, there must be at least one ACTION and one EVALUATOR!\n\nPlease create the missing ACTION and/or EVALUATOR, and try again." )
			qt.setFocus ( thisEditor, "tblState" )
		end
	end

	local tT = shallowCopy ( tblFSMTrans )
	setFSMTransDefaults ( )
	tblFSMTrans = shallowCopy ( tT )
end

function populateStates ( )
	local iTmp = 0
	local tmpID = 0
	bFSMStateNew = false
	bFSMState = true
	local iCount = 0

	qt.clear ( thisEditor, "tblState" )

	iTmp = getTableLength ( tblFSMState )

	for x = 3, iTmp, 4 do
		tmpID = qt.insertTreeItem ( thisEditor, "tblState" )
		tblFSMState[x - 1] = tmpID

		qt.setTreeItemText ( thisEditor, "tblState", tmpID, 0, tblFSMState[x] )
		qt.setTreeItemText ( thisEditor, "tblState", tmpID, 1, tblFSMState[x + 1] )
	end

	qt.setCurrentIndex ( thisEditor, "tblState", treeStateID )
	qt.setText ( thisEditor, "txtFSMMsg", "" )

	local tmpTxt = qt.getTreeItemText ( thisEditor, "tblState", 1, 0 )
	local tmpTxt2 = qt.getTreeItemText ( thisEditor, "tblState", 1, 1 )

	qt.setText ( thisEditor, "txtFSMStateName", tmpTxt )

	populateComboActions ( "cboFSMStateAction" )
	setActionComboIdx ( "cboFSMStateAction", tmpTxt2 )

	qt.setEnabled ( thisEditor, "tblState" )
	qt.setEnabled ( thisEditor, "cboFSMInitState" )
	qt.setEnabled ( thisEditor, "btnNewState" )
	qt.setEnabled ( thisEditor, "btnEditState" )
	qt.setEnabled ( thisEditor, "btnDelState" )

	qt.setDisabled ( thisEditor, "txtFSMStateName" )
	qt.setDisabled ( thisEditor, "cboFSMStateAction" )
	qt.setDisabled ( thisEditor, "btnCxlState" )
	qt.setDisabled ( thisEditor, "btnSaveState" )

	populateComboStates ( "cboFSMInitState", "" )

	if ( sFSMInit == "" ) then
		qt.setCurrentIndex ( thisEditor, "cboFSMInitState", 0 )
	else
		setStateComboIdx ( "cboFSMInitState", sFSMInit )
	end

	qt.deselectAllItems ( thisEditor, "tblState" )
	qt.setTreeSelectedItem ( thisEditor, "tblState", treeStateID, 0, 1 )
	qt.setTreeSelectedItem ( thisEditor, "tblState", treeStateID, 1, 1 )
end

function setFSMTransDefaults ( )
	tblFSMTrans = { }
	bFSMTransNew = false
	bFSMTrans = false

	qt.clear ( thisEditor, "tblTransition" )

	populateComboNA ( "cboFSMFromState" )
	populateComboNA ( "cboFSMToState" )
	populateComboNA ( "cboFSMStateEval" )

	qt.setCurrentIndex ( thisEditor, "cboFSMFromState", 0 )
	qt.setCurrentIndex ( thisEditor, "cboFSMToState", 0 )
	qt.setCurrentIndex ( thisEditor, "cboFSMStateEval", 0 )

	treeTransID = qt.insertTreeItem ( thisEditor, "tblTransition" )

	qt.setTreeItemText ( thisEditor, "tblTransition", treeTransID, 0, "Dummy" )
	qt.setTreeItemText ( thisEditor, "tblTransition", treeTransID, 1, "Dummy" )
	qt.setTreeItemText ( thisEditor, "tblTransition", treeTransID, 2, "Evaluators_Dummy" )

	qt.setCurrentIndex ( thisEditor, "tblTransition", treeTransID )

	qt.setDisabled ( thisEditor, "tblTransition" )
	qt.setDisabled ( thisEditor, "cboFSMFromState" )
	qt.setDisabled ( thisEditor, "cboFSMToState" )
	qt.setDisabled ( thisEditor, "cboFSMStateEval" )
	qt.setDisabled ( thisEditor, "btnNewTrans" )
	qt.setDisabled ( thisEditor, "btnEditTrans" )
	qt.setDisabled ( thisEditor, "btnDelTrans" )
	qt.setDisabled ( thisEditor, "btnCxlTrans" )
	qt.setDisabled ( thisEditor, "btnSaveTrans" )
	qt.setDisabled ( thisEditor, "btnFSMCheck" )
end

function populateTrans ( )
	local iTmp = 0
	local tmpID = 0
	local tmpTxt = ""
	bFSMTransNew = false
	local iCount = 0

	qt.clear ( thisEditor, "tblTransition" )

	bFSMTrans = true

	iTmp = getTableLength ( tblFSMTrans )

	for x = 3, iTmp, 5 do
		tmpID = qt.insertTreeItem ( thisEditor, "tblTransition" )
		tblFSMTrans[x - 1] = tmpID

		qt.setTreeItemText ( thisEditor, "tblTransition", tmpID, 0, tblFSMTrans[x] )
		qt.setTreeItemText ( thisEditor, "tblTransition", tmpID, 1, tblFSMTrans[x + 1] )
		qt.setTreeItemText ( thisEditor, "tblTransition", tmpID, 2, tblFSMTrans[x + 2] )
	end

	qt.setCurrentIndex ( thisEditor, "tblTransition", treeTransID )
	qt.setText ( thisEditor, "txtFSMMsg", "" )

	tmpTxt = qt.getTreeItemText ( thisEditor, "tblTransition", treeTransID, 0 )
	local tmpTxt2 = qt.getTreeItemText ( thisEditor, "tblTransition", treeTransID, 1 )
	local tmpTxt3 = qt.getTreeItemText ( thisEditor, "tblTransition", treeTransID, 2 )

	populateComboStates ( "cboFSMFromState" )
	setStateComboIdx ( "cboFSMFromState", tmpTxt )

	populateComboStates ( "cboFSMToState", "" )
	setStateComboIdx ( "cboFSMToState", tmpTxt2 )

	populateComboEvals ( "cboFSMStateEval" )
	setEvalComboIdx ( "cboFSMStateEval", tmpTxt3 )

	qt.setEnabled ( thisEditor, "tblTransition" )
	qt.setEnabled ( thisEditor, "btnNewTrans" )
	qt.setEnabled ( thisEditor, "btnEditTrans" )
	qt.setEnabled ( thisEditor, "btnDelTrans" )
	qt.setEnabled ( thisEditor, "btnFSMCheck" )

	qt.setDisabled ( thisEditor, "cboFSMFromState" )
	qt.setDisabled ( thisEditor, "cboFSMToState" )
	qt.setDisabled ( thisEditor, "cboFSMStateEval" )
	qt.setDisabled ( thisEditor, "btnCxlTrans" )
	qt.setDisabled ( thisEditor, "btnSaveTrans" )
end

function sortActions ( )
	tblTmp = { }
	local tblTmp2 = { }
	local iCount = 1
	local iTmpRow = treeActionID

	for x = 1, getTableLength ( tblActions ), 7 do
		tblTmp[iCount] = tblActions[x + 2]
		iCount = iCount + 1
	end

	bubbleSort ( tblTmp )

	iCount = 0

	for k, v in pairs ( tblTmp ) do
		for k1, v1 in pairs ( tblActions ) do
			if ( v == v1 ) then
				tblTmp2[k * 7 - 6] = tblActions[k1 - 2]
				tblTmp2[k * 7 - 5] = tblActions[k1 - 1]
				tblTmp2[k * 7 - 4] = tblActions[k1]
				tblTmp2[k * 7 - 3] = tblActions[k1 + 1]
				tblTmp2[k * 7 - 2] = tblActions[k1 + 2]
				tblTmp2[k * 7 - 1] = tblActions[k1 + 3]
				tblTmp2[k * 7] = tblActions[k1 + 4]

				if ( k == iTmpRow ) then
					treeActionID = tblActions[k1 - 1]
				end

				break
			end
		end
	end

	tblActions = shallowCopy ( tblTmp2 )
end

function sortEvaluators ( )
	tblTmp = { }
	local tblTmp2 = { }
	local iCount = 1
	local iTmpRow = treeEvalID

	for x = 1, getTableLength ( tblEvaluators ), 5 do
		tblTmp[iCount] = tblEvaluators[x + 2]
		iCount = iCount + 1
	end

	bubbleSort ( tblTmp )

	iCount = 0

	for k, v in pairs ( tblTmp ) do
		for k1, v1 in pairs ( tblEvaluators ) do
			if ( v == v1 ) then
				tblTmp2[k * 5 - 4] = tblEvaluators[k1 - 2]
				tblTmp2[k * 5 - 3] = tblEvaluators[k1 - 1]
				tblTmp2[k * 5 - 2] = tblEvaluators[k1]
				tblTmp2[k * 5 - 1] = tblEvaluators[k1 + 1]
				tblTmp2[k * 5] = tblEvaluators[k1 + 2]

				if ( k == iTmpRow ) then
					treeEvalID = tblEvaluators[k1 - 1]
				end

				break
			end
		end
	end

	tblEvaluators = shallowCopy ( tblTmp2 )
end

function sortStates ( )
	tblTmp = { }
	local tblTmp2 = { }
	local iCount = 1
	local iTmpRow = treeStateID

	for x = 1, getTableLength ( tblFSMState ), 4 do
		tblTmp[iCount] = tblFSMState[x + 2]
		iCount = iCount + 1
	end

	bubbleSort ( tblTmp )

	iCount = 0

	for k, v in pairs ( tblTmp ) do
		for k1, v1 in pairs ( tblFSMState ) do
			if ( v == v1 ) then
				tblTmp2[k * 4 - 3] = tblFSMState[k1 - 2]
				tblTmp2[k * 4 - 2] = tblFSMState[k1 - 1]
				tblTmp2[k * 4 - 1] = tblFSMState[k1]
				tblTmp2[k * 4] = tblFSMState[k1 + 1]

				if ( k == iTmpRow ) then
					treeStateID = tblFSMState[k1 - 1]
				end

				break
			end
		end
	end

	tblFSMState = shallowCopy ( tblTmp2 )
end

function createAct ( )
	local myFile = io.open ( "actions_code_new.lua", "w" )
	io.output ( myFile )

	local tmpTxt = "--[[\n"
	local tmpTxt2 = ""
	local tmpTxt3 = ""

	tmpTxt = tmpTxt .. copyright ( )
	io.write ( tmpTxt )

	tmpTxt = "sky.include \"action.lua\"\n"
	tmpTxt = tmpTxt .. "sky.include \"blackboard.lua\"\n\n"
	io.write ( tmpTxt )

	tmpTxt = "function act_actions ( objID )\n"
	tmpTxt = tmpTxt .. "\tlocal self = {\n"
	tmpTxt = tmpTxt .. "\t\tact_type = \"action\"\n"
	tmpTxt = tmpTxt .. "\t}\n\n"
	io.write ( tmpTxt )

	for x = 3, getTableLength ( tblActions ), 7 do
		tmpTxt2 = tblActions[x + 2]
		tmpTxt2 = string.gsub ( tmpTxt2, "\r", "" )
		tmpTxt2 = string.gsub ( tmpTxt2, "\n", "\n\t" )
		tmpTxt = "\t" .. tmpTxt2 .. "\n\n"
		io.write ( tmpTxt )

		tmpTxt2 = tblActions[x + 3]
		tmpTxt2 = string.gsub ( tmpTxt2, "\r", "" )
		tmpTxt2 = string.gsub ( tmpTxt2, "\n", "\n\t" )
		tmpTxt = "\t" .. tmpTxt2 .. "\n\n"
		io.write ( tmpTxt )

		tmpTxt2 = tblActions[x + 4]
		tmpTxt2 = string.gsub ( tmpTxt2, "\r", "" )
		tmpTxt2 = string.gsub ( tmpTxt2, "\n", "\n\t" )
		tmpTxt = "\t" .. tmpTxt2 .. "\n\n"
		io.write ( tmpTxt )

		tmpTxt2 = tblActions[x + 1]
		tmpTxt = "\tlocal function " .. tmpTxt2 .. "\n"
		tmpTxt = tmpTxt .. "\t\tlocal tAct = {\n"
		tmpTxt2 = string.gsub ( tmpTxt2, " %( objID %)", "" )
		tmpTxt2 = string.gsub ( tmpTxt2, "ACT_", "act_" )
		tmpTxt2 = string.gsub ( tmpTxt2, "Action", "" )
		tmpTxt = tmpTxt .. "\t\t\tinit = " .. tmpTxt2 .. "Initialize,\n"
		tmpTxt = tmpTxt .. "\t\t\tupd = " .. tmpTxt2 .. "Update,\n"
		tmpTxt = tmpTxt .. "\t\t\tclean = " .. tmpTxt2 .. "CleanUp\n"
		tmpTxt = tmpTxt .. "\t\t}\n\n"
		tmpTxt = tmpTxt .. "\t\treturn actionNew (\n"
		tmpTxt = tmpTxt .. "\t\t\t\"" .. tblActions[x] .. "\",\n"
		tmpTxt = tmpTxt .. "\t\t\ttAct,\n"
		tmpTxt = tmpTxt .. "\t\t\tobjID )\n"
		tmpTxt = tmpTxt .. "\tend\n\n"
		io.write ( tmpTxt )
	end

	tmpTxt = "\treturn {\n"
	tmpTxt = tmpTxt .. "\t\tact_type = \"action\",\n"

	for x = 3, getTableLength ( tblActions ), 7 do
		tmpTxt2 = tblActions[x]
		tmpTxt3 = tblActions[x + 1]
		tmpTxt = tmpTxt .. "\t\tACT_" .. firstToUpper ( tmpTxt2 ) .. " = " .. tmpTxt3 .. ",\n"
	end

	tmpTxt = string.sub ( tmpTxt, 1, -3 )
	tmpTxt = tmpTxt .. "\n\t}\nend"
	io.write ( tmpTxt )
	io.close ( myFile )

	local tTemp = "Actions script successfully created!"
	qt.setText ( thisEditor, "txtStatus", tTemp )
end

function createEval ( )
	local myFile = io.open ( "evaluators_code_new.lua", "w" )
	io.output ( myFile )

	local tmpTxt = "--[[\n"
	local tmpTxt2 = ""
	local tmpTxt3 = ""

	tmpTxt = tmpTxt .. copyright ( )
	io.write ( tmpTxt )

	tmpTxt = "sky.include \"blackboard.lua\"\n\n"
	io.write ( tmpTxt )

	tmpTxt = "local Evaluators = { }\n\n"
	io.write ( tmpTxt )

	tmpTxt = ""

	for x = 3, getTableLength ( tblEvaluators ), 5 do
		tmpTxt = tmpTxt .. tblEvaluators[x + 2] .. "\n\n"
	end

	io.write ( tmpTxt )

	tmpTxt = "return Evaluators"
	io.write ( tmpTxt )
	io.close ( myFile )

	local tTemp = "Evaluators script successfully created!"
	qt.setText ( thisEditor, "txtStatus", tTemp )
end

function createBT ( )
	local myFile = io.open ( "bt_code_new.lua", "w" )
	io.output ( myFile )

	local tmpTxt = "--[[\n"
	local tmpTxt2 = ""
	local tmpTxt3 = ""
	local tmpTxt4 = ""
	local iCount = 0
	local iLenBT = 0

	tmpTxt = tmpTxt .. copyright ( )
	io.write ( tmpTxt )
	io.write ( "\n" )
	io.write ( 'sky.include \"evaluators_code_new.lua\"\n' )
	io.write ( 'sky.include \"behaviortree.lua\"\n' )
	io.write ( 'sky.include \"behaviortreenode.lua\"\n\n' )

	tmpTxt = "function behaviourTree ( objID )\n"
	tmpTxt = tmpTxt .. "\tlocal tree = btNew ( objID )\n"
	tmpTxt = tmpTxt .. "\tlocal node\n"
	tmpTxt = tmpTxt .. "\tlocal child\n\n"
	io.write ( tmpTxt )

	iLenBT = getTableLength ( tblBT )
	tmpTxt2 = tblBT[3]

	if ( tmpTxt2 == "Sequence" ) then
		tmpTxt = "\tnode = tree.BT_CreateSequence ( )\n"
		tmpTxt = tmpTxt .. "\ttree.bt_node_ = node\n\n"
	elseif ( tmpTxt2 == "Selector" ) then
		tmpTxt = "\tnode = tree.BT_CreateSelector ( )\n"
		tmpTxt = tmpTxt .. "\ttree.bt_node_ = node\n\n"
	end

	io.write ( tmpTxt )

	for x = 5, iLenBT, 4 do
		tmpTxt2 = tblBT[x + 2]

		if ( tmpTxt2 == "Sequence" ) then
			tmpTxt = "\tchild = tree.BT_CreateSequence ( )\n"
			tmpTxt = tmpTxt .. "\tnode:BTN_AddChild ( child )\n"
			tmpTxt = tmpTxt .. "\tnode = child\n\n"

			io.write ( tmpTxt )
			iCount = 0
		elseif ( tmpTxt2 == "Selector" ) then
			tmpTxt = "\tchild = tree.BT_CreateSelector ( )\n"
			tmpTxt = tmpTxt .. "\tnode:BTN_AddChild ( child )\n"
			tmpTxt = tmpTxt .. "\tnode = child\n\n"

			io.write ( tmpTxt )
			iCount = 0
		elseif ( tmpTxt2 == "Action" ) then
			tmpTxt3 = tblBT[x + 3]

			for y = 2, getTableLength ( tblActions ), 5 do
				if ( tblActions[y] == tmpTxt3 ) then
					tmpTxt4 = tblActions[y - 1]
					break
				end
			end

			tmpTxt3 = string.gsub ( tblBT[x + 3], "act_", "" )
			tmpTxt = "\tchild = tree.BT_CreateAction ( \"" .. tmpTxt3 .. "\", ACT_" .. tmpTxt3 .. "Action ( objID ) )\n"
			tmpTxt = tmpTxt .. "\tnode:BTN_AddChild ( child )\n"
			tmpTxt = tmpTxt .. "\tnode = child\n\n"
			tmpTxt = tmpTxt .. "\tnode = node:BTN_GetParent ( )\n"
			tmpTxt = tmpTxt .. "\tnode = node:BTN_GetParent ( )\n\n"

			io.write ( tmpTxt )
			iCount = iCount + 1
		elseif ( tmpTxt2 == "Evaluator" ) then
			tmpTxt3 = tblBT[x + 3]

			for y = 2, getTableLength ( tblEvaluators ), 5 do
				if ( tblEvaluators[y] == tmpTxt3 ) then
					tmpTxt4 = tblEvaluators[y - 1]
					break
				end
			end

			tmpTxt3 = string.gsub ( tblBT[x + 3], "act_", "" )
			tmpTxt = "\tchild = tree.BT_CreateCondition ( \"" .. tmpTxt3 .. "\", Evaluator_" .. tmpTxt3 .. " )\n"
			tmpTxt = tmpTxt .. "\tnode:BTN_AddChild ( child )\n"
			tmpTxt = tmpTxt .. "\tnode = child\n\n"
			tmpTxt = tmpTxt .. "\tnode = node:BTN_GetParent ( )\n"
			io.write ( tmpTxt )
			iCount = iCount + 1
		end
	end

	tmpTxt = "\treturn tree\nend"
	io.write ( tmpTxt )
	io.close ( myFile )

	local tTemp = "Behaviour Tree script successfully created!"
	qt.setText ( thisEditor, "txtStatus", tTemp )

end

function createDT ( )
	local myFile = io.open ( "dt_code_new.lua", "w" )
	io.output ( myFile )

	local tmpTxt = "--[[\n"
	local tmpTxt2 = ""
	local tmpTxt3 = ""
	local tmpStartBranch = ""

	tmpTxt = tmpTxt .. copyright ( )
	io.write ( tmpTxt )
	io.write ( "\n" )
	io.write ( 'sky.include \"evaluators_code_new.lua\"\n' )
	io.write ( 'sky.include \"decisionbranch.lua\"\n' )
	io.write ( 'sky.include \"decisiontree.lua\"\n\n' )

	tmpTxt = "function decisionTree ( objID )\n"
	tmpTxt = tmpTxt .. "\tlocal tree = dtNew ( )\n\n"
	io.write ( tmpTxt )

	tblTmp = { }
	local iTmp = 0
	local tmpTxt4 = ""

	for x = 3, getTableLength ( tblDT ), 4 do
		if ( tblDT[x] == "Branch" ) then
			tmpTxt2 = tblDT[x + 1]
			tmpTxt = "\tlocal " .. tmpTxt2 .. "Branch = dbNew ( )\n"
			io.write ( tmpTxt )
		end
	end

	io.write ( "\n" )

	for x = 3, getTableLength ( tblDT ), 4 do
		tmpTxt2 = tblDT[x]
		iTmp = tblDT[x - 1]

		if ( tmpTxt2 == "Branch" ) then
			tmpTxt3 = tblDT[x + 1]
			tmpTxt3 = tmpTxt3 .. "Branch"

			if ( x == 3 ) then
				tmpStartBranch = tmpTxt3
			end

			tmpTxt3 = "\t" .. tmpTxt3

			for y = x - 2, getTableLength ( tblDT ), 4 do
				if ( tblDT[y] == iTmp ) then
					tmpTxt = tmpTxt3 .. ":DB_AddChild ( "

					if ( tblDT[y + 2] == "Branch" ) then
						tmpTxt4 = tblDT[y + 3]
						tmpTxt4 = tmpTxt4 .. "Branch"

						tmpTxt = tmpTxt .. tmpTxt4 .. " )\n"
					else
						tmpTxt4 = tblDT[y + 3]
						tmpTxt4 = "ACT_" .. tmpTxt4 .. "Action ( objID ) )\n"

						tmpTxt = tmpTxt .. tmpTxt4
					end

					io.write ( tmpTxt )
				end
			end

			tmpTxt = tmpTxt3 .. ":DB_SetEvaluator ( \n\t\tfunction ( )\n"
			tmpTxt = tmpTxt .. "\t\t\tif Evaluator_" .. tblDT[x + 1] .. " ( objID ) then\n"
			tmpTxt = tmpTxt .. "\t\t\t\treturn 1\n"
			tmpTxt = tmpTxt .. "\t\t\tend\n\n"
			tmpTxt = tmpTxt .. "\t\t\treturn 2\n"
			tmpTxt = tmpTxt .. "\t\tend )\n\n"
			io.write ( tmpTxt )
		end
	end

	tmpTxt = "\ttree:DT_SetBranch ( " .. tmpStartBranch .. " )\n"
	tmpTxt = tmpTxt .. "\treturn tree\nend"
	io.write ( tmpTxt )
	io.close ( myFile )

	local tTemp = "Decision Tree script successfully created!"
	qt.setText ( thisEditor, "txtStatus", tTemp )
end

function createFSM ( )
	local myFile = io.open ( "fsm_code_new.lua", "w" )
	io.output ( myFile )

	local tmpTxt = "--[[\n"
	local tmpTxt2 = ""
	local tmpTxt3 = ""
	local tmpTxt4 = ""

	tmpTxt = tmpTxt .. copyright ( )
	io.write ( tmpTxt )
	io.write ( "\n" )
	io.write ( 'sky.include \"evaluators_code_new.lua\"\n' )
	io.write ( 'sky.include \"finitestate.lua\"\n' )
	io.write ( 'sky.include \"finitestatemachine.lua\"\n' )
	io.write ( 'sky.include \"finitestatetransitions.lua\"\n\n' )

	tmpTxt = "function finiteStateMachine ( objID )\n"
	tmpTxt = tmpTxt .. "\tlocal fsm = fsmNew ( objID )\n\n"
	io.write ( tmpTxt )

	for x = 3, getTableLength ( tblFSMState ), 4 do
		tmpTxt2 = tblFSMState[x]
		tmpTxt3 = tblFSMState[x + 1] .. "Action"

		tmpTxt = "\tfsm:FSM_AddState ( \"" .. tmpTxt2 .."\", ACT_" .. tmpTxt3 .. " ( objID ) )\n"
		io.write ( tmpTxt )
	end

	tmpTxt = "\n"
	io.write ( tmpTxt )

	for x = 3, getTableLength ( tblFSMTrans ), 5 do
		tmpTxt2 = tblFSMTrans[x]
		tmpTxt3 = tblFSMTrans[x + 1]
		tmpTxt4 = tblFSMTrans[x + 2]

		tmpTxt = "\tfsm:FSM_AddTransition ( \"" .. tmpTxt2 .. "\", \"" .. tmpTxt3 .. "\", Evaluator_" .. tmpTxt4 .. " )\n"
		io.write ( tmpTxt )
	end

	tmpTxt = "\n"
	io.write ( tmpTxt )

	local iFSMInit = qt.getCurrentIndex ( thisEditor, "cboFSMInitState" )
	sFSMInit = qt.getComboItemText ( thisEditor, "cboFSMInitState", iFSMInit )
	tmpTxt = "\tfsm:FSM_SetState ( \"" .. sFSMInit .. "\" )\n\n"
	tmpTxt = tmpTxt .. "\treturn fsm\nend"
	io.write ( tmpTxt )
	io.close ( myFile )

	local tTemp = "Finite State Machine script successfully created!"
	qt.setText ( thisEditor, "txtStatus", tTemp )
end

function checkName ( inType, inTxt )
	local bRet = true

	if ( inType == "A" ) then
		for x = 3, getTableLength ( tblActions ), 7 do
			if ( tblActions[x] == inTxt ) then
				bRet = false
				break
			end
		end
	elseif ( inType == "E" ) then
		for x = 3, getTableLength ( tblEvaluators ), 5 do
			if ( tblEvaluators[x] == inTxt ) then
				bRet = false
				break
			end
		end
	elseif ( inType == "S" ) then
		for x = 3, getTableLength ( tblFSMState ), 4 do
			if ( tblFSMState[x] == inTxt ) then
				bRet = false
				break
			end
		end
	end

	return bRet
end

function copyright ( )
	local tmpText = "\tCopyright (c) 2013 David Young dayoung@goliathdesigns.com\n\n"
	tmpText = tmpText .. "\tThis software is provided 'as-is', without any express or implied\n"
	tmpText = tmpText .. "\twarranty. In no event will the authors be held liable for any damages\n"
	tmpText = tmpText .. "\tarising from the use of this software.\n\n"
	tmpText = tmpText .. "\tPermission is granted to anyone to use this software for any purpose,\n"
	tmpText = tmpText .. "\tincluding commercial applications, and to alter it and redistribute it\n"
	tmpText = tmpText .. "\tfreely, subject to the following restrictions:\n\n"
	tmpText = tmpText .. "\t1. The origin of this software must not be misrepresented you must not\n"
	tmpText = tmpText .. "\tclaim that you wrote the original software. If you use this software\n"
	tmpText = tmpText .. "\tin a product, an acknowledgement in the product documentation would be\n"
	tmpText = tmpText .. "\tappreciated but is not required.\n\n"
	tmpText = tmpText .. "\t2. Altered source versions must be plainly marked as such, and must not be\n"
	tmpText = tmpText .. "\tmisrepresented as being the original software.\n\n"
	tmpText = tmpText .. "\t3. This notice may not be removed or altered from any source\n"
	tmpText = tmpText .. "\tdistribution.\n\n"
	tmpText = tmpText .. "**** Code generated for use in the Skyline Game Engine by the AI_Editor Plug-In ****\n"
	tmpText = tmpText .. "]]\n\n"

	return tmpText
end

function checkStatus ( )
	if ( qt.getText ( thisEditor, "txtStatus" ) ~= "" ) then
		qt.setText ( thisEditor, "txtStatus", "" )
	end
end
