--[[
	Copyright (c) 2013 David Young dayoung@goliathdesigns.com

	This software is provided 'as-is', without any express or implied
	warranty. In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose,
	including commercial applications, and to alter it and redistribute it
	freely, subject to the following restrictions:

	1. The origin of this software must not be misrepresented you must not
	claim that you wrote the original software. If you use this software
	in a product, an acknowledgement in the product documentation would be
	appreciated but is not required.

	2. Altered source versions must be plainly marked as such, and must not be
	misrepresented as being the original software.

	3. This notice may not be removed or altered from any source
	distribution.

**** Code generated for use in the Skyline Game Engine by the AI_Editor Plug-In ****
]]

sky.include "action.lua"
sky.include "blackboard.lua"

function act_actions ( objID )
	local self = {
		act_type = "action"
	}

	local act_DieInitialize = function ( objID )
		return "TERMINATED"
	end

	local act_DieUpdate = function ( objID )
		return "TERMINATED"
	end

	local act_DieCleanUp = function ( objID )
	
	end

	local function ACT_DieAction ( objID )
		local tAct = {
			init = act_DieInitialize,
			upd = act_DieUpdate,
			clean = act_DieCleanUp
		}

		return actionNew (
			"Die",
			tAct,
			objID )
	end

	local act_FleeInitialize = function ( objID )
		return "TERMINATED"
	end

	local act_FleeUpdate = function ( objID )
		return "TERMINATED"
	end

	local act_FleeCleanUp = function ( objID )
		return "TERMINATED"
	end

	local function ACT_FleeAction ( objID )
		local tAct = {
			init = act_FleeInitialize,
			upd = act_FleeUpdate,
			clean = act_FleeCleanUp
		}

		return actionNew (
			"Flee",
			tAct,
			objID )
	end

	local act_IdleInitialize = function ( objID )
		return "TERMINATED"
	end

	local act_IdleUpdate = function ( objID )
		return "TERMINATED"
	end

	local act_IdleCleanUp = function ( objID )
	
	end

	local function ACT_IdleAction ( objID )
		local tAct = {
			init = act_IdleInitialize,
			upd = act_IdleUpdate,
			clean = act_IdleCleanUp
		}

		return actionNew (
			"Idle",
			tAct,
			objID )
	end

	local act_MoveToInitialize = function ( objID )
		return "TERMINATED"
	end

	local act_MoveToUpdate = function ( objID )
		return "TERMINATED"
	end

	local act_MoveToCleanUp = function ( objID )
		return "TERMINATED"
	end

	local function ACT_MoveToAction ( objID )
		local tAct = {
			init = act_MoveToInitialize,
			upd = act_MoveToUpdate,
			clean = act_MoveToCleanUp
		}

		return actionNew (
			"MoveTo",
			tAct,
			objID )
	end

	local act_PursueInitialize = function ( objID )
		return "TERMINATED"
	end

	local act_PursueUpdate = function ( objID )
		return "TERMINATED"
	end

	local act_PursueCleanUp = function ( objID )
		return "TERMINATED"
	end

	local function ACT_PursueAction ( objID )
		local tAct = {
			init = act_PursueInitialize,
			upd = act_PursueUpdate,
			clean = act_PursueCleanUp
		}

		return actionNew (
			"Pursue",
			tAct,
			objID )
	end

	local act_RandomMoveInitialize = function ( objID )
		return "TERMINATED"
	end

	local act_RandomMoveUpdate = function ( objID )
		return "TERMINATED"
	end

	local act_RandomMoveCleanUp = function ( objID )
	
	end

	local function ACT_RandomMoveAction ( objID )
		local tAct = {
			init = act_RandomMoveInitialize,
			upd = act_RandomMoveUpdate,
			clean = act_RandomMoveCleanUp
		}

		return actionNew (
			"RandomMove",
			tAct,
			objID )
	end

	local act_ReloadInitialize = function ( objID )
		return "TERMINATED"
	end

	local act_ReloadUpdate = function ( objID )
		return "TERMINATED"
	end

	local act_ReloadCleanUp = function ( objID )
		return "TERMINATED"
	end

	local function ACT_ReloadAction ( objID )
		local tAct = {
			init = act_ReloadInitialize,
			upd = act_ReloadUpdate,
			clean = act_ReloadCleanUp
		}

		return actionNew (
			"Reload",
			tAct,
			objID )
	end

	local act_ShootInitialize = function ( objID )
		return "TERMINATED"
	end

	local act_ShootUpdate = function ( objID )
		return "TERMINATED"
	end

	local act_ShootCleanUp = function ( objID )
		return "TERMINATED"
	end

	local function ACT_ShootAction ( objID )
		local tAct = {
			init = act_ShootInitialize,
			upd = act_ShootUpdate,
			clean = act_ShootCleanUp
		}

		return actionNew (
			"Shoot",
			tAct,
			objID )
	end

	return {
		act_type = "action",
		ACT_Die = ACT_DieAction ( objID ),
		ACT_Flee = ACT_FleeAction ( objID ),
		ACT_Idle = ACT_IdleAction ( objID ),
		ACT_MoveTo = ACT_MoveToAction ( objID ),
		ACT_Pursue = ACT_PursueAction ( objID ),
		ACT_RandomMove = ACT_RandomMoveAction ( objID ),
		ACT_Reload = ACT_ReloadAction ( objID ),
		ACT_Shoot = ACT_ShootAction ( objID )
	}
end