--[[
	Copyright (c) 2013 David Young dayoung@goliathdesigns.com

	This software is provided 'as-is', without any express or implied
	warranty. In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose,
	including commercial applications, and to alter it and redistribute it
	freely, subject to the following restrictions:

	1. The origin of this software must not be misrepresented you must not
	claim that you wrote the original software. If you use this software
	in a product, an acknowledgement in the product documentation would be
	appreciated but is not required.

	2. Altered source versions must be plainly marked as such, and must not be
	misrepresented as being the original software.

	3. This notice may not be removed or altered from any source
	distribution.

**** Code rewritten for use in the Skyline Game Engine by SpinalSoft (AU) 2017 ****
]]

function btnNew ( name, inType )
	local self = {
		btn_action_,
		btn_children_ = { },
		btn_evaluator_,
		btn_name_ = name or "",
		btn_parent_,
		btn_type_ = inType or "ACTION"
	}

	local btn_addChild = function ( self, child, index )
		index = index or ( #self.btn_children_ + 1 )
		table.insert ( self.btn_children_, index, child )
		child.btn_parent_ = self
	end

	local btn_childIndex = function ( self, inChild )
		for index = 1, #self.btn_children_ do
			if ( self.btn_children_[index] == inChild ) then
				return index
			end
		end

		return -1
	end

	local btn_getChild = function ( self, childIndex )
		return self.btn_children_[childIndex]
	end

	local btn_getNumberOfChildren = function ( self )
		return #self.btn_children_
	end

	local btn_getParent = function ( self )
		return self.btn_parent_
	end

	local btn_setAction = function ( self, action )
		self.btn_action_ = action
	end

	local btn_setEvaluator = function ( self, evaluator )
		self.btn_evaluator_ = evaluator
	end

	local btn_setType = function ( self, inType )
		self.btn_type_ = inType
	end

	return {
		btn_action_,
		btn_children_ = { },
		btn_evaluator_,
		btn_name_ = name or "",
		btn_parent_,
		btn_type_ = inType or "ACTION",

		BTN_AddChild = btn_addChild,
		BTN_ChildIndex = btn_childIndex,
		BTN_GetChild = btn_getChild,
		BTN_GetNumberOfChildren = btn_getNumberOfChildren,
		BTN_GetParent = btn_getParent,
		BTN_SetAction = btn_setAction,
		BTN_SetEvaluator = btn_setEvaluator,
		BTN_SetType = btn_setType
	}
end