--[[
	Copyright (c) 2013 David Young dayoung@goliathdesigns.com

	This software is provided 'as-is', without any express or implied
	warranty. In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose,
	including commercial applications, and to alter it and redistribute it
	freely, subject to the following restrictions:

	1. The origin of this software must not be misrepresented you must not
	claim that you wrote the original software. If you use this software
	in a product, an acknowledgement in the product documentation would be
	appreciated but is not required.

	2. Altered source versions must be plainly marked as such, and must not be
	misrepresented as being the original software.

	3. This notice may not be removed or altered from any source
	distribution.

**** Code rewritten for use in the Skyline Game Engine by SpinalSoft (AU) 2017 ****
]]

local bb = { }

function bb_Initialise ( )
	bb_Clear ( )
end

function bb_Set ( bbID, bbType, bbValue )
	local tmpBB = sky.getTable ( "gbb" )
	local typExists = false

	for k, v in pairs ( tmpBB ) do
		if ( tonumber ( v["id"] ) == bbID ) then
			for kk, vv in pairs ( v ) do
				if ( vv["typ"] == bbType ) then
					vv["val"] = bbValue
					typExists = true
				end
			end
		end
	end

	if ( not typExists ) then
		local tmpLocalBB = { id = bbID, values = { typ = bbType, val = bbValue } }

		table.insert ( tmpBB, tmpLocalBB )
	end

	sky.setTable ( "gbb", tmpBB )
end

function bb_Get ( bbID, bbType )
	local tmpBB = sky.getTable ( "gbb" )

	for k, v in pairs ( tmpBB ) do
		if ( tonumber ( v["id"] ) == bbID ) then
			for kk, vv in pairs ( v ) do
				if ( vv["typ"] == bbType ) then
					return true, vv["val"]
				end
			end
		end
	end

	return false, 0
end

function bb_Clear ( )
	local tmpBB = { }
	local tblTmp = { id = 0, values = { typ = "Dummy", val = 0 } }

	table.insert ( tmpBB, tblTmp )
	sky.setTable ( "gbb", tmpBB )
end

function bb_Delete ( bbID, bbType )
	local tmpBB = sky.getTable ( "gbb" )

	for k, v in pairs ( tmpBB ) do
		if ( tonumber ( v["id"] ) == bbID ) then
			for kk, vv in pairs ( v ) do
				if ( vv["typ"] == bbType ) then
					table.remove ( tmpBB, tmpIdx )
					sky.setTable ( "gbb", tmpBB )

					return true
				end
			end
		end
	end

	return false
end

return bb