--[[
	Copyright (c) 2013 David Young dayoung@goliathdesigns.com

	This software is provided 'as-is', without any express or implied
	warranty. In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose,
	including commercial applications, and to alter it and redistribute it
	freely, subject to the following restrictions:

	1. The origin of this software must not be misrepresented you must not
	claim that you wrote the original software. If you use this software
	in a product, an acknowledgement in the product documentation would be
	appreciated but is not required.

	2. Altered source versions must be plainly marked as such, and must not be
	misrepresented as being the original software.

	3. This notice may not be removed or altered from any source
	distribution.

**** Code rewritten for use in the Skyline Game Engine by SpinalSoft (AU) 2015 ****
]]

sky.include "action.lua"
sky.include "decisionbranch.lua"

function dtNew ( )
	local self = {
		dt_branch_ = nil,
		dt_currentAction_ = nil
	}

	local dt_setBranch = function ( self, branch )
		self.dt_branch_ = branch
	end

	local dt_update = function ( self, deltaTimeInMillis )
		if ( self.dt_branch_ == nil ) then
			return
		end

		if ( self.dt_currentAction_ == nil ) then
			self.dt_currentAction_ = self.dt_branch_:DB_Evaluate ( )
			self.dt_currentAction_:ACT_Initialize ( objID )
		end

		local status = self.dt_currentAction_:ACT_Update ( objID, deltaTimeInMillis )

		if ( status == "TERMINATED" ) then
			self.dt_currentAction_:ACT_CleanUp ( objID )
			self.dt_currentAction_ = nil
		end
	end

	return {
		dt_branch_ = nil,
		dt_currentAction_ = nil,

		DT_SetBranch = dt_setBranch,
		DT_Update = dt_update
	}
end