--[[
	Copyright (c) 2013 David Young dayoung@goliathdesigns.com

	This software is provided 'as-is', without any express or implied
	warranty. In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose,
	including commercial applications, and to alter it and redistribute it
	freely, subject to the following restrictions:

	1. The origin of this software must not be misrepresented you must not
	claim that you wrote the original software. If you use this software
	in a product, an acknowledgement in the product documentation would be
	appreciated but is not required.

	2. Altered source versions must be plainly marked as such, and must not be
	misrepresented as being the original software.

	3. This notice may not be removed or altered from any source
	distribution.

**** Code generated for use in the Skyline Game Engine by the AI_Editor Plug-In ****
]]

sky.include “evaluators_code_new.lua”
sky.include “finitestate.lua”
sky.include “finitestatemachine.lua”
sky.include “finitestatetransitions.lua”

function finiteStateMachine ( objID )
	local fsm = fsmNew ( objID )

	fsm:FSM_AddState ( "die", ACT_DieAction ( objID ) )
	fsm:FSM_AddState ( "flee", ACT_FleeAction ( objID ) )
	fsm:FSM_AddState ( "idle", ACT_IdleAction ( objID ) )
	fsm:FSM_AddState ( "moveTo", ACT_MoveToAction ( objID ) )
	fsm:FSM_AddState ( "pursue", ACT_PursueAction ( objID ) )
	fsm:FSM_AddState ( "randomMove", ACT_RandomMoveAction ( objID ) )
	fsm:FSM_AddState ( "reload", ACT_ReloadAction ( objID ) )
	fsm:FSM_AddState ( "shoot", ACT_ShootAction ( objID ) )

	fsm:FSM_AddTransition ( "idle", "die", Evaluator_IsNotAlive )
	fsm:FSM_AddTransition ( "idle", "flee", Evaluator_HasCriticalHealth )
	fsm:FSM_AddTransition ( "idle", "reload", Evaluator_HasNoAmmo )
	fsm:FSM_AddTransition ( "idle", "shoot", Evaluator_CanShootEnemy )
	fsm:FSM_AddTransition ( "idle", "pursue", Evaluator_HasEnemy )
	fsm:FSM_AddTransition ( "idle", "randomMove", Evaluator_Random )
	fsm:FSM_AddTransition ( "idle", "idle", Evaluator_HasNoEnemy )
	fsm:FSM_AddTransition ( "moveTo", "die", Evaluator_IsNotAlive )
	fsm:FSM_AddTransition ( "moveTo", "flee", Evaluator_HasCriticalHealth )
	fsm:FSM_AddTransition ( "moveTo", "reload", Evaluator_HasNoAmmo )
	fsm:FSM_AddTransition ( "moveTo", "shoot", Evaluator_CanShootEnemy )
	fsm:FSM_AddTransition ( "moveTo", "pursue", Evaluator_HasEnemy )
	fsm:FSM_AddTransition ( "moveTo", "moveTo", Evaluator_HasMovePosition )
	fsm:FSM_AddTransition ( "moveTo", "randomMove", Evaluator_Random )
	fsm:FSM_AddTransition ( "moveTo", "idle", Evaluator_HasNoEnemy )
	fsm:FSM_AddTransition ( "randomMove", "die", Evaluator_IsNotAlive )
	fsm:FSM_AddTransition ( "randomMove", "moveTo", Evaluator_HasMovePosition )
	fsm:FSM_AddTransition ( "shoot", "die", Evaluator_IsNotAlive )
	fsm:FSM_AddTransition ( "shoot", "flee", Evaluator_HasCriticalHealth )
	fsm:FSM_AddTransition ( "shoot", "reload", Evaluator_HasNoAmmo )
	fsm:FSM_AddTransition ( "shoot", "pursue", Evaluator_HasEnemy )
	fsm:FSM_AddTransition ( "shoot", "randomMove", Evaluator_Random )
	fsm:FSM_AddTransition ( "shoot", "idle", Evaluator_HasNoEnemy )
	fsm:FSM_AddTransition ( "flee", "die", Evaluator_IsNotAlive )
	fsm:FSM_AddTransition ( "pursue", "die", Evaluator_IsNotAlive )
	fsm:FSM_AddTransition ( "pursue", "flee", Evaluator_HasCriticalHealth )
	fsm:FSM_AddTransition ( "pursue", "shoot", Evaluator_CanShootEnemy )
	fsm:FSM_AddTransition ( "pursue", "idle", Evaluator_HasNoEnemy )
	fsm:FSM_AddTransition ( "reload", "die", Evaluator_IsNotAlive )
	fsm:FSM_AddTransition ( "reload", "shoot", Evaluator_CanShootEnemy )
	fsm:FSM_AddTransition ( "reload", "pursue", Evaluator_HasEnemy )
	fsm:FSM_AddTransition ( "reload", "randomMove", Evaluator_Random )
	fsm:FSM_AddTransition ( "reload", "idle", Evaluator_HasNoEnemy )

	fsm:FSM_SetState ( "shoot" )

	return fsm
end