-- ****************************************
-- **      AI STEERING BEHAVIOURS        **
-- **        DYNAMIC PROPERTIES          **
-- **                                    **
-- ** Copyright (c) 2017 SpinalSoft (AU) **
-- ****************************************
ai_on = false
ai_maxVelocity = newType.vec3 ( 0.0, 0.0, 0.0 )
sky.include "ai_steer_test.lua"

--[[HeaderImage|Skyline_AI_System_Test_Header.png]]
--[[Prop|int#0,99,1]]					ai_team							=	1
--[[Prop|float#0,999,5]]				ai_maxVelocityX					=	10.00
--[[Prop|float#0,999,5]]				ai_maxVelocityY					=	0.00
--[[Prop|float#0,999,5]]				ai_maxVelocityZ					=	10.00
--[[Prop|float#0,999,5]]				ai_maxForce						=	10.00
--[[Prop|float#0,999,5]]				ai_mass							=	100.00
--[[Prop|float#0,10,0.5]] 				ai_runFactor					=	1.50
--[[Prop|Header]]						Wander							=	""
--[[Prop|bool]]							chkWander						=	"true"
--[[Prop|float#0,1,0.1]]				ai_wanderWeight					=	1.00
--[[Prop|float#0,999,5]]				ai_wanderRadius					=	25.00
--[[Prop|int#1,3,1]]					ai_wanderFlag					=	2
--[[Prop|float#0,999,5]]				ai_wanderAOE					=	30.00
--[[Prop|Header]]						seek_header						=	"Seek"
--[[Prop|bool]]							chkSeek							=	"false"
--[[Prop|combo#tag]]					ai_seekObject					=	""
--[[Prop|float#0,999,5]]				ai_seekRadius					=	2.00
--[[Prop|float#0,1,0.1]]				ai_seekWeight					=	1.00
--[[Prop|Header]]						flee_header						=	"Flee"
--[[Prop|bool]]							chkFlee							=	"false"
--[[Prop|combo#tag]]					ai_fleeObject					=	""
--[[Prop|float#0,1,0.1]]				ai_fleeWeight					=	1.00
--[[Prop|float#0,999,5]]				ai_fleePanicDistance			=	10.00
--[[Prop|float#0,999,5]]				ai_fleeRelaxDistance			=	30.00
--[[Prop|Header]]						pursue_header					=	"Pursue"
--[[Prop|bool]]							chkPursue						=	"false"
--[[Prop|combo#tag]]					ai_pursueObject					=	""
--[[Prop|float#0,999,5]]				ai_pursueRadius					=	2.00
--[[Prop|float#0,1,0.1]]				ai_pursueWeight					=	1.00
--[[Prop|Header]]						evade_header					=	"Evade"
--[[Prop|bool]]							chkEvade						=	"false"
--[[Prop|combo#tag]]					ai_evadeObject					=	""
--[[Prop|float#0,1,0.1]]				ai_evadeWeight					=	1.00
--[[Prop|float#0,999,5]]				ai_evadePanicDistance			=	10.00
--[[Prop|float#0,999,5]]				ai_evadeRelaxDistance			=	30.00
--[[Prop|Header]]						follow_header					=	"Follow"
--[[Prop|bool]]							chkFollow						=	"false"
--[[Prop|combo#tag]]					ai_followObject					=	""
--[[Prop|float#0,999,5]]				ai_followArriveRadius			=	10.00
--[[Prop|float#0,999,5]]				ai_followBehindDistance			=	2.00
--[[Prop|float#0,999,5]]				ai_followSeparationRadius		=	2.00
--[[Prop|float#0,999,5]]				ai_followMaxSeparation			=	5.00
--[[Prop|float#0,999,5]]				ai_followSightRadius			=	2.00
--[[Prop|float#0,1,0.1]]				ai_followWeight					=	1.00
--[[Prop|Header]]						arrival_header					=	"Arrival"
--[[Prop|bool]]							chkArrival						=	"false"
--[[Prop|float#0,999,5]]				ai_arrivalDistance				=	20.00
--[[Prop|float#0,999,5]]				ai_arrivalStop					=	5.00
--[[Prop|Header]]						obstacle_header					=	"Obstacle Avoidance"
--[[Prop|bool]]							chkObstacle						=	"false"
--[[Prop|float#0,999,5]]				ai_obstacleAvoidFeelerLength	=	10.00
--[[Prop|float#0,1,0.1]]				ai_obstacleAvoidWeight			=	5.00

-- | This is used to grab the properties at game start time.
function SetupDynamicValues( id )
	ai_team = tonumber ( entity.getDynamicProperty ( id, "ai_team" ) )
	ai_maxVelocity.x = tonumber ( entity.getDynamicProperty ( id, "ai_maxVelocityX" ) )
	ai_maxVelocity.y = tonumber ( entity.getDynamicProperty ( id, "ai_maxVelocityY" ) )
	ai_maxVelocity.z = tonumber ( entity.getDynamicProperty ( id, "ai_maxVelocityZ" ) )
	ai_maxForce = tonumber ( entity.getDynamicProperty ( id, "ai_maxForce" ) )
	ai_mass = tonumber ( entity.getDynamicProperty ( id, "ai_mass" ) )
	ai_runFactor = tonumber ( entity.getDynamicProperty ( id, "ai_runFactor" ) )
	chkWander = tonumber ( entity.getDynamicProperty ( id, "chkWander" ) )
	ai_wanderWeight = tonumber ( entity.getDynamicProperty ( id, "ai_wanderWeight" ) )
	ai_wanderRadius = tonumber ( entity.getDynamicProperty ( id, "ai_wanderRadius" ) )
	ai_wanderFlag = tonumber ( entity.getDynamicProperty ( id, "ai_wanderFlag" ) )
	ai_wanderAOE = tonumber ( entity.getDynamicProperty ( id, "ai_wanderAOE" ) )
	chkEvade = tonumber ( entity.getDynamicProperty ( id, "chkEvade" ) )
	ai_evadeObj = entity.getIDFromTag ( entity.getDynamicProperty ( id, "ai_evadeObject" ) )
	ai_evadeWeight = tonumber ( entity.getDynamicProperty ( id, "ai_evadeWeight" ) )
	ai_evadePanicDistance = tonumber ( entity.getDynamicProperty ( id, "ai_evadePanicDistance" ) )
	ai_evadeRelaxDistance = tonumber ( entity.getDynamicProperty ( id, "ai_evadeRelaxDistance" ) )
	chkFlee = tonumber ( entity.getDynamicProperty ( id, "chkFlee" ) )
	ai_fleeObj = entity.getIDFromTag ( entity.getDynamicProperty ( id, "ai_fleeObject" ) )
	ai_fleeWeight = tonumber ( entity.getDynamicProperty ( id, "ai_fleeWeight" ) )
	ai_fleePanicDistance = tonumber ( entity.getDynamicProperty ( id, "ai_fleePanicDistance" ) )
	ai_fleeRelaxDistance = tonumber ( entity.getDynamicProperty ( id, "ai_fleeRelaxDistance" ) )
	chkSeek = tonumber ( entity.getDynamicProperty ( id, "chkSeek" ) )
	ai_seekObj = tonumber ( entity.getDynamicProperty ( id, "ai_seekObject" ) )
	ai_seekRadius = tonumber ( entity.getDynamicProperty ( id, "ai_seekRadius" ) )
	ai_seekWeight = tonumber ( entity.getDynamicProperty ( id, "ai_seekWeight" ) )
	chkPursue = tonumber ( entity.getDynamicProperty ( id, "chkPursue" ) )
	ai_pursueObj = entity.getIDFromTag ( entity.getDynamicProperty ( id, "ai_pursueObject" ) )
	ai_pursueRadius = tonumber ( entity.getDynamicProperty ( id, "ai_pursueRadius" ) )
	ai_pursueWeight = tonumber ( entity.getDynamicProperty ( id, "ai_pursueWeight" ) )
	chkFollow = tonumber ( entity.getDynamicProperty ( id, "chkFollow" ) )
	ai_followObj = entity.getIDFromTag ( entity.getDynamicProperty ( id, "ai_followObject" ) )
	ai_followArriveRadius = tonumber ( entity.getDynamicProperty ( id, "ai_followArriveRadius" ) )
	ai_followBehindDistance = tonumber ( entity.getDynamicProperty ( id, "ai_followBehindDistance" ) )
	ai_followSeparationRadius = tonumber ( entity.getDynamicProperty ( id, "ai_followSeparationRadius" ) )
	ai_followMaxSeparation = tonumber ( entity.getDynamicProperty ( id, "ai_followMaxSeparation" ) )
	ai_followSightRadius = tonumber ( entity.getDynamicProperty ( id, "ai_followSightRadius" ) )
	ai_followWeight = tonumber ( entity.getDynamicProperty ( id, "ai_followWeight" ) )
	chkArrival = tonumber ( entity.getDynamicProperty ( id, "chkArrival" ) )
	ai_arrivalDistance = tonumber ( entity.getDynamicProperty ( id, "ai_arrivalDistance" ) )
	ai_arrivalStop = tonumber ( entity.getDynamicProperty ( id, "ai_arrivalStop" ) )
	chkObstacle = tonumber ( entity.getDynamicProperty ( id, "chkObstacle" ) )
	ai_obstacleAvoidFeeler = tonumber ( entity.getDynamicProperty ( id, "ai_obstacleAvoidFeelerLength" ) )
	ai_obstacleAvoidWeight = tonumber ( entity.getDynamicProperty ( id, "ai_obstacleAvoidWeight" ) )
end

-- | This will update the property edited only when its is tweaked. This saves having to call
-- | the above function in the onUpdate loop which would slow things down.
-- | Parameter Types:::: >>> (eID = int), (param = string), (value = string)
-- | This means you will need to convert the string to a number as lua sometimes fails in its typecasting
function SetDynamicProperty( eID, param, value )
	--sky.lprint("eID: "..param.."param: "..param.." value: "..value)

	if ( param == "ai_team" ) then
		ai_team = tonumber ( value )

		return
	end

	if ( param == "ai_maxVelocityX" ) then
		ai_maxVelocity.x = tonumber ( value )

		return
	end

	if ( param == "ai_maxVelocityY" ) then
		ai_maxVelocity.y = tonumber ( value )

		return
	end

	if ( param == "ai_maxVelocityZ" ) then
		ai_maxVelocity.z = tonumber ( value )

		return
	end

	if ( param == "ai_maxForce" ) then
		ai_maxForce = tonumber ( value )

		return
	end

	if ( param == "ai_mass" ) then
		ai_mass = tonumber ( value )

		return
	end

	if ( param == "ai_runFactor" ) then
		ai_runFactor = tonumber ( value )

		return
	end

	if ( param == "chkWander" ) then
		chkWander = tonumber ( value )

		if ( chkWander == 1 ) then
			if ( not ai_on ) then
				ai_init ( obj )
			end

			aiWander ( )
		else
			if ( chkWander == 0 and chkEvade == 0 and chkFlee == 0 and chkSeek == 0 and chkPursue == 0 and chkFollow == 0 and chkArrival == 0 and chkObstacle == 0 ) then
				ai_on = false
			end

			aiTurnOff ( "ai_wander" )
		end

		return
	end

	if ( param == "ai_wanderWeight" ) then
		ai_wanderWeight = tonumber ( value )

		return
	end

	if ( param == "ai_wanderRadius" ) then
		ai_wanderRadius = tonumber ( value )

		return
	end

	if ( param == "ai_wanderFlag" ) then
		ai_wanderFlag = tonumber ( value )

		return
	end

	if ( param == "ai_wanderAOE" ) then
		ai_wanderAOE = tonumber ( value )

		return
	end

	if ( param == "chkEvade" ) then
		chkEvade = tonumber ( value )

		if ( chkEvade == 1 ) then
			if ( not ai_on ) then
				ai_init ( obj )
			end

			aiEvade ( )
		else
			if ( chkWander == 0 and chkEvade == 0 and chkFlee == 0 and chkSeek == 0 and chkPursue == 0 and chkFollow == 0 and chkArrival == 0 and chkObstacle == 0 ) then
				ai_on = false
			end

			aiTurnOff ( "ai_evade" )
		end

		return
	end

	if ( param == "ai_evadeObject" ) then
		ai_evadeObj = entity.getIDFromTag ( value )

		return
	end

	if ( param == "ai_evadeWeight" ) then
		ai_evadeWeight = tonumber ( value )

		return
	end

	if ( param == "ai_evadePanicDistance" ) then
		ai_evadePanicDistance = tonumber ( value )

		return
	end

	if ( param == "ai_evadeRelaxDistance" ) then
		ai_evadeRelaxDistance = tonumber ( value )

		return
	end

	if ( param == "chkFlee" ) then
		chkFlee = tonumber ( value )

		if ( chkFlee == 1 ) then
			if ( not ai_on ) then
				ai_init ( obj )
			end

			aiFlee ( )
		else
			if ( chkWander == 0 and chkEvade == 0 and chkFlee == 0 and chkSeek == 0 and chkPursue == 0 and chkFollow == 0 and chkArrival == 0 and chkObstacle == 0 ) then
				ai_on = false
			end

			aiTurnOff ( "ai_flee" )
		end

		return
	end

	if ( param == "ai_fleeObject" ) then
		ai_fleeObj = entity.getIDFromTag ( value )

		return
	end

	if ( param == "ai_fleeWeight" ) then
		ai_fleeWeight = tonumber ( value )

		return
	end

	if ( param == "ai_fleePanicDistance" ) then
		ai_fleePanicDistance = tonumber ( value )

		return
	end

	if ( param == "ai_fleeRelaxDistance" ) then
		ai_fleeRelaxDistance = tonumber ( value )

		return
	end

	if ( param == "chkSeek" ) then
		chkSeek = tonumber ( value )

		if ( chkSeek == 1 ) then
			if ( not ai_on ) then
				ai_init ( obj )
			end

			aiSeek ( )
		else
			if ( chkWander == 0 and chkEvade == 0 and chkFlee == 0 and chkSeek == 0 and chkPursue == 0 and chkFollow == 0 and chkArrival == 0 and chkObstacle == 0 ) then
				ai_on = false

				aiTurnOff ( "ai_seek" )
			end
		end

		return
	end

	if ( param == "ai_seekObject" ) then
		ai_seekObj = entity.getIDFromTag ( value )

		return
	end
	if ( param == "ai_seekRadius" ) then
		ai_seekRadius = tonumber ( value )

		return
	end

	if ( param == "ai_seekWeight" ) then
		ai_seekWeight = tonumber ( value )

		return
	end

	if ( param == "chkPursue" ) then
		chkPursue = tonumber ( value )

		if ( chkPursue == 1 ) then
			if ( not ai_on ) then
				ai_init ( obj )
			end

			aiPursue ( )
		else
			if ( chkWander == 0 and chkEvade == 0 and chkFlee == 0 and chkSeek == 0 and chkPursue == 0 and chkFollow == 0 and chkArrival == 0 and chkObstacle == 0 ) then
				ai_on = false

				aiTurnOff ( "ai_pursue" )
			end
		end

		return
	end

	if ( param == "ai_pursueObject" ) then
		ai_pursueObj = entity.getIDFromTag ( value )

		return
	end

	if ( param == "ai_pursueRadius" ) then
		ai_pursueRadius = tonumber ( value )

		return
	end

	if ( param == "ai_pursueWeight" ) then
		ai_pursueWeight = tonumber ( value )

		return
	end

	if ( param == "chkFollow" ) then
		chkFollow = tonumber ( value )

		if ( chkFollow == 1 ) then
			if ( not ai_on ) then
				ai_init ( obj )
			end

			aiFollow ( )
		else
			if ( chkWander == 0 and chkEvade == 0 and chkFlee == 0 and chkSeek == 0 and chkPursue == 0 and chkFollow == 0 and chkArrival == 0 and chkObstacle == 0 ) then
				ai_on = false

				aiTurnOff ( "ai_follow" )
			end
		end

		return
	end

	if ( param == "ai_followObject" ) then
		ai_followObj = entity.getIDFromTag ( value )

		return
	end

	if ( param == "ai_followArriveRadius" ) then
		ai_followArriveRadius = tonumber ( value )

		return
	end

	if ( param == "ai_followBehindDistance" ) then
		ai_followBehindDistance = tonumber ( value )

		return
	end

	if ( param == "ai_followSeparationRadius" ) then
		ai_followSeparationRadius = tonumber ( value )

		return
	end

	if ( param == "ai_followMaxSeparation" ) then
		ai_followMaxSeparation = tonumber ( value )

		return
	end

	if ( param == "ai_followSightRadius" ) then
		ai_followSightRadius = tonumber ( value )

		return
	end

	if ( param == "ai_followWeight" ) then
		ai_followWeight = tonumber ( value )

		return
	end

	if ( param == "chkArrival" ) then
		chkArrival = tonumber ( value )

		if ( chkArrival == 1 ) then
			if ( not ai_on ) then
				ai_init ( obj )
			end

			aiArrival ( )
		else
			if ( chkWander == 0 and chkEvade == 0 and chkFlee == 0 and chkSeek == 0 and chkPursue == 0 and chkFollow == 0 and chkArrival == 0 and chkObstacle == 0 ) then
				ai_on = false

				aiTurnOff ( "ai_arrival" )
			end
		end
	
		return
	end

	if ( param == "ai_arrivalDistance" ) then
		ai_arrivalDistance = tonumber ( value )

		return
	end

	if ( param == "ai_arrivalStop" ) then
		ai_arrivalStop = tonumber ( value )

		return
	end

	if ( param == "chkObstacle" ) then
		chkObstacle = tonumber ( value )

		if ( chkObstacle == 1 ) then
			if ( not ai_on ) then
				ai_init ( obj )
			end

			aiObstacleAvoid ( )
		else
			if ( chkWander == 0 and chkEvade == 0 and chkFlee == 0 and chkSeek == 0 and chkPursue == 0 and chkFollow == 0 and chkArrival == 0 and chkObstacle == 0 ) then
				ai_on = false

				aiTurnOff ( "ai_obstacleavoid" )
			end
		end

		return
	end

	if ( param == "ai_obstacleAvoidFeelerLength" ) then
		ai_obstacleAvoidFeeler = tonumber ( value )

		return
	end

	if ( param == "ai_obstacleAvoidWeight" ) then
		ai_obstacleAvoidWeight = tonumber ( value )

		return
	end
end

sky.include "actions_entity.lua"
sky.include "blackboard.lua"
sky.include "decisiontree.lua"
sky.include "decisionbranch.lua"
sky.include "evaluators_entity.lua"

rayID = 0
obj = -1

function onInit ( objID )
	obj = objID
end

function postInit ( )
	SetupDynamicValues(obj)

	bb_Set ( obj, "targetid", -1 )
	bb_Set ( obj, "team", ai_team )

	--	myActions = act_actions ( obj )
	--	myLogic = decisionTree ( obj )

	if ( chkWander == 1 or chkEvade == 1 or chkFlee == 1 or chkSeek == 1 or chkPursue == 1 or chkFollow == 1 or chkArrival == 1 or chkObstacle == 1 ) then
		ai_on = true

		aiInit ( obj )

		if ( chkWander == 1 ) then
			aiWander ( )
		end

		if ( chkEvade == 1 ) then
			aiEvade ( )
		end

		if ( chkFlee == 1 ) then
			aiFlee ( )
		end

		if ( chkSeek == 1 ) then
			aiSeek ( )
		end

		if ( chkPursue == 1 ) then
			aiPursue ( )
		end

		if ( chkFollow == 1 ) then
			aiFollow ( )
		end

		-- ARRIVAL can ONLY work if SEEK or PURSUE is active
		if ( chkArrival == 1 ) then
			if ( chkSeek == 1 or chkPursue == 1 ) then
				aiArrival ( )
			end
		end

		-- OBSTACLE AVOIDANCE can ONLY work if at least one of WANDER, EVADE, FLEE, SEEK, PURSUE or FOLLOW is active
		if ( chkObstacle == 1 ) then
			if ( chkWander == 1 or chkEvade == 1 or chkFlee == 1 or chkSeek == 1 or chkPursue == 1 or chkFollow == 1 ) then
				aiObstacleAvoid ( )
			end
		end

	rayID = physics.createRay ( )					-- or does this need to be in EVALUATORS.LUA??
end

function onUpdate ( )
	--	myLogic:DT_Update ( dt )

	if ( ai_on ) then
		aiUpdate ( )
	end
end

function decisionTree ( objid )
	local tree = dtNew ( )
	local isWithinDistanceBranch = dbNew ( )
	local isVisibleBranch = dbNew ( )

	isWithinDistanceBranch:DB_AddChild ( myActions.ACT_WanderAction ( objid ) )
	isWithinDistanceBranch:DB_AddChild ( isVisibleBranch )
	isWithinDistanceBranch:DB_SetEvaluator ( function ( )
			if Evaluators_IsWithinDistance ( objid ) then
				return 2
			else
				return 1
			end
		end
	)

	isVisibleBranch:DB_AddChild ( myActions.ACT_WanderAction ( objid ) )
	isVisibleBranch:DB_AddChild ( myActions.ACT_EvadeAction ( objid ) )
	isVisibleBranch:DB_SetEvaluator ( function ( )
			if Evaluators_IsVisible ( objid ) then
				return 2
			else
				return 1
			end
		end
	)

	tree:DT_SetBranch ( isWithinDistanceBranch )

	return tree
end

--[[
*****************************************
**** THIS IS THE OLD CODE THAT WORKS ****
*****************************************

sky.include "ai_steer.lua"
aiOn = true

function onInit ( objID )
	if ( aiOn ) then
		ai_maxVelocity = newType.vec3 ( 10.0, 0.0, 10.0 )
		ai_maxForce = 12.5
		ai_mass = 100.0
		ai_runFactor = 1.25

		ai_fleeObj = entity.getIDFromTag ( "mZirax" )
		ai_fleePanicDistance = 10.0
		ai_fleeRelaxDistance = 30.0
		ai_fleeWeight = 0.9
		ai_evadeObj = entity.getIDFromTag ( "fZirax" )
		ai_evadePanicDistance = 10.0
		ai_evadeRelaxDistance = 30.0
		ai_evadeWeight = 0.8
		ai_wanderRadius = 25.0
		ai_wanderFlag = 2
		ai_wanderAOE = 30.0
		ai_wanderWeight = 0.5
		ai_obstacleAvoidFeelerLength = 10.0
		ai_obstacleAvoidWeight = 1.0

		aiInit ( objID )
		aiWander ( )
		aiObstacleAvoid ( )
		aiFlee ( ai_fleeObj, ai_fleePanicDistance, ai_fleeRelaxDistance, ai_fleeWeight )
		aiEvade ( ai_evadeObj, ai_evadePanicDistance, ai_evadeRelaxDistance, ai_evadeWeight )
	end
end

function onUpdate ( dt )
	if ( aiOn ) then
		aiUpdate ( )
	end
end
]]

