-- ****************************************
-- **      AI STEERING BEHAVIOURS        **
-- **                                    **
-- ** Copyright (c) 2015 SpinalSoft (AU) **
-- ****************************************
AI_NONE = false
AI_SEEK = false
AI_FLEE = false
AI_FLEE_ACTIVATE = false
AI_ARRIVAL = false
AI_ARRIVAL_ACTIVATE = false
AI_WANDER = false
AI_PURSUE = false
AI_EVADE = false
AI_EVADE_ACTIVATE = false
AI_FOLLOW = false
AI_OBSTACLE_AVOID = false

ai_seekObj = -1
ai_seekForce = newType.vec3 ( 0.0, 0.0, 0.0 )
ai_seekRadius = 0.0
ai_seekWeight = 1.0

ai_fleeObj = -1
ai_fleeTarget = -1
ai_fleeForce = newType.vec3 ( 0.0, 0.0, 0.0 )
ai_fleeWeight = 0.0
ai_fleePanicDistance = 0.0
ai_fleeRelaxDistance = 0.0

ai_pursueObj = -1
ai_pursueForce = newType.vec3 ( 0.0, 0.0, 0.0 )
ai_pursueRadius = 0.0
ai_pursueWeight = 1.0

ai_evadeObj = -1
ai_evadeForce = newType.vec3 ( 0.0, 0.0, 0.0 )
ai_evadeWeight = 0.0
ai_evadePanicDistance = 0.0
ai_evadeRelaxDistance = 0.0

ai_arrivalObj = -1
ai_arrivalForce = newType.vec3 ( 0.0, 0.0, 0.0 )
ai_arrivalDistance = 0.0
ai_arrivalStop = 0.0
ai_arrivalDone = false

ai_wanderForce = newType.vec3 ( 0.0, 0.0, 0.0 )
ai_wanderTarget = newType.vec3 ( 0.0, 0.0, 0.0 )
ai_wanderInitialPosition = newType.vec3 ( 0.0, 0.0, 0.0 )
ai_wanderWeight = 1.0
ai_wanderRadius = 0.0
ai_wanderAOE = 0.0
ai_wanderFlag = 0
ai_boolWander = false
ai_wanderEdge = 0

ai_followObj = -1
ai_followForce = newType.vec3 ( 0.0, 0.0, 0.0 )
ai_followArriveRadius = 0.0
ai_followBehindDistance	= 0.0
ai_followSeparationRadius = 0.0
ai_followMaxSeparation = 0.0
ai_followSightRadius = 0.0
ai_followWeight = 1.0

ai_obstacleAvoidForce = newType.vec3 ( 0.0, 0.0, 0.0 )
ai_obstacleAvoidDirection = newType.vec3 ( 0.0, 0.0, 0.0 )
ai_obstacleAvoidWeight = 1.0
ai_obstacleAvoidDone = false
ai_obstacleAvoidFeeler = 10.0
ai_obstacleAvoidNearestObstacle = newType.vec3 ( 0.0, 0.0, 0.0 )

ai_obj = -1
ai_mass = 0.0
ai_steerForce = newType.vec3 ( 0.0, 0.0, 0.0 )
ai_maxVelocity = newType.vec3 ( 0.0, 0.0, 0.0 )
ai_maxForce = 0.0
ai_runFactor = 0.0
ai_rotationProgress = 0.0
ai_rotationFactor = 0.01

ai_rayIDC = 0
ai_rayIDL = 0
ai_rayIDR = 0

function aiTurnOn ( ai_type )
	if ( ai_type == "seek" ) then
		AI_SEEK = true
	elseif ( ai_type == "flee" ) then
		AI_FLEE = true
	elseif ( ai_type == "pursue" ) then
		AI_PURSUE = true
	elseif ( ai_type == "evade" ) then
		AI_EVADE = true
	elseif ( ai_type == "arrival" ) then
		AI_ARRIVAL = true
	elseif ( ai_type == "wander" ) then
		AI_WANDER = true
	elseif ( ai_type == "follow" ) then
		AI_FOLLOW = true
	elseif ( ai_type == "obstacleavoid" ) then
		AI_OBSTACLE_AVOID = true
	elseif ( ai_type == "fleeactivate" ) then
		AI_FLEE_ACTIVATE = true
	elseif ( ai_type == "evadeactivate" ) then
		AI_EVADE_ACTIVATE = true
	elseif ( ai_type == "arrivalactivate" ) then
		AI_ARRIVAL_ACTIVATE = true
	end

	AI_NONE = false
end

function aiTurnOff ( ai_type )
	if ( ai_type == "seek" ) then
		if ( AI_SEEK ) then
			AI_SEEK = false
		end

		ai_seekForce = newType.vec3 ( 0.0, 0.0, 0.0 )
	elseif ( ai_type == "flee" ) then
		if ( AI_FLEE ) then
			AI_FLEE = false
		end

		ai_fleeForce = newType.vec3 ( 0.0, 0.0, 0.0 )
	elseif ( ai_type == "pursue" ) then
		if ( AI_PURSUE ) then
			AI_PURSUE = false
		end

		ai_pursueForce = newType.vec3 ( 0.0, 0.0, 0.0 )
	elseif ( ai_type == "evade" ) then
		if ( AI_EVADE ) then
			AI_EVADE = false
		end

		ai_evadeForce = newType.vec3 ( 0.0, 0.0, 0.0 )
	elseif ( ai_type == "arrival" ) then
		if ( AI_ARRIVAL ) then
			AI_ARRIVAL = false
		end

		ai_arrivalForce = newType.vec3 ( 0.0, 0.0, 0.0 )
	elseif ( ai_type == "wander" ) then
		if ( AI_WANDER ) then
			AI_WANDER = false
			ai_wanderOn = false
		end

		ai_wanderForce = newType.vec3 ( 0.0, 0.0, 0.0 )
	elseif ( ai_type == "follow" ) then
		if ( AI_FOLLOW ) then
			AI_FOLLOW = false
		end
		
		ai_followForce = newType.vec3 ( 0.0, 0.0, 0.0 )
	elseif ( ai_type == "obstacleavoid" ) then
		if ( AI_OBSTACLE_AVOID ) then
			AI_OBSTACLE_AVOID = false
		end

		ai_obstacleAvoidForce = newType.vec3 ( 0.0, 0.0, 0.0 )
	elseif ( ai_type == "fleeactivate" ) then
		if ( AI_FLEE_ACTIVATE ) then
			AI_FLEE_ACTIVATE = false
		end
	elseif ( ai_type == "evadeactivate" ) then
		if ( AI_EVADE_ACTIVATE ) then
			AI_EVADE_ACTIVATE = false
		end
	elseif ( ai_type == "arrivalactivate" ) then
		if ( AI_ARRIVAL_ACTIVATE ) then
			AI_ARRIVAL_ACTIVATE = false
		end
	end

	if ( AI_SEEK or AI_PURSUE or AI_FLEE or AI_FLEE_ACTIVATE or AI_ARRIVAL or AI_ARRIVAL_ACTIVATE or AI_EVADE or AI_WANDER or AI_EVADE_ACTIVATE or AI_OBSTACLE_AVOID ) then
		AI_NONE = false
	else
		AI_NONE = true
	end
end

function aiIsConflict ( )
	local iCount = 0

	if ( AI_SEEK ) then
		iCount = iCount + 1
	end

	if ( AI_FLEE ) then
		iCount = iCount + 1
	end

	if ( AI_PURSUE ) then
		iCount = iCount + 1
	end

	if ( AI_EVADE ) then
		iCount = iCount + 1
	end

	if ( AI_WANDER ) then
		iCount = iCount + 1
	end

	if ( AI_FOLLOW ) then
		iCount = iCount + 1
	end

	if ( AI_OBSTACLE_AVOID ) then
		iCount = iCount + 1
	end

	if ( iCount > 1 ) then
		return true
	else
		return false
	end
end

function aiCalculatePrioritised ( )
	local tmpForce = newType.vec3 ( 0.0, 0.0, 0.0 )

	ai_conflict = aiIsConflict ( )

	if ( AI_SEEK ) then
		tmpForce = aiDoSeek ( )

		if ( ai_conflict ) then
			tmpForce.x = tmpForce.x * ai_seekWeight
			tmpForce.y = tmpForce.y * ai_seekWeight
			tmpForce.z = tmpForce.z * ai_seekWeight
		end

		ai_seekForce.x = tmpForce.x
		ai_seekForce.y = tmpForce.y
		ai_seekForce.z = tmpForce.z
	end

	if ( AI_FLEE_ACTIVATE ) then
		aiFleeActivate ( )
	end

	if ( AI_FLEE ) then
		ai_fleeForce = newType.vec3 ( 0.0, 0.0, 0.0 )

		if ( ai_fleeActivateDone ) then
			tmpForce = aiDoFlee ( )

			if ( ai_conflict ) then
				tmpForce.x = tmpForce.x * ai_fleeWeight
				tmpForce.y = tmpForce.y * ai_fleeWeight
				tmpForce.z = tmpForce.z * ai_fleeWeight
			end

			ai_fleeForce.x = ai_fleeForce.x + tmpForce.x
			ai_fleeForce.y = ai_fleeForce.y + tmpForce.y
			ai_fleeForce.z = ai_fleeForce.z + tmpForce.z
		end
	end

	if ( AI_PURSUE ) then
		tmpForce = aiDoPursue ( )

		if ( ai_conflict ) then
			tmpForce.x = tmpForce.x * ai_pursueWeight
			tmpForce.y = tmpForce.y * ai_pursueWeight
			tmpForce.z = tmpForce.z * ai_pursueWeight
		end

		ai_pursueForce.x = tmpForce.x
		ai_pursueForce.y = tmpForce.y
		ai_pursueForce.z = tmpForce.z
	end

	if ( AI_EVADE_ACTIVATE ) then
		aiEvadeActivate ( )
	end

	if ( AI_EVADE ) then
		ai_evadeForce = newType.vec3 ( 0.0, 0.0, 0.0 )

		if ( ai_evadeActivateDone ) then
			tmpForce = aiDoEvade ( )

			if ( ai_conflict ) then
				tmpForce.x = tmpForce.x * ai_evadeWeight
				tmpForce.y = tmpForce.y * ai_evadeWeight
				tmpForce.z = tmpForce.z * ai_evadeWeight
			end

			ai_evadeForce.x = ai_evadeForce.x + tmpForce.x
			ai_evadeForce.y = ai_evadeForce.y + tmpForce.y
			ai_evadeForce.z = ai_evadeForce.z + tmpForce.z
		end
	end

	if ( AI_ARRIVAL_ACTIVATE ) then
		aiArrivalActivate ( )
	end

	if ( AI_ARRIVAL ) then
		tmpForce = aiDoArrival ( )

		ai_arrivalForce.x = tmpForce.x
		ai_arrivalForce.y = tmpForce.y
		ai_arrivalForce.z = tmpForce.z
	end

	if ( AI_WANDER ) then
		tmpForce = aiDoWander ( )

		if ( ai_conflict ) then
			tmpForce.x = tmpForce.x * ai_wanderWeight
			tmpForce.y = tmpForce.y * ai_wanderWeight
			tmpForce.z = tmpForce.z * ai_wanderWeight
		end

		ai_wanderForce.x = tmpForce.x
		ai_wanderForce.y = tmpForce.y
		ai_wanderForce.z = tmpForce.z
	end

	if ( AI_FOLLOW ) then
		tmpForce = aiDoFollow ( )

		if ( ai_conflict ) then
			tmpForce.x = tmpForce.x * ai_followWeight
			tmpForce.y = tmpForce.y * ai_followWeight
			tmpForce.z = tmpForce.z * ai_followWeight
		end

		ai_followForce.x = tmpForce.x
		ai_followForce.y = tmpForce.y
		ai_followForce.z = tmpForce.z
	end

	if ( AI_OBSTACLE_AVOID ) then
		tmpForce = aiDoObstacleAvoid ( )

		if ( ai_conflict ) then
			tmpForce.x = tmpForce.x * ai_obstacleAvoidWeight
			tmpForce.y = tmpForce.y * ai_obstacleAvoidWeight
			tmpForce.z = tmpForce.z * ai_obstacleAvoidWeight
		end

		ai_obstacleAvoidForce.x = tmpForce.x
		ai_obstacleAvoidForce.y = tmpForce.y
		ai_obstacleAvoidForce.z = tmpForce.z
	end

	ai_steerForce = newType.vec3 ( 0.0, 0.0, 0.0 )

	if ( AI_SEEK ) then
		ai_steerForce.x = ai_steerForce.x + ai_seekForce.x 
		ai_steerForce.y = ai_steerForce.y + ai_seekForce.y 
		ai_steerForce.z = ai_steerForce.z + ai_seekForce.z 
	end

	if ( AI_FLEE ) then
		ai_steerForce.x = ai_steerForce.x + ai_fleeForce.x 
		ai_steerForce.y = ai_steerForce.y + ai_fleeForce.y 
		ai_steerForce.z = ai_steerForce.z + ai_fleeForce.z 
	end

	if ( AI_PURSUE ) then
		ai_steerForce.x = ai_steerForce.x + ai_pursueForce.x 
		ai_steerForce.y = ai_steerForce.y + ai_pursueForce.y 
		ai_steerForce.z = ai_steerForce.z + ai_pursueForce.z 
	end

	if ( AI_EVADE ) then
		ai_steerForce.x = ai_steerForce.x + ai_evadeForce.x 
		ai_steerForce.y = ai_steerForce.y + ai_evadeForce.y 
		ai_steerForce.z = ai_steerForce.z + ai_evadeForce.z 
	end

	if ( AI_WANDER ) then
		ai_steerForce.x = ai_steerForce.x + ai_wanderForce.x 
		ai_steerForce.y = ai_steerForce.y + ai_wanderForce.y 
		ai_steerForce.z = ai_steerForce.z + ai_wanderForce.z 
	end

	if ( AI_FOLLOW ) then
		ai_steerForce.x = ai_steerForce.x + ai_followForce.x 
		ai_steerForce.y = ai_steerForce.y + ai_followForce.y 
		ai_steerForce.z = ai_steerForce.z + ai_followForce.z 
	end

	if ( AI_OBSTACLE_AVOID ) then
		ai_steerForce.x = ai_steerForce.x + ai_obstacleAvoidForce.x 
		ai_steerForce.y = ai_steerForce.y + ai_obstacleAvoidForce.y 
		ai_steerForce.z = ai_steerForce.z + ai_obstacleAvoidForce.z
	end

	if ( AI_ARRIVAL ) then
		ai_steerForce.x = ai_steerForce.x + ai_arrivalForce.x
		ai_steerForce.y = ai_steerForce.y + ai_arrivalForce.y
		ai_steerForce.z = ai_steerForce.z + ai_arrivalForce.z
	end

	if ( AI_FLEE or AI_EVADE ) then
sky.lprint ( "Length of steerForce = " .. aiLength ( ai_steerForce ) )
sky.lprint ( "maxForce = " .. ai_maxForce )
sky.lprint ( "runFactor = " .. ai_runFactor )

		if ( aiLength ( ai_steerForce ) > ( ai_maxForce * ai_runFactor ) ) then
			ai_steerForce = aiNormalise ( ai_steerForce )
			ai_steerForce.x = ai_steerForce.x * ai_maxVelocity.x * ai_runFactor
			ai_steerForce.y = ai_steerForce.y * ai_maxVelocity.y * ai_runFactor
			ai_steerForce.z = ai_steerForce.z * ai_maxVelocity.z * ai_runFactor
		end
	else
		if ( aiLength ( ai_steerForce ) > ai_maxForce ) then
			ai_steerForce = aiNormalise ( ai_steerForce )
			ai_steerForce.x = ai_steerForce.x * ai_maxVelocity.x
			ai_steerForce.y = ai_steerForce.y * ai_maxVelocity.y
			ai_steerForce.z = ai_steerForce.z * ai_maxVelocity.z
		end
	end

	return ai_steerForce
end

function aiSeek ( )
	aiTurnOn ( "seek" )
end

function aiDoSeek ( )
	if ( ai_seekObj ~= -1 ) then
		local tmpSeekDir = newType.vec3 ( entity.getDirection ( ai_obj, ai_seekObj ) )
		local tmpTgtDist = entity.getDistance ( ai_seekObj, ai_obj )
		tmpSeekDir = aiNormalise ( tmpSeekDir )

		if ( tmpTgtDist <= ai_seekRadius ) then
			ai_steerForce = newType.vec3 ( 0.0, 0.0, 0.0 )
			ai_seekForce = newType.vec3 ( 0.0, 0.0, 0.0 )
			aiTurnOff ( "seek" )
			return ai_SteerForce
		end

		local tmpRet = newType.vec3 ( 0.0, 0.0, 0.0 )

		tmpRet.x = tmpSeekDir.x * ai_maxVelocity.x
		tmpRet.y = tmpSeekDir.y * ai_maxVelocity.y
		tmpRet.z = tmpSeekDir.z * ai_maxVelocity.z

		return tmpRet
	else
		sky.lprint ( "[AI ERROR] No SEEK Object specified. The SEEK Behaviour will be turned OFF." )
		aiTurnOff ( "seek" )
		return newType.vec3 ( 0.0, 0.0, 0.0 )
	end
end

function aiFlee ( )
	ai_fleeDone = false
	ai_fleeActivateDone = false

	aiTurnOn ( "fleeactivate" )
end

function aiDoFlee ( )
	if ( ai_fleeObj ~= -1 ) then
		if ( ai_wanderOn ) then
			ai_wanderOn = false
			AI_WANDER = false
			ai_wanderEdge = 0
			ai_rotationFactor = 0.01
		end

		local tmpFleeDir = newType.vec3 ( entity.getDirection ( ai_fleeObj, ai_obj ) )
		local tmpDist = entity.getDistance ( ai_obj, ai_fleeObj )

		tmpFleeDir = aiNormalise ( tmpFleeDir )

		if ( tmpDist >= ai_fleeRelaxDistance ) then
			ai_steerForce = newType.vec3 ( 0.0, 0.0, 0.0 )
			ai_fleeDone = true
			ai_fleeActivateDone = false

			if ( ai_fleeDone ) then
				aiTurnOff ( "flee" )
				aiTurnOn ( "fleeactivate" )

				if ( ai_wanderOn ) then
					aiWander ( )
				end
			end

			return newType.vec3 ( 0.0, 0.0, 0.0 )
		else
			ai_fleeDone = false

			local tmpRet = newType.vec3 ( 0.0, 0.0, 0.0 )

			tmpRet.x = tmpFleeDir.x * ai_maxVelocity.x * ai_runFactor
			tmpRet.y = tmpFleeDir.y * ai_maxVelocity.y * ai_runFactor
			tmpRet.z = tmpFleeDir.z * ai_maxVelocity.z * ai_runFactor

			return tmpRet
		end
	else
		sky.lprint ( "[AI ERROR] No FLEE Object specified. The FLEE Behaviour will be turned OFF." )
		aiTurnOff ( "flee" )
		return newType.vec3 ( 0.0, 0.0, 0.0 )
	end
end

function aiFleeActivate ( )
	local tmpDist = entity.getDistance ( ai_obj, ai_fleeObj )

	ai_fleeActivateDone = false

	if ( tmpDist <= ai_fleePanicDistance ) then
		aiTurnOff ( "fleeactivate" )
		aiTurnOn ( "flee" )
		ai_fleeActivateDone = true
		ai_fleeDone = false
	end
end

function aiPursue ( )
	aiTurnOn ( "pursue" )
end

function aiDoPursue ( )
	if ( ai_pursueObj ~= -1 ) then
		local tmpPos = newType.vec3 ( entity.getPosition ( ai_obj ) )
		local tmpDist = entity.getDistance ( ai_obj, ai_pursueObj )
		local tmpPurPos = newType.vec3 ( entity.getPosition ( ai_pursueObj ) )
		local tmpFutDist = tmpDist / ai_maxForce
		local tmpFutPos = newType.vec3 ( 0.0, 0.0, 0.0 )
		local bodyID = physics.getBodyID ( ai_pursueObj )
		local tmpPurVel = newType.vec3 ( physics.getVelocity ( bodyID ) )

		tmpFutPos.x = tmpPurPos.x + ( tmpPurVel.x * tmpFutDist )
		tmpFutPos.y = tmpPurPos.y + ( tmpPurVel.y * tmpFutDist )
		tmpFutPos.z = tmpPurPos.z + ( tmpPurVel.z * tmpFutDist )

		local tmpPurDir = newType.vec3 ( entity.subtractPositions_float3 ( tmpFutPos.x, tmpFutPos.y, tmpFutPos.z, tmpPos.x, tmpPos.y, tmpPos.z ) )
		tmpPurDir = aiNormalise ( tmpPurDir )

		if ( tmpDist <= ai_pursueRadius ) then
			ai_steerForce = newType.vec3 ( 0.0, 0.0, 0.0 )
			ai_pursueForce = newType.vec3 ( 0.0, 0.0, 0.0 )
			aiTurnOff ( "pursue" )

			return ai_steerForce
		end

		local tmpRet = newType.vec3 ( 0.0, 0.0, 0.0 )

		tmpRet.x = tmpPurDir.x * ai_maxVelocity.x
		tmpRet.y = tmpPurDir.y * ai_maxVelocity.y
		tmpRet.z = tmpPurDir.z * ai_maxVelocity.z

		return tmpRet
	else
		return newType.vec3 ( 0.0, 0.0, 0.0 )
	end
end

function aiEvade ( evadeObj, panicDistance, relaxDistance, evadeWeight )
	ai_evadeDone = true
	ai_evadeActivateDone = false

	aiTurnOn ( "evadeactivate" )
end

function aiDoEvade ( )
	if ( ai_evadeObj ~= -1 ) then
		if ( ai_wanderOn ) then
			ai_wanderOn = false
			AI_WANDER = false
			ai_wanderEdge = 0
			ai_rotationFactor = 0.01
		end

		local tmpDist = entity.getDistance ( ai_obj, ai_evadeObj )
		local tmpEvadePos = newType.vec3 ( entity.getPosition ( ai_evadeObj ) )
		local tmpPos = newType.vec3 ( entity.getPosition ( ai_obj ) )
		local tmpRet = newType.vec3 ( 0.0, 0.0, 0.0 )
		local tmpFutDist = tmpDist / ai_maxForce
		local tmpFutPos = newType.vec3 ( 0.0, 0.0, 0.0 )
		local bodyID = physics.getBodyID ( ai_evadeObj )
		local tmpEvadeVel = newType.vec3 ( physics.getVelocity ( bodyID ) )

		tmpFutPos.x = tmpEvadePos.x + ( tmpEvadeVel.x * tmpFutDist )
		tmpFutPos.y = tmpEvadePos.y + ( tmpEvadeVel.y * tmpFutDist )
		tmpFutPos.z = tmpEvadePos.z + ( tmpEvadeVel.z * tmpFutDist )

		tmpEvadeDir = newType.vec3 ( entity.subtractPositions_float3 ( tmpFutPos.y, tmpFutPos.z, tmpPos.x, tmpPos.y, tmpPos.z, tmpFutPos.x ) )

		tmpDist = aiLength ( tmpEvadeDir )
		tmpEvadeDir = aiNormalise ( tmpEvadeDir )

		if ( tmpDist >= ai_evadeRelaxDistance ) then
			if ( AI_EVADE ) then
				ai_steerForce = newType.vec3 ( 0.0, 0.0, 0.0 )
			end

			ai_evadeDone = true
			ai_evadeActivateDone = false

			if ( ai_evadeDone ) then
				aiTurnOff ( "evade" )
				aiTurnOn ( "evadeactivate" )

				if ( ai_wanderOn ) then
					aiWander ( )
				end
			end

			return newType.vec3 ( 0.0, 0.0, 0.0 )
		else
			ai_evadeDone = false

			tmpRet.x = tmpEvadeDir.x * ai_maxVelocity.x * ai_runFactor
			tmpRet.y = tmpEvadeDir.y * ai_maxVelocity.y * ai_runFactor
			tmpRet.z = tmpEvadeDir.z * ai_maxVelocity.z * ai_runFactor

			return tmpRet
		end
	else
		return newType.vec3 ( 0.0, 0.0, 0.0 )
	end
end

function aiEvadeActivate ( )
	local tmpDist = entity.getDistance ( ai_obj, ai_evadeObj )

	ai_evadeActivateDone = false

	if ( tmpDist < ai_evadePanicDistance ) then
		aiTurnOff ( "evadeactivate" )
		aiTurnOn ( "evade" )
		ai_evadeActivateDone = true
		ai_evadeDone = false
	end
end

function aiArrival ( )
	if ( ai_pursueObj ~= -1 ) then
		ai_arrivalObj = ai_pursueObj
		aiTurnOn ( "arrivalactivate" )
	elseif ( ai_seekObj ~= -1 ) then
		ai_arrivalObj = ai_seekObj
		aiTurnOn ( "arrivalactivate" )
	else
		sky.lprint ( "[AI ERROR] A SEEK or PURSUE behaviour is required for the ARRIVAL behaviour" )
	end
end

function aiDoArrival ( )
	local tmpTgtDir = newType.vec3 ( entity.getDirection ( ai_obj, ai_arrivalObj ) )
	local tmpDist = entity.getDistance ( ai_arrivalObj, ai_obj )

	tmpArrDir = aiNormalise ( tmpTgtDir )

	if ( tmpDist <= ai_arrivalStop ) then
		ai_steerForce = newType.vec3 ( 0.0, 0.0, 0.0 )
		ai_arrivalForce = newType.vec3 ( 0.0, 0.0, 0.0 )
		aiTurnOff ( "arrival" )
		ai_arrivalDone = true

		return newType.vec3 ( 0.0, 0.0, 0.0 )
	else
		ai_arrivalDone = false
	end

	tmpTgtDir = aiNormalise ( tmpTgtDir )

	tmpTgtDir.x = tmpTgtDir.x * ai_maxVelocity.x
	tmpTgtDir.y = tmpTgtDir.y * ai_maxVelocity.y
	tmpTgtDir.z = tmpTgtDir.z * ai_maxVelocity.z

	if ( tmpDist <= ai_arrivalDistance ) then
		tmpTgtDir.x = tmpTgtDir.x * tmpDist / ai_arrivalDistance
		tmpTgtDir.y = tmpTgtDir.y * tmpDist / ai_arrivalDistance
		tmpTgtDir.z = tmpTgtDir.z * tmpDist / ai_arrivalDistance
	end

	if ( ai_seekObj ~= -1 ) then
		return tmpTgtDir
	elseif ( ai_pursueObj ~= -1 ) then
		return tmpTgtDir
	end

	sky.lprint ( "[AI ERROR] A SEEK or PURSUE behaviour is required for the ARRIVAL behaviour" )
	return newType.vec3 ( 0.0, 0.0, 0.0 )
end

function aiArrivalActivate ( )
	local tmpDist = entity.getDistance ( ai_obj, ai_arrivalObj )

	if ( tmpDist < ai_arrivalDistance and aiLength ( ai_steerForce ) > 0 ) then
		aiTurnOff ( "arrivalactivate" )
		aiTurnOn ( "arrival" )

		if ( AI_SEEK ) then
			aiTurnOff ( "seek" )
		end

		if ( AI_PURSUE ) then
			aiTurnOff ( "pursue" )
		end
	end
end

function aiWander ( )
	ai_wanderInitialPosition = newType.vec3 ( entity.getPosition ( ai_obj ) )
	ai_wanderOn = true

	local theta = math.random ( ) * 2 * 3.14159
	local si = math.random ( ) * 3.14159
	local cosTheta = math.cos ( theta )
	local sinTheta = math.sin ( theta )
	local cosSi = math.cos ( si )
	local sinSi = math.sin ( si )

	if ( ai_wanderFlag == 0 ) then
		ai_wanderTarget.x = ai_wanderRadius * cosTheta
		ai_wanderTarget.y = ai_wanderRadius * sinTheta
		ai_wanderTarget.z = 0.0
	elseif ( ai_wanderFlag == 1 ) then
		ai_wanderTarget.x = 0.0
		ai_wanderTarget.y = ai_wanderRadius * cosTheta
		ai_wanderTarget.z = ai_wanderRadius * sinTheta
	elseif ( ai_wanderFlag == 2 ) then
		ai_wanderTarget.x = ai_wanderRadius * cosTheta
		ai_wanderTarget.y = 0.0
		ai_wanderTarget.z = ai_wanderRadius * sinTheta
	elseif ( ai_wanderFlag == 3 ) then
		ai_wanderTarget.x = ai_wanderRadius * sinTheta * cosSi
		ai_wanderTarget.y = ai_wanderRadius * sinTheta * sinSi
		ai_wanderTarget.z = ai_wanderRadius * cosTheta
	else
		ai_wanderTarget.x = ai_wanderRadius * cosTheta
		ai_wanderTarget.y = ai_wanderRadius * sinTheta
		ai_wanderTarget.z = 0.0
	end

	aiTurnOn ( "wander" )
end

function aiDoWander ( )
	local tmpPos = newType.vec3 ( entity.getPosition ( ai_obj ) )
	local tmpTimeSlice1 = aiRandomClamped ( ) * 1.5
	local tmpTimeSlice2 = aiRandomClamped ( ) * 1.5
	local tmpTimeSlice3 = aiRandomClamped ( ) * 1.5

	if ( ai_wanderFlag == 0 ) then
		ai_wanderTarget.x = ai_wanderTarget.x + tmpTimeSlice1
		ai_wanderTarget.y = ai_wanderTarget.y + tmpTimeSlice2
		ai_wanderTarget.z = 0.0
	elseif ( ai_wanderFlag == 1 ) then
		ai_wanderTarget.x = 0.0
		ai_wanderTarget.y = ai_wanderTarget.y + tmpTimeSlice1
		ai_wanderTarget.z = ai_wanderTarget.z + tmpTimeSlice2
	elseif ( ai_wanderFlag == 2 ) then
		ai_wanderTarget.x = ai_wanderTarget.x + tmpTimeSlice1
		ai_wanderTarget.y = 0.0
		ai_wanderTarget.z = ai_wanderTarget.z + tmpTimeSlice2
	elseif ( ai_wanderFlag == 3 ) then
		ai_wanderTarget.x = ai_wanderTarget.x + tmpTimeSlice1
		ai_wanderTarget.y = ai_wanderTarget.y + tmpTimeSlice2
		ai_wanderTarget.z = ai_wanderTarget.z + tmpTimeSlice3
	else
		ai_wanderTarget.x = ai_wanderTarget.x + tmpTimeSlice1
		ai_wanderTarget.y = ai_wanderTarget.y + tmpTimeSlice2
		ai_wanderTarget.z = 0.0
	end

	ai_wanderTarget = aiNormalise ( ai_wanderTarget )

	ai_wanderTarget.x = ai_wanderTarget.x * ai_wanderRadius
	ai_wanderTarget.y = ai_wanderTarget.y * ai_wanderRadius
	ai_wanderTarget.z = ai_wanderTarget.z * ai_wanderRadius

	local tmpTgt = newType.vec3 ( entity.getForward ( ai_obj ) )
	tmpTgt = aiNormalise ( tmpTgt )

	tmpTgt.x = ai_wanderTarget.x + tmpTgt.x
	tmpTgt.y = ai_wanderTarget.y + tmpTgt.y
	tmpTgt.z = ai_wanderTarget.z + tmpTgt.z

	local tmpDesTgt = newType.vec3 ( 0.0, 0.0, 0.0 )

	tmpDesTgt.x = tmpPos.x + tmpTgt.x
	tmpDesTgt.y = tmpPos.y + tmpTgt.y
	tmpDesTgt.z = tmpPos.z + tmpTgt.z

	local tmpRet = newType.vec3 ( 0.0, 0.0, 0.0 )

	tmpRet = newType.vec3 ( entity.subtractPositions_float3 ( tmpDesTgt.x, tmpDesTgt.y, tmpDesTgt.z, tmpPos.x, tmpPos.y, tmpPos.z ) )
	tmpRet = aiNormalise ( tmpRet )

	tmpRet.x = tmpRet.x * ai_maxVelocity.x
	tmpRet.y = tmpRet.y * ai_maxVelocity.y
	tmpRet.z = tmpRet.z * ai_maxVelocity.z

	local tmpDir = newType.vec3 ( entity.subtractPositions_float3 ( ai_wanderInitialPosition.x, ai_wanderInitialPosition.y, ai_wanderInitialPosition.z, tmpPos.x, tmpPos.y, tmpPos.z ) )
	local tmpDist = aiLength ( tmpDir )
	tmpDir = aiNormalise ( tmpDir )

	if ( ai_wanderAOE > 0 and tmpDist > ai_wanderAOE ) then
		ai_wanderEdge = 100
	end

	if ( ai_wanderEdge > 1 ) then
		ai_wanderEdge = ai_wanderEdge - 1
		ai_rotationFactor = 0.1

		tmpRet.x = tmpDir.x * ai_maxVelocity.x
		tmpRet.y = tmpDir.y * ai_maxVelocity.y
		tmpRet.z = tmpDir.z * ai_maxVelocity.z
	elseif ( ai_wanderEdge == 1 ) then
		ai_wanderEdge = 0
		ai_rotationFactor = 0.01

		tmpRet.x = tmpDir.x * ai_maxVelocity.x
		tmpRet.y = tmpDir.y * ai_maxVelocity.y
		tmpRet.z = tmpDir.z * ai_maxVelocity.z

		aiWander ( )
	else
		ai_rotationFactor = 0.01
	end

	return tmpRet
end

function aiFollow ( )
	aiTurnOn ( "follow" )
end

function aiDoFollow ( )
	local bodyID = physics.getBodyID ( ai_followObj )
	local tmpPos = newType.vec3 ( entity.getPosition ( ai_obj ) )
	local tmpTgtDir = newType.vec3 ( 0.0, 0.0, 0.0 )
	local tmpTgtPos = newType.vec3 ( entity.getPosition ( ai_followObj ) )
	local tmpTgtVel = newType.vec3 ( physics.getVelocity ( bodyID ) )
	local tmpAheadPos = newType.vec3 ( 0.0, 0.0, 0.0 )
	local tmpBehindPos = newType.vec3 ( 0.0, 0.0, 0.0 )
	local tmpFollowForce = newType.vec3 ( 0.0, 0.0, 0.0 )
	local tmpEvadeDir = newType.vec3 ( 0.0, 0.0, 0.0 )
	local tmpDist = 0.0
	local tmpFutDist = 0.0
	local tmpFutPos = newType.vec3 ( 0.0, 0.0, 0.0 )
	local tmpArrDir = newType.vec3 ( 0.0, 0.0, 0.0 )
	local tmpDesVel = newType.vec3 ( 0.0, 0.0, 0.0 )
	local tmpSepForce = newType.vec3 ( 0.0, 0.0, 0.0 )

	tmpTgtVel = aiNormalise ( tmpTgtVel )

	tmpTgtVel.x = tmpTgtVel.x * -ai_followBehindDistance
	tmpTgtVel.y = tmpTgtVel.y * -ai_followBehindDistance
	tmpTgtVel.z = tmpTgtVel.z * -ai_followBehindDistance

	tmpAheadPos.x = tmpTgtPos.x + tmpTgtVel.x
	tmpAheadPos.y = tmpTgtPos.y + tmpTgtVel.y
	tmpAheadPos.z = tmpTgtPos.z + tmpTgtVel.z

	if ( aiIsInSight ( tmpAheadPos ) ) then
		tmpEvadeDir = newType.vec3 ( entity.subtractPositions_float3 ( tmpPos.x, tmpPos.y, tmpPos.z, tmpAheadPos.x, tmpAheadPos.y, tmpAheadPos.z ) )
		tmpDist = aiLength ( tmpEvadeDir )
		tmpFutDist = tmpDist / ai_maxForce

		tmpFutPos.x = tmpAheadPos.x + ( tmpTgtVel.x * tmpFutDist )
		tmpFutPos.y = tmpAheadPos.y + ( tmpTgtVel.y * tmpFutDist )
		tmpFutPos.z = tmpAheadPos.z + ( tmpTgtVel.z * tmpFutDist )

		tmpEvadeDir = newType.vec3 ( entity.subtractPositions_float3 ( tmpPos.x, tmpPos.y, tmpPos.z, tmpFutPos.x, tmpFutPos.y, tmpFutPos.z ) )

		tmpDist = aiLength ( tmpEvadeDir )
		tmpEvadeDir = aiNormalise ( tmpEvadeDir )

		tmpFollowForce.x = tmpEvadeDir.x * ai_maxVelocity.x
		tmpFollowForce.y = tmpEvadeDir.y * ai_maxVelocity.y
		tmpFollowForce.z = tmpEvadeDir.z * ai_maxVelocity.z
	end

	tmpTgtVel.x = tmpTgtVel.x * -1
	tmpTgtVel.y = tmpTgtVel.y * -1
	tmpTgtVel.z = tmpTgtVel.z * -1

	tmpBehindPos.x = tmpTgtPos.x + tmpTgtVel.x
	tmpBehindPos.y = tmpTgtPos.y + tmpTgtVel.y
	tmpBehindPos.z = tmpTgtPos.z + tmpTgtVel.z

	tmpTgtDir = newType.vec3 ( entity.subtractPositions_float3 ( tmpBehindPos.x, tmpBehindPos.y, tmpBehindPos.z, tmpPos.x, tmpPos.y, tmpPos.z ) )
	tmpDist = aiLength ( tmpTgtDir )
	tmpDesVel = aiNormalise ( tmpTgtDir )

	tmpDesVel.x = tmpDesVel.x * ai_maxVelocity.x
	tmpDesVel.y = tmpDesVel.y * ai_maxVelocity.y
	tmpDesVel.z = tmpDesVel.z * ai_maxVelocity.z

	if ( tmpDist <= ai_followArriveRadius ) then
		tmpDesVel.x = tmpDesVel.x * tmpDist / ai_followArriveRadius
		tmpDesVel.y = tmpDesVel.y * tmpDist / ai_followArriveRadius
		tmpDesVel.z = tmpDesVel.z * tmpDist / ai_followArriveRadius
	end

	tmpFollowForce.x = tmpFollowForce.x + tmpDesVel.x
	tmpFollowForce.y = tmpFollowForce.y + tmpDesVel.y
	tmpFollowForce.z = tmpFollowForce.z + tmpDesVel.z

	tmpSepForce = aiSeparation ( )

	tmpFollowForce.x = tmpFollowForce.x + tmpSepForce.x
	tmpFollowForce.y = tmpFollowForce.y + tmpSepForce.y
	tmpFollowForce.z = tmpFollowForce.z + tmpSepForce.z

	return tmpFollowForce
end

function aiSeparation ( )
	local tmpSepForce = newType.vec3 ( 0.0, 0.0, 0.0 )
	local tmpSepDist = entity.getDistance ( ai_followObj, ai_obj )
	local bSep = false

	if ( tmpSepDist <= ai_followSeparationRadius ) then
		tmpSepForce = newType.vec3 ( entity.subtractPositions_float3 ( ai_followObj, ai_obj ) )
		bSep = true
	end

	if ( bSep ) then
		tmpSepForce.x = tmpSepForce.x * -1
		tmpSepForce.y = tmpSepForce.y * -1
		tmpSepForce.z = tmpSepForce.z * -1
	end

	tmpSepForce = aiNormalise ( tmpSepForce )

	tmpSepForce.x = tmpSepForce.x * ai_followMaxSeparation
	tmpSepForce.y = tmpSepForce.y * ai_followMaxSeparation
	tmpSepForce.z = tmpSepForce.z * ai_followMaxSeparation

	return tmpSepForce
end

function aiIsInSight ( aheadPos )
	local tmpPos = newType.vec3 ( entity.getPosition ( ai_obj ) )
	local tmpDist = entity.getDistance ( ai_followObj, ai_obj )
	local tmpAheadDist = aiLength ( newType.vec3 ( entity.subtractPositions_float3 ( aheadPos.x, aheadPos.y, aheadPos.z, tmpPos.x, tmpPos.y, tmpPos.z ) ) )

	if ( tmpAheadDist <= ai_followSightRadius or tmpDist <= ai_followSightRadius ) then
		return true
	else
		return false
	end
end

function aiObstacleAvoid ( )
	aiTurnOn ( "obstacleavoid" )
	--physics.rayDebugLines ( ai_rayIDC, 1 )
	--physics.rayDebugLines ( ai_rayIDL, 1 )
	--physics.rayDebugLines ( ai_rayIDR, 1 )
end

function aiDoObstacleAvoid ( )
	aiObstacleAvoidObstacleDetection ( )
	local tmpAvoid = newType.vec3 ( 0.0, 0.0, 0.0 )

	if ( ai_obstacleAvoidNearestObstacle > -1 ) then
		local tmpOffset = newType.vec3 ( entity.getDirection ( ai_obstacleAvoidNearestObstacle, ai_obj ) )
		local tmpDir = newType.vec3 ( 0.0, 0.0, 0.0 )
		local tmpForward = 0.0
		local tmpProject = newType.vec3 ( 0.0, 0.0, 0.0 )
		local tmpPerp = newType.vec3 ( 0.0, 0.0, 0.0 )
		local tmpP = 0.0

		local tmpBSphere = entity.getBoundingRadius ( ai_obj )
		local tmpNPSphere = entity.getBoundingRadius ( ai_obstacleAvoidNearestObstacle )
		local tmpDist= aiLength ( tmpOffset ) - tmpBSphere - tmpNPSphere

		tmpDir = newType.vec3 ( entity.getForward ( ai_obj ) )
		tmpDir = aiNormalise ( tmpDir )
		tmpForward = vector3.dotProduct ( tmpOffset.x, tmpOffset.y, tmpOffset.z, tmpDir.x, tmpDir.y, tmpDir.z )

		tmpProject.x = tmpForward * tmpDir.x
		tmpProject.y = tmpForward * tmpDir.y
		tmpProject.z = tmpForward * tmpDir.z

		tmpPerp = newType.vec3 ( entity.subtractPositions_float3 ( tmpOffset.x, tmpOffset.y, tmpOffset.z, tmpProject.x, tmpProject.y, tmpProject.z ) )
		tmpP = aiLength ( tmpPerp )
		tmpPerp = aiNormalise ( tmpPerp )
		tmpAvoid = tmpPerp

		tmpAvoid.x = ( tmpAvoid.x * ai_maxForce * ai_maxVelocity.x ) / ( tmpP + 0.01 )
		tmpAvoid.y = ( tmpAvoid.y * ai_maxForce * ai_maxVelocity.y ) / ( tmpP + 0.01 )
		tmpAvoid.z = ( tmpAvoid.z * ai_maxForce * ai_maxVelocity.z ) / ( tmpP + 0.01 )

		return tmpAvoid
	else
		return tmpAvoid
	end
end

function aiObstacleAvoidObstacleDetection ( )
	local tmpPos = newType.vec3 ( entity.getPosition ( ai_obj ) )
	local tmpRot = newType.vec4 ( entity.getWorldOrientation ( ai_obj ) )
	local tmpHitID1, tmpHitID2, tmpHitID3 = -1, -1, -1
	local tmpHit = newType.vec3 ( 0.0, 0.0, 0.0 )
	local tmpDist = 0.0
	local tmpSmallDist = 0.0
	local tmpKeep = 0

	tmpRot = newType.vec4 ( quat.rotateOrientation ( 180, 0, 1, 0, tmpRot.w, tmpRot.x, tmpRot.y, tmpRot.z ) )
	tmpHitID1, tmpHit.x, tmpHit.y, tmpHit.z = physics.rayFromPoint ( ai_rayIDC, tmpPos.x, tmpPos.y + 1, tmpPos.z, tmpRot.w, tmpRot.x, tmpRot.y, tmpRot.z, ai_obstacleAvoidFeeler )

	if ( tmpHitID1 > -1 ) then
		tmpDist = vector3.squaredDistance ( tmpPos.x, tmpPos.y + 1, tmpPos.z, tmpHit.x, tmpHit.y, tmpHit.z )
		tmpSmallDist = tmpDist
		tmpKeep = 1
	end

	tmpRot = newType.vec4 ( quat.rotateOrientation ( 30, 0, 1, 0, tmpRot.w, tmpRot.x, tmpRot.y, tmpRot.z ) )
	tmpHitID2, tmpHit.x, tmpHit.y, tmpHit.z = physics.rayFromPoint ( ai_rayIDR, tmpPos.x, tmpPos.y + 1, tmpPos.z, tmpRot.w, tmpRot.x, tmpRot.y, tmpRot.z, ai_obstacleAvoidFeeler * 0.866 )

	if ( tmpHitID2 > -1 ) then
		tmpDist = vector3.squaredDistance ( tmpPos.x, tmpPos.y + 1, tmpPos.z, tmpHit.x, tmpHit.y, tmpHit.z )

		if ( tmpSmallDist > 0 ) then
			if ( tmpDist < tmpSmallDist ) then
				tmpSmallDist = tmpDist
				tmpKeep = 2
			end
		else
			tmpSmallDist = tmpDist
			tmpKeep = 2
		end
	end

	tmpRot = newType.vec4 ( quat.rotateOrientation ( -60, 0, 1, 0, tmpRot.w, tmpRot.x, tmpRot.y, tmpRot.z ) )
	tmpHitID3, tmpHit.x, tmpHit.y, tmpHit.z = physics.rayFromPoint ( ai_rayIDL, tmpPos.x, tmpPos.y + 1, tmpPos.z, tmpRot.w, tmpRot.x, tmpRot.y, tmpRot.z, ai_obstacleAvoidFeeler * 0.866 )

	if ( tmpHitID3 > -1 ) then
		tmpDist = vector3.squaredDistance ( tmpPos.x, tmpPos.y + 1, tmpPos.z, tmpHit.x, tmpHit.y, tmpHit.z )

		if ( tmpSmallDist > 0 ) then
			if ( tmpDist < tmpSmallDist ) then
				tmpKeep = 3
			end
		else
			tmpKeep = 3
		end
	end

	if ( tmpKeep == 1 ) then
		ai_obstacleAvoidNearestObstacle = tmpHitID1
	elseif ( tmpKeep == 2 ) then
		ai_obstacleAvoidNearestObstacle = tmpHitID2
	elseif ( tmpKeep == 3 ) then
		ai_obstacleAvoidNearestObstacle = tmpHitID3
	else
		ai_obstacleAvoidNearestObstacle = -1
	end
end

function aiNormalise ( inVec )
	local retVec = newType.vec3 ( 0.0, 0.0, 0.0 )

	retVec = newType.vec3 ( vector3.normalisedCopy ( inVec.x, inVec.y, inVec.z ) )

	return retVec
end

function aiLength ( inLenVec )
	local retLen = 0.0

	retLen = vector3.length ( inLenVec.x, inLenVec.y, inLenVec.z )

	return retLen
end

function aiRandomClamped ( )
	return ( math.random ( ) - math.random ( ) )
end

function aiTruncate ( inVec, inMax )
	local myVal = inMax / aiLength ( inVec )

	if ( myVal >= 1 ) then
		myVal = 1
	else
		inVec.x = inVec.x * myVal
		inVec.y = inVec.y * myVal
		inVec.z = inVec.z * myVal
	end

	return inVec
end

function aiUpdate ( )
	local tmpPos = newType.vec3 ( 0.0, 0.0, 0.0 )
	local tmpOldPos = newType.vec3 ( 0.0, 0.0, 0.0 )
	local tmpAccel = newType.vec3 ( 0.0, 0.0, 0.0 )
	local tmpDir = newType.vec3 ( 0.0, 0.0, 0.0 )

	if ( AI_NONE ) then
		ai_steerForce = newType.vec3 ( 0.0, 0.0, 0.0 )
		ai_seekForce = newType.vec3 ( 0.0, 0.0, 0.0 )
		ai_fleeForce = newType.vec3 ( 0.0, 0.0, 0.0 )
		ai_pursueForce = newType.vec3 ( 0.0, 0.0, 0.0 )
		ai_evadeForce = newType.vec3 ( 0.0, 0.0, 0.0 )
		ai_arrivalForce = newType.vec3 ( 0.0, 0.0, 0.0 )
		ai_wanderForce = newType.vec3 ( 0.0, 0.0, 0.0 )
		ai_followForce = newType.vec3 ( 0.0, 0.0, 0.0 )
	else
		tmpOldPos = newType.vec3 ( entity.getPosition ( ai_obj ) )

		ai_steerForce = aiCalculatePrioritised ( )

		tmpAccel.x = ai_steerForce.x / ai_mass
		tmpAccel.y = ai_steerForce.y / ai_mass
		tmpAccel.z = ai_steerForce.z / ai_mass
		tmpDir = aiNormalise ( ai_steerForce )
		tmpPos.x = tmpOldPos.x + tmpAccel.x
		tmpPos.y = tmpOldPos.y + tmpAccel.y
		tmpPos.z = tmpOldPos.z + tmpAccel.z

		entity.setPosition ( ai_obj, tmpPos.x, tmpPos.y, tmpPos.z )

		if ( aiLength ( ai_steerForce ) > 0 ) then
			tmpPos = newType.vec3 ( tmpOldPos.x + ( tmpDir.x * 5 ), tmpOldPos.y + ( tmpDir.y * 5 ), tmpOldPos.z + ( tmpDir.z * 5 ) ) 

			ai_rotationProgress = ai_rotationProgress + ai_rotationFactor

			if ( ai_rotationProgress >= 1 ) then 
				ai_rotationProgress = 0
			else
				entity.lookatPosition ( ai_obj, tmpPos.x, tmpPos.y, tmpPos.z, ai_rotationProgress, 0, 0, 1 )
			end 

--			entity.setYaw ( ai_obj, entity.getYaw ( ai_obj ) + 180 )
--			entity.setPitch ( ai_obj, entity.getPitch ( ai_obj ) * -1 )
--			entity.setRoll ( ai_obj, entity.getRoll ( ai_obj ) * -1 )
		end
	end
end

function aiInit ( objID )
	ai_obj = objID

	ai_rayIDC = physics.createRay ( )
	ai_rayIDL = physics.createRay ( )
	ai_rayIDR = physics.createRay ( )

	AI_NONE = true
end